/*
* Copyright (c) 2017-2024 Nils Kohl, Daniel Bauer, Fabian Böhm.
*
* This file is part of HyTeG
* (see https://i10git.cs.fau.de/hyteg/hyteg).
*
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program. If not, see <http://www.gnu.org/licenses/>.
*/

/*
* The entire file was generated with the HyTeG form generator.
*
* Avoid modifying this file. If buggy, consider fixing the generator itself.
*/

























#include "../P1ElementwiseMass.hpp"

#define FUNC_PREFIX  

namespace hyteg {

namespace operatorgeneration {

void P1ElementwiseMass::computeInverseDiagonalOperatorValues_macro_3D( real_t * RESTRICT  _data_invDiag_, real_t macro_vertex_coord_id_0comp0, real_t macro_vertex_coord_id_0comp1, real_t macro_vertex_coord_id_0comp2, real_t macro_vertex_coord_id_1comp0, real_t macro_vertex_coord_id_1comp1, real_t macro_vertex_coord_id_1comp2, real_t macro_vertex_coord_id_2comp0, real_t macro_vertex_coord_id_2comp1, real_t macro_vertex_coord_id_2comp2, real_t macro_vertex_coord_id_3comp0, real_t macro_vertex_coord_id_3comp1, real_t macro_vertex_coord_id_3comp2, int64_t micro_edges_per_macro_edge, real_t micro_edges_per_macro_edge_float ) const
{
    {
       const real_t _data_q_w [] = {0.050086823222829389, 0.046462929447761279, 0.05318232258357912, 0.016934591412496786};
   
       const real_t tmp_0_WHITE_UP = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t p_affine_0_0_WHITE_UP = macro_vertex_coord_id_0comp0;
       const real_t p_affine_0_1_WHITE_UP = macro_vertex_coord_id_0comp1;
       const real_t p_affine_0_2_WHITE_UP = macro_vertex_coord_id_0comp2;
       const real_t p_affine_1_0_WHITE_UP = macro_vertex_coord_id_0comp0 + tmp_0_WHITE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const real_t p_affine_1_1_WHITE_UP = macro_vertex_coord_id_0comp1 + tmp_0_WHITE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const real_t p_affine_1_2_WHITE_UP = macro_vertex_coord_id_0comp2 + tmp_0_WHITE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2);
       const real_t p_affine_2_0_WHITE_UP = macro_vertex_coord_id_0comp0 + tmp_0_WHITE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t p_affine_2_1_WHITE_UP = macro_vertex_coord_id_0comp1 + tmp_0_WHITE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t p_affine_2_2_WHITE_UP = macro_vertex_coord_id_0comp2 + tmp_0_WHITE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const real_t p_affine_3_0_WHITE_UP = macro_vertex_coord_id_0comp0 + tmp_0_WHITE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0);
       const real_t p_affine_3_1_WHITE_UP = macro_vertex_coord_id_0comp1 + tmp_0_WHITE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1);
       const real_t p_affine_3_2_WHITE_UP = macro_vertex_coord_id_0comp2 + tmp_0_WHITE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2);
       {
          /* CellType.WHITE_UP */
          const real_t _data_phi_psi_det_jac_aff_0_WHITE_UP [] = {0.20046443821120821*abs((p_affine_0_0_WHITE_UP - p_affine_1_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_2_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_3_2_WHITE_UP) - (p_affine_0_0_WHITE_UP - p_affine_1_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_3_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_2_2_WHITE_UP) - (p_affine_0_0_WHITE_UP - p_affine_2_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_1_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_3_2_WHITE_UP) + (p_affine_0_0_WHITE_UP - p_affine_2_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_3_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_1_2_WHITE_UP) + (p_affine_0_0_WHITE_UP - p_affine_3_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_1_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_2_2_WHITE_UP) - (p_affine_0_0_WHITE_UP - p_affine_3_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_2_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_1_2_WHITE_UP)), 0.080605154129423817*abs((p_affine_0_0_WHITE_UP - p_affine_1_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_2_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_3_2_WHITE_UP) - (p_affine_0_0_WHITE_UP - p_affine_1_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_3_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_2_2_WHITE_UP) - (p_affine_0_0_WHITE_UP - p_affine_2_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_1_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_3_2_WHITE_UP) + (p_affine_0_0_WHITE_UP - p_affine_2_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_3_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_1_2_WHITE_UP) + (p_affine_0_0_WHITE_UP - p_affine_3_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_1_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_2_2_WHITE_UP) - (p_affine_0_0_WHITE_UP - p_affine_3_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_2_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_1_2_WHITE_UP)), 0.16356320182856121*abs((p_affine_0_0_WHITE_UP - p_affine_1_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_2_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_3_2_WHITE_UP) - (p_affine_0_0_WHITE_UP - p_affine_1_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_3_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_2_2_WHITE_UP) - (p_affine_0_0_WHITE_UP - p_affine_2_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_1_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_3_2_WHITE_UP) + (p_affine_0_0_WHITE_UP - p_affine_2_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_3_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_1_2_WHITE_UP) + (p_affine_0_0_WHITE_UP - p_affine_3_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_1_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_2_2_WHITE_UP) - (p_affine_0_0_WHITE_UP - p_affine_3_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_2_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_1_2_WHITE_UP)), 0.0030997579321792282*abs((p_affine_0_0_WHITE_UP - p_affine_1_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_2_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_3_2_WHITE_UP) - (p_affine_0_0_WHITE_UP - p_affine_1_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_3_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_2_2_WHITE_UP) - (p_affine_0_0_WHITE_UP - p_affine_2_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_1_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_3_2_WHITE_UP) + (p_affine_0_0_WHITE_UP - p_affine_2_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_3_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_1_2_WHITE_UP) + (p_affine_0_0_WHITE_UP - p_affine_3_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_1_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_2_2_WHITE_UP) - (p_affine_0_0_WHITE_UP - p_affine_3_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_2_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_1_2_WHITE_UP)), 0.032410690545436126*abs((p_affine_0_0_WHITE_UP - p_affine_1_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_2_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_3_2_WHITE_UP) - (p_affine_0_0_WHITE_UP - p_affine_1_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_3_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_2_2_WHITE_UP) - (p_affine_0_0_WHITE_UP - p_affine_2_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_1_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_3_2_WHITE_UP) + (p_affine_0_0_WHITE_UP - p_affine_2_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_3_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_1_2_WHITE_UP) + (p_affine_0_0_WHITE_UP - p_affine_3_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_1_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_2_2_WHITE_UP) - (p_affine_0_0_WHITE_UP - p_affine_3_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_2_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_1_2_WHITE_UP)), 0.065767460857085305*abs((p_affine_0_0_WHITE_UP - p_affine_1_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_2_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_3_2_WHITE_UP) - (p_affine_0_0_WHITE_UP - p_affine_1_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_3_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_2_2_WHITE_UP) - (p_affine_0_0_WHITE_UP - p_affine_2_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_1_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_3_2_WHITE_UP) + (p_affine_0_0_WHITE_UP - p_affine_2_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_3_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_1_2_WHITE_UP) + (p_affine_0_0_WHITE_UP - p_affine_3_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_1_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_2_2_WHITE_UP) - (p_affine_0_0_WHITE_UP - p_affine_3_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_2_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_1_2_WHITE_UP)), 0.0012463879784202093*abs((p_affine_0_0_WHITE_UP - p_affine_1_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_2_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_3_2_WHITE_UP) - (p_affine_0_0_WHITE_UP - p_affine_1_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_3_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_2_2_WHITE_UP) - (p_affine_0_0_WHITE_UP - p_affine_2_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_1_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_3_2_WHITE_UP) + (p_affine_0_0_WHITE_UP - p_affine_2_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_3_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_1_2_WHITE_UP) + (p_affine_0_0_WHITE_UP - p_affine_3_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_1_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_2_2_WHITE_UP) - (p_affine_0_0_WHITE_UP - p_affine_3_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_2_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_1_2_WHITE_UP)), 0.13345469765676804*abs((p_affine_0_0_WHITE_UP - p_affine_1_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_2_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_3_2_WHITE_UP) - (p_affine_0_0_WHITE_UP - p_affine_1_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_3_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_2_2_WHITE_UP) - (p_affine_0_0_WHITE_UP - p_affine_2_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_1_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_3_2_WHITE_UP) + (p_affine_0_0_WHITE_UP - p_affine_2_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_3_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_1_2_WHITE_UP) + (p_affine_0_0_WHITE_UP - p_affine_3_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_1_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_2_2_WHITE_UP) - (p_affine_0_0_WHITE_UP - p_affine_3_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_2_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_1_2_WHITE_UP)), 0.002529158472220073*abs((p_affine_0_0_WHITE_UP - p_affine_1_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_2_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_3_2_WHITE_UP) - (p_affine_0_0_WHITE_UP - p_affine_1_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_3_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_2_2_WHITE_UP) - (p_affine_0_0_WHITE_UP - p_affine_2_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_1_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_3_2_WHITE_UP) + (p_affine_0_0_WHITE_UP - p_affine_2_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_3_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_1_2_WHITE_UP) + (p_affine_0_0_WHITE_UP - p_affine_3_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_1_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_2_2_WHITE_UP) - (p_affine_0_0_WHITE_UP - p_affine_3_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_2_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_1_2_WHITE_UP)), 4.793119080794062e-5*abs((p_affine_0_0_WHITE_UP - p_affine_1_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_2_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_3_2_WHITE_UP) - (p_affine_0_0_WHITE_UP - p_affine_1_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_3_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_2_2_WHITE_UP) - (p_affine_0_0_WHITE_UP - p_affine_2_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_1_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_3_2_WHITE_UP) + (p_affine_0_0_WHITE_UP - p_affine_2_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_3_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_1_2_WHITE_UP) + (p_affine_0_0_WHITE_UP - p_affine_3_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_1_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_2_2_WHITE_UP) - (p_affine_0_0_WHITE_UP - p_affine_3_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_2_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_1_2_WHITE_UP)), 2.3424983832091605e-5*abs((p_affine_0_0_WHITE_UP - p_affine_1_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_2_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_3_2_WHITE_UP) - (p_affine_0_0_WHITE_UP - p_affine_1_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_3_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_2_2_WHITE_UP) - (p_affine_0_0_WHITE_UP - p_affine_2_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_1_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_3_2_WHITE_UP) + (p_affine_0_0_WHITE_UP - p_affine_2_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_3_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_1_2_WHITE_UP) + (p_affine_0_0_WHITE_UP - p_affine_3_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_1_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_2_2_WHITE_UP) - (p_affine_0_0_WHITE_UP - p_affine_3_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_2_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_1_2_WHITE_UP)), 0.00075470637742922845*abs((p_affine_0_0_WHITE_UP - p_affine_1_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_2_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_3_2_WHITE_UP) - (p_affine_0_0_WHITE_UP - p_affine_1_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_3_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_2_2_WHITE_UP) - (p_affine_0_0_WHITE_UP - p_affine_2_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_1_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_3_2_WHITE_UP) + (p_affine_0_0_WHITE_UP - p_affine_2_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_3_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_1_2_WHITE_UP) + (p_affine_0_0_WHITE_UP - p_affine_3_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_1_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_2_2_WHITE_UP) - (p_affine_0_0_WHITE_UP - p_affine_3_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_2_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_1_2_WHITE_UP)), 0.0022140849621758063*abs((p_affine_0_0_WHITE_UP - p_affine_1_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_2_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_3_2_WHITE_UP) - (p_affine_0_0_WHITE_UP - p_affine_1_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_3_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_2_2_WHITE_UP) - (p_affine_0_0_WHITE_UP - p_affine_2_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_1_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_3_2_WHITE_UP) + (p_affine_0_0_WHITE_UP - p_affine_2_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_3_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_1_2_WHITE_UP) + (p_affine_0_0_WHITE_UP - p_affine_3_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_1_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_2_2_WHITE_UP) - (p_affine_0_0_WHITE_UP - p_affine_3_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_2_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_1_2_WHITE_UP)), 0.0018477200224347493*abs((p_affine_0_0_WHITE_UP - p_affine_1_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_2_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_3_2_WHITE_UP) - (p_affine_0_0_WHITE_UP - p_affine_1_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_3_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_2_2_WHITE_UP) - (p_affine_0_0_WHITE_UP - p_affine_2_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_1_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_3_2_WHITE_UP) + (p_affine_0_0_WHITE_UP - p_affine_2_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_3_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_1_2_WHITE_UP) + (p_affine_0_0_WHITE_UP - p_affine_3_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_1_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_2_2_WHITE_UP) - (p_affine_0_0_WHITE_UP - p_affine_3_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_2_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_1_2_WHITE_UP)), 0.024315138068613611*abs((p_affine_0_0_WHITE_UP - p_affine_1_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_2_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_3_2_WHITE_UP) - (p_affine_0_0_WHITE_UP - p_affine_1_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_3_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_2_2_WHITE_UP) - (p_affine_0_0_WHITE_UP - p_affine_2_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_1_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_3_2_WHITE_UP) + (p_affine_0_0_WHITE_UP - p_affine_2_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_3_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_1_2_WHITE_UP) + (p_affine_0_0_WHITE_UP - p_affine_3_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_1_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_2_2_WHITE_UP) - (p_affine_0_0_WHITE_UP - p_affine_3_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_2_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_1_2_WHITE_UP)), 0.071333412782766975*abs((p_affine_0_0_WHITE_UP - p_affine_1_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_2_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_3_2_WHITE_UP) - (p_affine_0_0_WHITE_UP - p_affine_1_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_3_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_2_2_WHITE_UP) - (p_affine_0_0_WHITE_UP - p_affine_2_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_1_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_3_2_WHITE_UP) + (p_affine_0_0_WHITE_UP - p_affine_2_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_3_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_1_2_WHITE_UP) + (p_affine_0_0_WHITE_UP - p_affine_3_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_1_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_2_2_WHITE_UP) - (p_affine_0_0_WHITE_UP - p_affine_3_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_2_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_1_2_WHITE_UP)), 0.059529863270376029*abs((p_affine_0_0_WHITE_UP - p_affine_1_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_2_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_3_2_WHITE_UP) - (p_affine_0_0_WHITE_UP - p_affine_1_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_3_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_2_2_WHITE_UP) - (p_affine_0_0_WHITE_UP - p_affine_2_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_1_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_3_2_WHITE_UP) + (p_affine_0_0_WHITE_UP - p_affine_2_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_3_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_1_2_WHITE_UP) + (p_affine_0_0_WHITE_UP - p_affine_3_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_1_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_2_2_WHITE_UP) - (p_affine_0_0_WHITE_UP - p_affine_3_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_2_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_1_2_WHITE_UP)), 0.20927110365887197*abs((p_affine_0_0_WHITE_UP - p_affine_1_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_2_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_3_2_WHITE_UP) - (p_affine_0_0_WHITE_UP - p_affine_1_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_3_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_2_2_WHITE_UP) - (p_affine_0_0_WHITE_UP - p_affine_2_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_1_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_3_2_WHITE_UP) + (p_affine_0_0_WHITE_UP - p_affine_2_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_3_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_1_2_WHITE_UP) + (p_affine_0_0_WHITE_UP - p_affine_3_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_1_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_2_2_WHITE_UP) - (p_affine_0_0_WHITE_UP - p_affine_3_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_2_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_1_2_WHITE_UP)), 0.17464298568178085*abs((p_affine_0_0_WHITE_UP - p_affine_1_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_2_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_3_2_WHITE_UP) - (p_affine_0_0_WHITE_UP - p_affine_1_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_3_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_2_2_WHITE_UP) - (p_affine_0_0_WHITE_UP - p_affine_2_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_1_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_3_2_WHITE_UP) + (p_affine_0_0_WHITE_UP - p_affine_2_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_3_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_1_2_WHITE_UP) + (p_affine_0_0_WHITE_UP - p_affine_3_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_1_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_2_2_WHITE_UP) - (p_affine_0_0_WHITE_UP - p_affine_3_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_2_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_1_2_WHITE_UP)), 0.14574478709475508*abs((p_affine_0_0_WHITE_UP - p_affine_1_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_2_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_3_2_WHITE_UP) - (p_affine_0_0_WHITE_UP - p_affine_1_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_3_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_2_2_WHITE_UP) - (p_affine_0_0_WHITE_UP - p_affine_2_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_1_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_3_2_WHITE_UP) + (p_affine_0_0_WHITE_UP - p_affine_2_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_3_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_1_2_WHITE_UP) + (p_affine_0_0_WHITE_UP - p_affine_3_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_1_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_2_2_WHITE_UP) - (p_affine_0_0_WHITE_UP - p_affine_3_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_2_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_1_2_WHITE_UP)), 0.12450054579698165*abs((p_affine_0_0_WHITE_UP - p_affine_1_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_2_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_3_2_WHITE_UP) - (p_affine_0_0_WHITE_UP - p_affine_1_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_3_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_2_2_WHITE_UP) - (p_affine_0_0_WHITE_UP - p_affine_2_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_1_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_3_2_WHITE_UP) + (p_affine_0_0_WHITE_UP - p_affine_2_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_3_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_1_2_WHITE_UP) + (p_affine_0_0_WHITE_UP - p_affine_3_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_1_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_2_2_WHITE_UP) - (p_affine_0_0_WHITE_UP - p_affine_3_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_2_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_1_2_WHITE_UP)), 0.076241779079863126*abs((p_affine_0_0_WHITE_UP - p_affine_1_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_2_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_3_2_WHITE_UP) - (p_affine_0_0_WHITE_UP - p_affine_1_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_3_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_2_2_WHITE_UP) - (p_affine_0_0_WHITE_UP - p_affine_2_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_1_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_3_2_WHITE_UP) + (p_affine_0_0_WHITE_UP - p_affine_2_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_3_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_1_2_WHITE_UP) + (p_affine_0_0_WHITE_UP - p_affine_3_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_1_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_2_2_WHITE_UP) - (p_affine_0_0_WHITE_UP - p_affine_3_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_2_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_1_2_WHITE_UP)), 0.00013249910677232994*abs((p_affine_0_0_WHITE_UP - p_affine_1_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_2_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_3_2_WHITE_UP) - (p_affine_0_0_WHITE_UP - p_affine_1_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_3_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_2_2_WHITE_UP) - (p_affine_0_0_WHITE_UP - p_affine_2_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_1_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_3_2_WHITE_UP) + (p_affine_0_0_WHITE_UP - p_affine_2_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_3_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_1_2_WHITE_UP) + (p_affine_0_0_WHITE_UP - p_affine_3_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_1_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_2_2_WHITE_UP) - (p_affine_0_0_WHITE_UP - p_affine_3_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_2_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_1_2_WHITE_UP)), 0.15197152472496969*abs((p_affine_0_0_WHITE_UP - p_affine_1_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_2_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_3_2_WHITE_UP) - (p_affine_0_0_WHITE_UP - p_affine_1_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_3_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_2_2_WHITE_UP) - (p_affine_0_0_WHITE_UP - p_affine_2_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_1_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_3_2_WHITE_UP) + (p_affine_0_0_WHITE_UP - p_affine_2_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_3_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_1_2_WHITE_UP) + (p_affine_0_0_WHITE_UP - p_affine_3_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_1_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_2_2_WHITE_UP) - (p_affine_0_0_WHITE_UP - p_affine_3_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_2_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_1_2_WHITE_UP)), 0.046689023249274604*abs((p_affine_0_0_WHITE_UP - p_affine_1_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_2_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_3_2_WHITE_UP) - (p_affine_0_0_WHITE_UP - p_affine_1_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_3_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_2_2_WHITE_UP) - (p_affine_0_0_WHITE_UP - p_affine_2_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_1_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_3_2_WHITE_UP) + (p_affine_0_0_WHITE_UP - p_affine_2_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_3_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_1_2_WHITE_UP) + (p_affine_0_0_WHITE_UP - p_affine_3_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_1_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_2_2_WHITE_UP) - (p_affine_0_0_WHITE_UP - p_affine_3_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_2_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_1_2_WHITE_UP)), 8.1139946513070487e-5*abs((p_affine_0_0_WHITE_UP - p_affine_1_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_2_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_3_2_WHITE_UP) - (p_affine_0_0_WHITE_UP - p_affine_1_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_3_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_2_2_WHITE_UP) - (p_affine_0_0_WHITE_UP - p_affine_2_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_1_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_3_2_WHITE_UP) + (p_affine_0_0_WHITE_UP - p_affine_2_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_3_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_1_2_WHITE_UP) + (p_affine_0_0_WHITE_UP - p_affine_3_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_1_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_2_2_WHITE_UP) - (p_affine_0_0_WHITE_UP - p_affine_3_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_2_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_1_2_WHITE_UP)), 0.093064486909197122*abs((p_affine_0_0_WHITE_UP - p_affine_1_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_2_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_3_2_WHITE_UP) - (p_affine_0_0_WHITE_UP - p_affine_1_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_3_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_2_2_WHITE_UP) - (p_affine_0_0_WHITE_UP - p_affine_2_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_1_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_3_2_WHITE_UP) + (p_affine_0_0_WHITE_UP - p_affine_2_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_3_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_1_2_WHITE_UP) + (p_affine_0_0_WHITE_UP - p_affine_3_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_1_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_2_2_WHITE_UP) - (p_affine_0_0_WHITE_UP - p_affine_3_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_2_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_1_2_WHITE_UP)), 1.4101153680155925e-7*abs((p_affine_0_0_WHITE_UP - p_affine_1_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_2_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_3_2_WHITE_UP) - (p_affine_0_0_WHITE_UP - p_affine_1_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_3_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_2_2_WHITE_UP) - (p_affine_0_0_WHITE_UP - p_affine_2_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_1_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_3_2_WHITE_UP) + (p_affine_0_0_WHITE_UP - p_affine_2_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_3_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_1_2_WHITE_UP) + (p_affine_0_0_WHITE_UP - p_affine_3_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_1_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_2_2_WHITE_UP) - (p_affine_0_0_WHITE_UP - p_affine_3_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_2_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_1_2_WHITE_UP)), 0.00016173496390708763*abs((p_affine_0_0_WHITE_UP - p_affine_1_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_2_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_3_2_WHITE_UP) - (p_affine_0_0_WHITE_UP - p_affine_1_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_3_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_2_2_WHITE_UP) - (p_affine_0_0_WHITE_UP - p_affine_2_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_1_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_3_2_WHITE_UP) + (p_affine_0_0_WHITE_UP - p_affine_2_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_3_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_1_2_WHITE_UP) + (p_affine_0_0_WHITE_UP - p_affine_3_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_1_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_2_2_WHITE_UP) - (p_affine_0_0_WHITE_UP - p_affine_3_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_2_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_1_2_WHITE_UP)), 0.18550396047976195*abs((p_affine_0_0_WHITE_UP - p_affine_1_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_2_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_3_2_WHITE_UP) - (p_affine_0_0_WHITE_UP - p_affine_1_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_3_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_2_2_WHITE_UP) - (p_affine_0_0_WHITE_UP - p_affine_2_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_1_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_3_2_WHITE_UP) + (p_affine_0_0_WHITE_UP - p_affine_2_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_3_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_1_2_WHITE_UP) + (p_affine_0_0_WHITE_UP - p_affine_3_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_1_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_2_2_WHITE_UP) - (p_affine_0_0_WHITE_UP - p_affine_3_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_2_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_1_2_WHITE_UP)), 0.00021985802016328927*abs((p_affine_0_0_WHITE_UP - p_affine_1_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_2_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_3_2_WHITE_UP) - (p_affine_0_0_WHITE_UP - p_affine_1_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_3_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_2_2_WHITE_UP) - (p_affine_0_0_WHITE_UP - p_affine_2_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_1_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_3_2_WHITE_UP) + (p_affine_0_0_WHITE_UP - p_affine_2_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_3_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_1_2_WHITE_UP) + (p_affine_0_0_WHITE_UP - p_affine_3_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_1_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_2_2_WHITE_UP) - (p_affine_0_0_WHITE_UP - p_affine_3_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_2_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_1_2_WHITE_UP)), 0.012181957275462504*abs((p_affine_0_0_WHITE_UP - p_affine_1_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_2_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_3_2_WHITE_UP) - (p_affine_0_0_WHITE_UP - p_affine_1_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_3_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_2_2_WHITE_UP) - (p_affine_0_0_WHITE_UP - p_affine_2_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_1_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_3_2_WHITE_UP) + (p_affine_0_0_WHITE_UP - p_affine_2_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_3_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_1_2_WHITE_UP) + (p_affine_0_0_WHITE_UP - p_affine_3_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_1_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_2_2_WHITE_UP) - (p_affine_0_0_WHITE_UP - p_affine_3_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_2_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_1_2_WHITE_UP)), 0.0018336830929379926*abs((p_affine_0_0_WHITE_UP - p_affine_1_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_2_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_3_2_WHITE_UP) - (p_affine_0_0_WHITE_UP - p_affine_1_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_3_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_2_2_WHITE_UP) - (p_affine_0_0_WHITE_UP - p_affine_2_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_1_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_3_2_WHITE_UP) + (p_affine_0_0_WHITE_UP - p_affine_2_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_3_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_1_2_WHITE_UP) + (p_affine_0_0_WHITE_UP - p_affine_3_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_1_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_2_2_WHITE_UP) - (p_affine_0_0_WHITE_UP - p_affine_3_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_2_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_1_2_WHITE_UP)), 0.00059211167385993745*abs((p_affine_0_0_WHITE_UP - p_affine_1_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_2_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_3_2_WHITE_UP) - (p_affine_0_0_WHITE_UP - p_affine_1_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_3_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_2_2_WHITE_UP) - (p_affine_0_0_WHITE_UP - p_affine_2_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_1_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_3_2_WHITE_UP) + (p_affine_0_0_WHITE_UP - p_affine_2_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_3_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_1_2_WHITE_UP) + (p_affine_0_0_WHITE_UP - p_affine_3_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_1_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_2_2_WHITE_UP) - (p_affine_0_0_WHITE_UP - p_affine_3_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_2_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_1_2_WHITE_UP)), 0.67498144007199112*abs((p_affine_0_0_WHITE_UP - p_affine_1_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_2_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_3_2_WHITE_UP) - (p_affine_0_0_WHITE_UP - p_affine_1_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_3_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_2_2_WHITE_UP) - (p_affine_0_0_WHITE_UP - p_affine_2_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_1_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_3_2_WHITE_UP) + (p_affine_0_0_WHITE_UP - p_affine_2_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_3_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_1_2_WHITE_UP) + (p_affine_0_0_WHITE_UP - p_affine_3_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_1_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_2_2_WHITE_UP) - (p_affine_0_0_WHITE_UP - p_affine_3_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_2_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_1_2_WHITE_UP)), 0.10160124737918669*abs((p_affine_0_0_WHITE_UP - p_affine_1_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_2_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_3_2_WHITE_UP) - (p_affine_0_0_WHITE_UP - p_affine_1_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_3_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_2_2_WHITE_UP) - (p_affine_0_0_WHITE_UP - p_affine_2_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_1_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_3_2_WHITE_UP) + (p_affine_0_0_WHITE_UP - p_affine_2_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_3_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_1_2_WHITE_UP) + (p_affine_0_0_WHITE_UP - p_affine_3_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_1_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_2_2_WHITE_UP) - (p_affine_0_0_WHITE_UP - p_affine_3_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_2_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_1_2_WHITE_UP)), 0.032807896240979378*abs((p_affine_0_0_WHITE_UP - p_affine_1_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_2_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_3_2_WHITE_UP) - (p_affine_0_0_WHITE_UP - p_affine_1_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_3_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_2_2_WHITE_UP) - (p_affine_0_0_WHITE_UP - p_affine_2_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_1_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_3_2_WHITE_UP) + (p_affine_0_0_WHITE_UP - p_affine_2_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_3_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_1_2_WHITE_UP) + (p_affine_0_0_WHITE_UP - p_affine_3_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_1_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_2_2_WHITE_UP) - (p_affine_0_0_WHITE_UP - p_affine_3_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_2_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_1_2_WHITE_UP)), 0.015293477503478755*abs((p_affine_0_0_WHITE_UP - p_affine_1_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_2_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_3_2_WHITE_UP) - (p_affine_0_0_WHITE_UP - p_affine_1_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_3_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_2_2_WHITE_UP) - (p_affine_0_0_WHITE_UP - p_affine_2_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_1_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_3_2_WHITE_UP) + (p_affine_0_0_WHITE_UP - p_affine_2_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_3_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_1_2_WHITE_UP) + (p_affine_0_0_WHITE_UP - p_affine_3_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_1_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_2_2_WHITE_UP) - (p_affine_0_0_WHITE_UP - p_affine_3_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_2_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_1_2_WHITE_UP)), 0.0049383923528547903*abs((p_affine_0_0_WHITE_UP - p_affine_1_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_2_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_3_2_WHITE_UP) - (p_affine_0_0_WHITE_UP - p_affine_1_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_3_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_2_2_WHITE_UP) - (p_affine_0_0_WHITE_UP - p_affine_2_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_1_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_3_2_WHITE_UP) + (p_affine_0_0_WHITE_UP - p_affine_2_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_3_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_1_2_WHITE_UP) + (p_affine_0_0_WHITE_UP - p_affine_3_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_1_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_2_2_WHITE_UP) - (p_affine_0_0_WHITE_UP - p_affine_3_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_2_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_1_2_WHITE_UP)), 0.0015946483738042757*abs((p_affine_0_0_WHITE_UP - p_affine_1_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_2_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_3_2_WHITE_UP) - (p_affine_0_0_WHITE_UP - p_affine_1_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_3_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_2_2_WHITE_UP) - (p_affine_0_0_WHITE_UP - p_affine_2_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_1_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_3_2_WHITE_UP) + (p_affine_0_0_WHITE_UP - p_affine_2_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_3_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_1_2_WHITE_UP) + (p_affine_0_0_WHITE_UP - p_affine_3_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_1_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_2_2_WHITE_UP) - (p_affine_0_0_WHITE_UP - p_affine_3_0_WHITE_UP)*(p_affine_0_1_WHITE_UP - p_affine_2_1_WHITE_UP)*(p_affine_0_2_WHITE_UP - p_affine_1_2_WHITE_UP))};
      
          for (int64_t ctr_2 = 0; ctr_2 < micro_edges_per_macro_edge; ctr_2 += 1)
          for (int64_t ctr_1 = 0; ctr_1 < -ctr_2 + micro_edges_per_macro_edge; ctr_1 += 1)
          {
             for (int64_t ctr_0 = 0; ctr_0 < (int64_t)((-ctr_1 - ctr_2 + micro_edges_per_macro_edge) / (4)) * (4); ctr_0 += 4)
             {
                __m256d q_acc_0_0 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_1 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_2 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_3 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                for (int64_t q = 0; q < 4; q += 1)
                {
                   const real_t q_tmp_0_0 = _data_phi_psi_det_jac_aff_0_WHITE_UP[10*q]*_data_q_w[q];
                   const real_t q_tmp_1_1 = _data_phi_psi_det_jac_aff_0_WHITE_UP[10*q + 4]*_data_q_w[q];
                   const real_t q_tmp_2_2 = _data_phi_psi_det_jac_aff_0_WHITE_UP[10*q + 7]*_data_q_w[q];
                   const real_t q_tmp_3_3 = _data_phi_psi_det_jac_aff_0_WHITE_UP[10*q + 9]*_data_q_w[q];
                   q_acc_0_0 = _mm256_add_pd(_mm256_set_pd(q_tmp_0_0,q_tmp_0_0,q_tmp_0_0,q_tmp_0_0),q_acc_0_0);
                   q_acc_1_1 = _mm256_add_pd(_mm256_set_pd(q_tmp_1_1,q_tmp_1_1,q_tmp_1_1,q_tmp_1_1),q_acc_1_1);
                   q_acc_2_2 = _mm256_add_pd(_mm256_set_pd(q_tmp_2_2,q_tmp_2_2,q_tmp_2_2,q_tmp_2_2),q_acc_2_2);
                   q_acc_3_3 = _mm256_add_pd(_mm256_set_pd(q_tmp_3_3,q_tmp_3_3,q_tmp_3_3,q_tmp_3_3),q_acc_3_3);
                }
                const __m256d elMatDiag_0 = q_acc_0_0;
                const __m256d elMatDiag_1 = q_acc_1_1;
                const __m256d elMatDiag_2 = q_acc_2_2;
                const __m256d elMatDiag_3 = q_acc_3_3;
                _mm256_storeu_pd(&_data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatDiag_0,_mm256_loadu_pd(& _data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatDiag_1,_mm256_loadu_pd(& _data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_invDiag_[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatDiag_2,_mm256_loadu_pd(& _data_invDiag_[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatDiag_3,_mm256_loadu_pd(& _data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))])));
             }
             for (int64_t ctr_0 = (int64_t)((-ctr_1 - ctr_2 + micro_edges_per_macro_edge) / (4)) * (4); ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge; ctr_0 += 1)
             {
                real_t q_acc_0_0 = 0.0;
                real_t q_acc_1_1 = 0.0;
                real_t q_acc_2_2 = 0.0;
                real_t q_acc_3_3 = 0.0;
                for (int64_t q = 0; q < 4; q += 1)
                {
                   const real_t q_tmp_0_0 = _data_phi_psi_det_jac_aff_0_WHITE_UP[10*q]*_data_q_w[q];
                   const real_t q_tmp_1_1 = _data_phi_psi_det_jac_aff_0_WHITE_UP[10*q + 4]*_data_q_w[q];
                   const real_t q_tmp_2_2 = _data_phi_psi_det_jac_aff_0_WHITE_UP[10*q + 7]*_data_q_w[q];
                   const real_t q_tmp_3_3 = _data_phi_psi_det_jac_aff_0_WHITE_UP[10*q + 9]*_data_q_w[q];
                   q_acc_0_0 = q_acc_0_0 + q_tmp_0_0;
                   q_acc_1_1 = q_acc_1_1 + q_tmp_1_1;
                   q_acc_2_2 = q_acc_2_2 + q_tmp_2_2;
                   q_acc_3_3 = q_acc_3_3 + q_tmp_3_3;
                }
                const real_t elMatDiag_0 = q_acc_0_0;
                const real_t elMatDiag_1 = q_acc_1_1;
                const real_t elMatDiag_2 = q_acc_2_2;
                const real_t elMatDiag_3 = q_acc_3_3;
                _data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatDiag_0 + _data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                _data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatDiag_1 + _data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_invDiag_[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatDiag_2 + _data_invDiag_[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                _data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatDiag_3 + _data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             }
          }
       }
       const real_t tmp_0_WHITE_DOWN = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t tmp_1_WHITE_DOWN = tmp_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t tmp_2_WHITE_DOWN = macro_vertex_coord_id_0comp0 + tmp_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const real_t tmp_3_WHITE_DOWN = tmp_1_WHITE_DOWN + tmp_2_WHITE_DOWN;
       const real_t tmp_4_WHITE_DOWN = tmp_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t tmp_5_WHITE_DOWN = macro_vertex_coord_id_0comp1 + tmp_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const real_t tmp_6_WHITE_DOWN = tmp_4_WHITE_DOWN + tmp_5_WHITE_DOWN;
       const real_t tmp_7_WHITE_DOWN = tmp_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const real_t tmp_8_WHITE_DOWN = macro_vertex_coord_id_0comp2 + tmp_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2);
       const real_t tmp_9_WHITE_DOWN = tmp_7_WHITE_DOWN + tmp_8_WHITE_DOWN;
       const real_t tmp_10_WHITE_DOWN = tmp_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0);
       const real_t tmp_11_WHITE_DOWN = tmp_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1);
       const real_t tmp_12_WHITE_DOWN = tmp_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2);
       const real_t p_affine_0_0_WHITE_DOWN = tmp_3_WHITE_DOWN;
       const real_t p_affine_0_1_WHITE_DOWN = tmp_6_WHITE_DOWN;
       const real_t p_affine_0_2_WHITE_DOWN = tmp_9_WHITE_DOWN;
       const real_t p_affine_1_0_WHITE_DOWN = tmp_10_WHITE_DOWN + tmp_2_WHITE_DOWN;
       const real_t p_affine_1_1_WHITE_DOWN = tmp_11_WHITE_DOWN + tmp_5_WHITE_DOWN;
       const real_t p_affine_1_2_WHITE_DOWN = tmp_12_WHITE_DOWN + tmp_8_WHITE_DOWN;
       const real_t p_affine_2_0_WHITE_DOWN = macro_vertex_coord_id_0comp0 + tmp_10_WHITE_DOWN + tmp_1_WHITE_DOWN;
       const real_t p_affine_2_1_WHITE_DOWN = macro_vertex_coord_id_0comp1 + tmp_11_WHITE_DOWN + tmp_4_WHITE_DOWN;
       const real_t p_affine_2_2_WHITE_DOWN = macro_vertex_coord_id_0comp2 + tmp_12_WHITE_DOWN + tmp_7_WHITE_DOWN;
       const real_t p_affine_3_0_WHITE_DOWN = tmp_10_WHITE_DOWN + tmp_3_WHITE_DOWN;
       const real_t p_affine_3_1_WHITE_DOWN = tmp_11_WHITE_DOWN + tmp_6_WHITE_DOWN;
       const real_t p_affine_3_2_WHITE_DOWN = tmp_12_WHITE_DOWN + tmp_9_WHITE_DOWN;
       {
          /* CellType.WHITE_DOWN */
          const real_t _data_phi_psi_det_jac_aff_0_WHITE_DOWN [] = {0.20046443821120821*abs((p_affine_0_0_WHITE_DOWN - p_affine_1_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_2_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_3_2_WHITE_DOWN) - (p_affine_0_0_WHITE_DOWN - p_affine_1_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_3_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_2_2_WHITE_DOWN) - (p_affine_0_0_WHITE_DOWN - p_affine_2_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_1_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_3_2_WHITE_DOWN) + (p_affine_0_0_WHITE_DOWN - p_affine_2_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_3_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_1_2_WHITE_DOWN) + (p_affine_0_0_WHITE_DOWN - p_affine_3_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_1_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_2_2_WHITE_DOWN) - (p_affine_0_0_WHITE_DOWN - p_affine_3_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_2_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_1_2_WHITE_DOWN)), 0.080605154129423817*abs((p_affine_0_0_WHITE_DOWN - p_affine_1_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_2_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_3_2_WHITE_DOWN) - (p_affine_0_0_WHITE_DOWN - p_affine_1_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_3_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_2_2_WHITE_DOWN) - (p_affine_0_0_WHITE_DOWN - p_affine_2_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_1_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_3_2_WHITE_DOWN) + (p_affine_0_0_WHITE_DOWN - p_affine_2_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_3_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_1_2_WHITE_DOWN) + (p_affine_0_0_WHITE_DOWN - p_affine_3_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_1_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_2_2_WHITE_DOWN) - (p_affine_0_0_WHITE_DOWN - p_affine_3_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_2_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_1_2_WHITE_DOWN)), 0.16356320182856121*abs((p_affine_0_0_WHITE_DOWN - p_affine_1_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_2_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_3_2_WHITE_DOWN) - (p_affine_0_0_WHITE_DOWN - p_affine_1_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_3_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_2_2_WHITE_DOWN) - (p_affine_0_0_WHITE_DOWN - p_affine_2_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_1_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_3_2_WHITE_DOWN) + (p_affine_0_0_WHITE_DOWN - p_affine_2_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_3_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_1_2_WHITE_DOWN) + (p_affine_0_0_WHITE_DOWN - p_affine_3_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_1_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_2_2_WHITE_DOWN) - (p_affine_0_0_WHITE_DOWN - p_affine_3_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_2_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_1_2_WHITE_DOWN)), 0.0030997579321792282*abs((p_affine_0_0_WHITE_DOWN - p_affine_1_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_2_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_3_2_WHITE_DOWN) - (p_affine_0_0_WHITE_DOWN - p_affine_1_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_3_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_2_2_WHITE_DOWN) - (p_affine_0_0_WHITE_DOWN - p_affine_2_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_1_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_3_2_WHITE_DOWN) + (p_affine_0_0_WHITE_DOWN - p_affine_2_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_3_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_1_2_WHITE_DOWN) + (p_affine_0_0_WHITE_DOWN - p_affine_3_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_1_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_2_2_WHITE_DOWN) - (p_affine_0_0_WHITE_DOWN - p_affine_3_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_2_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_1_2_WHITE_DOWN)), 0.032410690545436126*abs((p_affine_0_0_WHITE_DOWN - p_affine_1_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_2_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_3_2_WHITE_DOWN) - (p_affine_0_0_WHITE_DOWN - p_affine_1_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_3_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_2_2_WHITE_DOWN) - (p_affine_0_0_WHITE_DOWN - p_affine_2_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_1_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_3_2_WHITE_DOWN) + (p_affine_0_0_WHITE_DOWN - p_affine_2_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_3_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_1_2_WHITE_DOWN) + (p_affine_0_0_WHITE_DOWN - p_affine_3_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_1_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_2_2_WHITE_DOWN) - (p_affine_0_0_WHITE_DOWN - p_affine_3_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_2_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_1_2_WHITE_DOWN)), 0.065767460857085305*abs((p_affine_0_0_WHITE_DOWN - p_affine_1_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_2_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_3_2_WHITE_DOWN) - (p_affine_0_0_WHITE_DOWN - p_affine_1_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_3_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_2_2_WHITE_DOWN) - (p_affine_0_0_WHITE_DOWN - p_affine_2_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_1_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_3_2_WHITE_DOWN) + (p_affine_0_0_WHITE_DOWN - p_affine_2_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_3_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_1_2_WHITE_DOWN) + (p_affine_0_0_WHITE_DOWN - p_affine_3_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_1_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_2_2_WHITE_DOWN) - (p_affine_0_0_WHITE_DOWN - p_affine_3_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_2_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_1_2_WHITE_DOWN)), 0.0012463879784202093*abs((p_affine_0_0_WHITE_DOWN - p_affine_1_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_2_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_3_2_WHITE_DOWN) - (p_affine_0_0_WHITE_DOWN - p_affine_1_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_3_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_2_2_WHITE_DOWN) - (p_affine_0_0_WHITE_DOWN - p_affine_2_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_1_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_3_2_WHITE_DOWN) + (p_affine_0_0_WHITE_DOWN - p_affine_2_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_3_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_1_2_WHITE_DOWN) + (p_affine_0_0_WHITE_DOWN - p_affine_3_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_1_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_2_2_WHITE_DOWN) - (p_affine_0_0_WHITE_DOWN - p_affine_3_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_2_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_1_2_WHITE_DOWN)), 0.13345469765676804*abs((p_affine_0_0_WHITE_DOWN - p_affine_1_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_2_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_3_2_WHITE_DOWN) - (p_affine_0_0_WHITE_DOWN - p_affine_1_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_3_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_2_2_WHITE_DOWN) - (p_affine_0_0_WHITE_DOWN - p_affine_2_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_1_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_3_2_WHITE_DOWN) + (p_affine_0_0_WHITE_DOWN - p_affine_2_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_3_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_1_2_WHITE_DOWN) + (p_affine_0_0_WHITE_DOWN - p_affine_3_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_1_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_2_2_WHITE_DOWN) - (p_affine_0_0_WHITE_DOWN - p_affine_3_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_2_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_1_2_WHITE_DOWN)), 0.002529158472220073*abs((p_affine_0_0_WHITE_DOWN - p_affine_1_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_2_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_3_2_WHITE_DOWN) - (p_affine_0_0_WHITE_DOWN - p_affine_1_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_3_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_2_2_WHITE_DOWN) - (p_affine_0_0_WHITE_DOWN - p_affine_2_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_1_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_3_2_WHITE_DOWN) + (p_affine_0_0_WHITE_DOWN - p_affine_2_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_3_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_1_2_WHITE_DOWN) + (p_affine_0_0_WHITE_DOWN - p_affine_3_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_1_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_2_2_WHITE_DOWN) - (p_affine_0_0_WHITE_DOWN - p_affine_3_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_2_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_1_2_WHITE_DOWN)), 4.793119080794062e-5*abs((p_affine_0_0_WHITE_DOWN - p_affine_1_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_2_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_3_2_WHITE_DOWN) - (p_affine_0_0_WHITE_DOWN - p_affine_1_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_3_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_2_2_WHITE_DOWN) - (p_affine_0_0_WHITE_DOWN - p_affine_2_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_1_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_3_2_WHITE_DOWN) + (p_affine_0_0_WHITE_DOWN - p_affine_2_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_3_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_1_2_WHITE_DOWN) + (p_affine_0_0_WHITE_DOWN - p_affine_3_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_1_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_2_2_WHITE_DOWN) - (p_affine_0_0_WHITE_DOWN - p_affine_3_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_2_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_1_2_WHITE_DOWN)), 2.3424983832091605e-5*abs((p_affine_0_0_WHITE_DOWN - p_affine_1_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_2_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_3_2_WHITE_DOWN) - (p_affine_0_0_WHITE_DOWN - p_affine_1_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_3_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_2_2_WHITE_DOWN) - (p_affine_0_0_WHITE_DOWN - p_affine_2_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_1_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_3_2_WHITE_DOWN) + (p_affine_0_0_WHITE_DOWN - p_affine_2_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_3_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_1_2_WHITE_DOWN) + (p_affine_0_0_WHITE_DOWN - p_affine_3_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_1_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_2_2_WHITE_DOWN) - (p_affine_0_0_WHITE_DOWN - p_affine_3_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_2_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_1_2_WHITE_DOWN)), 0.00075470637742922845*abs((p_affine_0_0_WHITE_DOWN - p_affine_1_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_2_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_3_2_WHITE_DOWN) - (p_affine_0_0_WHITE_DOWN - p_affine_1_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_3_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_2_2_WHITE_DOWN) - (p_affine_0_0_WHITE_DOWN - p_affine_2_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_1_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_3_2_WHITE_DOWN) + (p_affine_0_0_WHITE_DOWN - p_affine_2_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_3_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_1_2_WHITE_DOWN) + (p_affine_0_0_WHITE_DOWN - p_affine_3_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_1_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_2_2_WHITE_DOWN) - (p_affine_0_0_WHITE_DOWN - p_affine_3_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_2_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_1_2_WHITE_DOWN)), 0.0022140849621758063*abs((p_affine_0_0_WHITE_DOWN - p_affine_1_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_2_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_3_2_WHITE_DOWN) - (p_affine_0_0_WHITE_DOWN - p_affine_1_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_3_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_2_2_WHITE_DOWN) - (p_affine_0_0_WHITE_DOWN - p_affine_2_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_1_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_3_2_WHITE_DOWN) + (p_affine_0_0_WHITE_DOWN - p_affine_2_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_3_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_1_2_WHITE_DOWN) + (p_affine_0_0_WHITE_DOWN - p_affine_3_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_1_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_2_2_WHITE_DOWN) - (p_affine_0_0_WHITE_DOWN - p_affine_3_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_2_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_1_2_WHITE_DOWN)), 0.0018477200224347493*abs((p_affine_0_0_WHITE_DOWN - p_affine_1_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_2_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_3_2_WHITE_DOWN) - (p_affine_0_0_WHITE_DOWN - p_affine_1_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_3_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_2_2_WHITE_DOWN) - (p_affine_0_0_WHITE_DOWN - p_affine_2_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_1_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_3_2_WHITE_DOWN) + (p_affine_0_0_WHITE_DOWN - p_affine_2_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_3_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_1_2_WHITE_DOWN) + (p_affine_0_0_WHITE_DOWN - p_affine_3_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_1_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_2_2_WHITE_DOWN) - (p_affine_0_0_WHITE_DOWN - p_affine_3_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_2_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_1_2_WHITE_DOWN)), 0.024315138068613611*abs((p_affine_0_0_WHITE_DOWN - p_affine_1_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_2_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_3_2_WHITE_DOWN) - (p_affine_0_0_WHITE_DOWN - p_affine_1_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_3_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_2_2_WHITE_DOWN) - (p_affine_0_0_WHITE_DOWN - p_affine_2_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_1_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_3_2_WHITE_DOWN) + (p_affine_0_0_WHITE_DOWN - p_affine_2_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_3_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_1_2_WHITE_DOWN) + (p_affine_0_0_WHITE_DOWN - p_affine_3_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_1_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_2_2_WHITE_DOWN) - (p_affine_0_0_WHITE_DOWN - p_affine_3_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_2_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_1_2_WHITE_DOWN)), 0.071333412782766975*abs((p_affine_0_0_WHITE_DOWN - p_affine_1_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_2_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_3_2_WHITE_DOWN) - (p_affine_0_0_WHITE_DOWN - p_affine_1_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_3_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_2_2_WHITE_DOWN) - (p_affine_0_0_WHITE_DOWN - p_affine_2_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_1_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_3_2_WHITE_DOWN) + (p_affine_0_0_WHITE_DOWN - p_affine_2_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_3_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_1_2_WHITE_DOWN) + (p_affine_0_0_WHITE_DOWN - p_affine_3_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_1_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_2_2_WHITE_DOWN) - (p_affine_0_0_WHITE_DOWN - p_affine_3_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_2_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_1_2_WHITE_DOWN)), 0.059529863270376029*abs((p_affine_0_0_WHITE_DOWN - p_affine_1_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_2_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_3_2_WHITE_DOWN) - (p_affine_0_0_WHITE_DOWN - p_affine_1_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_3_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_2_2_WHITE_DOWN) - (p_affine_0_0_WHITE_DOWN - p_affine_2_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_1_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_3_2_WHITE_DOWN) + (p_affine_0_0_WHITE_DOWN - p_affine_2_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_3_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_1_2_WHITE_DOWN) + (p_affine_0_0_WHITE_DOWN - p_affine_3_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_1_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_2_2_WHITE_DOWN) - (p_affine_0_0_WHITE_DOWN - p_affine_3_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_2_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_1_2_WHITE_DOWN)), 0.20927110365887197*abs((p_affine_0_0_WHITE_DOWN - p_affine_1_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_2_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_3_2_WHITE_DOWN) - (p_affine_0_0_WHITE_DOWN - p_affine_1_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_3_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_2_2_WHITE_DOWN) - (p_affine_0_0_WHITE_DOWN - p_affine_2_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_1_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_3_2_WHITE_DOWN) + (p_affine_0_0_WHITE_DOWN - p_affine_2_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_3_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_1_2_WHITE_DOWN) + (p_affine_0_0_WHITE_DOWN - p_affine_3_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_1_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_2_2_WHITE_DOWN) - (p_affine_0_0_WHITE_DOWN - p_affine_3_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_2_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_1_2_WHITE_DOWN)), 0.17464298568178085*abs((p_affine_0_0_WHITE_DOWN - p_affine_1_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_2_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_3_2_WHITE_DOWN) - (p_affine_0_0_WHITE_DOWN - p_affine_1_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_3_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_2_2_WHITE_DOWN) - (p_affine_0_0_WHITE_DOWN - p_affine_2_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_1_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_3_2_WHITE_DOWN) + (p_affine_0_0_WHITE_DOWN - p_affine_2_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_3_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_1_2_WHITE_DOWN) + (p_affine_0_0_WHITE_DOWN - p_affine_3_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_1_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_2_2_WHITE_DOWN) - (p_affine_0_0_WHITE_DOWN - p_affine_3_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_2_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_1_2_WHITE_DOWN)), 0.14574478709475508*abs((p_affine_0_0_WHITE_DOWN - p_affine_1_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_2_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_3_2_WHITE_DOWN) - (p_affine_0_0_WHITE_DOWN - p_affine_1_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_3_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_2_2_WHITE_DOWN) - (p_affine_0_0_WHITE_DOWN - p_affine_2_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_1_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_3_2_WHITE_DOWN) + (p_affine_0_0_WHITE_DOWN - p_affine_2_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_3_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_1_2_WHITE_DOWN) + (p_affine_0_0_WHITE_DOWN - p_affine_3_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_1_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_2_2_WHITE_DOWN) - (p_affine_0_0_WHITE_DOWN - p_affine_3_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_2_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_1_2_WHITE_DOWN)), 0.12450054579698165*abs((p_affine_0_0_WHITE_DOWN - p_affine_1_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_2_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_3_2_WHITE_DOWN) - (p_affine_0_0_WHITE_DOWN - p_affine_1_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_3_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_2_2_WHITE_DOWN) - (p_affine_0_0_WHITE_DOWN - p_affine_2_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_1_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_3_2_WHITE_DOWN) + (p_affine_0_0_WHITE_DOWN - p_affine_2_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_3_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_1_2_WHITE_DOWN) + (p_affine_0_0_WHITE_DOWN - p_affine_3_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_1_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_2_2_WHITE_DOWN) - (p_affine_0_0_WHITE_DOWN - p_affine_3_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_2_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_1_2_WHITE_DOWN)), 0.076241779079863126*abs((p_affine_0_0_WHITE_DOWN - p_affine_1_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_2_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_3_2_WHITE_DOWN) - (p_affine_0_0_WHITE_DOWN - p_affine_1_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_3_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_2_2_WHITE_DOWN) - (p_affine_0_0_WHITE_DOWN - p_affine_2_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_1_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_3_2_WHITE_DOWN) + (p_affine_0_0_WHITE_DOWN - p_affine_2_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_3_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_1_2_WHITE_DOWN) + (p_affine_0_0_WHITE_DOWN - p_affine_3_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_1_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_2_2_WHITE_DOWN) - (p_affine_0_0_WHITE_DOWN - p_affine_3_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_2_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_1_2_WHITE_DOWN)), 0.00013249910677232994*abs((p_affine_0_0_WHITE_DOWN - p_affine_1_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_2_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_3_2_WHITE_DOWN) - (p_affine_0_0_WHITE_DOWN - p_affine_1_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_3_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_2_2_WHITE_DOWN) - (p_affine_0_0_WHITE_DOWN - p_affine_2_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_1_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_3_2_WHITE_DOWN) + (p_affine_0_0_WHITE_DOWN - p_affine_2_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_3_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_1_2_WHITE_DOWN) + (p_affine_0_0_WHITE_DOWN - p_affine_3_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_1_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_2_2_WHITE_DOWN) - (p_affine_0_0_WHITE_DOWN - p_affine_3_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_2_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_1_2_WHITE_DOWN)), 0.15197152472496969*abs((p_affine_0_0_WHITE_DOWN - p_affine_1_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_2_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_3_2_WHITE_DOWN) - (p_affine_0_0_WHITE_DOWN - p_affine_1_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_3_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_2_2_WHITE_DOWN) - (p_affine_0_0_WHITE_DOWN - p_affine_2_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_1_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_3_2_WHITE_DOWN) + (p_affine_0_0_WHITE_DOWN - p_affine_2_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_3_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_1_2_WHITE_DOWN) + (p_affine_0_0_WHITE_DOWN - p_affine_3_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_1_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_2_2_WHITE_DOWN) - (p_affine_0_0_WHITE_DOWN - p_affine_3_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_2_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_1_2_WHITE_DOWN)), 0.046689023249274604*abs((p_affine_0_0_WHITE_DOWN - p_affine_1_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_2_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_3_2_WHITE_DOWN) - (p_affine_0_0_WHITE_DOWN - p_affine_1_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_3_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_2_2_WHITE_DOWN) - (p_affine_0_0_WHITE_DOWN - p_affine_2_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_1_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_3_2_WHITE_DOWN) + (p_affine_0_0_WHITE_DOWN - p_affine_2_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_3_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_1_2_WHITE_DOWN) + (p_affine_0_0_WHITE_DOWN - p_affine_3_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_1_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_2_2_WHITE_DOWN) - (p_affine_0_0_WHITE_DOWN - p_affine_3_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_2_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_1_2_WHITE_DOWN)), 8.1139946513070487e-5*abs((p_affine_0_0_WHITE_DOWN - p_affine_1_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_2_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_3_2_WHITE_DOWN) - (p_affine_0_0_WHITE_DOWN - p_affine_1_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_3_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_2_2_WHITE_DOWN) - (p_affine_0_0_WHITE_DOWN - p_affine_2_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_1_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_3_2_WHITE_DOWN) + (p_affine_0_0_WHITE_DOWN - p_affine_2_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_3_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_1_2_WHITE_DOWN) + (p_affine_0_0_WHITE_DOWN - p_affine_3_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_1_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_2_2_WHITE_DOWN) - (p_affine_0_0_WHITE_DOWN - p_affine_3_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_2_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_1_2_WHITE_DOWN)), 0.093064486909197122*abs((p_affine_0_0_WHITE_DOWN - p_affine_1_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_2_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_3_2_WHITE_DOWN) - (p_affine_0_0_WHITE_DOWN - p_affine_1_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_3_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_2_2_WHITE_DOWN) - (p_affine_0_0_WHITE_DOWN - p_affine_2_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_1_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_3_2_WHITE_DOWN) + (p_affine_0_0_WHITE_DOWN - p_affine_2_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_3_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_1_2_WHITE_DOWN) + (p_affine_0_0_WHITE_DOWN - p_affine_3_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_1_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_2_2_WHITE_DOWN) - (p_affine_0_0_WHITE_DOWN - p_affine_3_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_2_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_1_2_WHITE_DOWN)), 1.4101153680155925e-7*abs((p_affine_0_0_WHITE_DOWN - p_affine_1_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_2_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_3_2_WHITE_DOWN) - (p_affine_0_0_WHITE_DOWN - p_affine_1_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_3_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_2_2_WHITE_DOWN) - (p_affine_0_0_WHITE_DOWN - p_affine_2_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_1_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_3_2_WHITE_DOWN) + (p_affine_0_0_WHITE_DOWN - p_affine_2_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_3_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_1_2_WHITE_DOWN) + (p_affine_0_0_WHITE_DOWN - p_affine_3_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_1_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_2_2_WHITE_DOWN) - (p_affine_0_0_WHITE_DOWN - p_affine_3_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_2_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_1_2_WHITE_DOWN)), 0.00016173496390708763*abs((p_affine_0_0_WHITE_DOWN - p_affine_1_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_2_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_3_2_WHITE_DOWN) - (p_affine_0_0_WHITE_DOWN - p_affine_1_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_3_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_2_2_WHITE_DOWN) - (p_affine_0_0_WHITE_DOWN - p_affine_2_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_1_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_3_2_WHITE_DOWN) + (p_affine_0_0_WHITE_DOWN - p_affine_2_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_3_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_1_2_WHITE_DOWN) + (p_affine_0_0_WHITE_DOWN - p_affine_3_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_1_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_2_2_WHITE_DOWN) - (p_affine_0_0_WHITE_DOWN - p_affine_3_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_2_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_1_2_WHITE_DOWN)), 0.18550396047976195*abs((p_affine_0_0_WHITE_DOWN - p_affine_1_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_2_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_3_2_WHITE_DOWN) - (p_affine_0_0_WHITE_DOWN - p_affine_1_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_3_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_2_2_WHITE_DOWN) - (p_affine_0_0_WHITE_DOWN - p_affine_2_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_1_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_3_2_WHITE_DOWN) + (p_affine_0_0_WHITE_DOWN - p_affine_2_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_3_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_1_2_WHITE_DOWN) + (p_affine_0_0_WHITE_DOWN - p_affine_3_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_1_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_2_2_WHITE_DOWN) - (p_affine_0_0_WHITE_DOWN - p_affine_3_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_2_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_1_2_WHITE_DOWN)), 0.00021985802016328927*abs((p_affine_0_0_WHITE_DOWN - p_affine_1_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_2_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_3_2_WHITE_DOWN) - (p_affine_0_0_WHITE_DOWN - p_affine_1_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_3_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_2_2_WHITE_DOWN) - (p_affine_0_0_WHITE_DOWN - p_affine_2_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_1_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_3_2_WHITE_DOWN) + (p_affine_0_0_WHITE_DOWN - p_affine_2_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_3_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_1_2_WHITE_DOWN) + (p_affine_0_0_WHITE_DOWN - p_affine_3_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_1_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_2_2_WHITE_DOWN) - (p_affine_0_0_WHITE_DOWN - p_affine_3_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_2_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_1_2_WHITE_DOWN)), 0.012181957275462504*abs((p_affine_0_0_WHITE_DOWN - p_affine_1_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_2_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_3_2_WHITE_DOWN) - (p_affine_0_0_WHITE_DOWN - p_affine_1_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_3_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_2_2_WHITE_DOWN) - (p_affine_0_0_WHITE_DOWN - p_affine_2_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_1_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_3_2_WHITE_DOWN) + (p_affine_0_0_WHITE_DOWN - p_affine_2_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_3_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_1_2_WHITE_DOWN) + (p_affine_0_0_WHITE_DOWN - p_affine_3_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_1_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_2_2_WHITE_DOWN) - (p_affine_0_0_WHITE_DOWN - p_affine_3_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_2_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_1_2_WHITE_DOWN)), 0.0018336830929379926*abs((p_affine_0_0_WHITE_DOWN - p_affine_1_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_2_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_3_2_WHITE_DOWN) - (p_affine_0_0_WHITE_DOWN - p_affine_1_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_3_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_2_2_WHITE_DOWN) - (p_affine_0_0_WHITE_DOWN - p_affine_2_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_1_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_3_2_WHITE_DOWN) + (p_affine_0_0_WHITE_DOWN - p_affine_2_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_3_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_1_2_WHITE_DOWN) + (p_affine_0_0_WHITE_DOWN - p_affine_3_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_1_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_2_2_WHITE_DOWN) - (p_affine_0_0_WHITE_DOWN - p_affine_3_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_2_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_1_2_WHITE_DOWN)), 0.00059211167385993745*abs((p_affine_0_0_WHITE_DOWN - p_affine_1_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_2_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_3_2_WHITE_DOWN) - (p_affine_0_0_WHITE_DOWN - p_affine_1_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_3_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_2_2_WHITE_DOWN) - (p_affine_0_0_WHITE_DOWN - p_affine_2_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_1_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_3_2_WHITE_DOWN) + (p_affine_0_0_WHITE_DOWN - p_affine_2_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_3_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_1_2_WHITE_DOWN) + (p_affine_0_0_WHITE_DOWN - p_affine_3_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_1_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_2_2_WHITE_DOWN) - (p_affine_0_0_WHITE_DOWN - p_affine_3_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_2_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_1_2_WHITE_DOWN)), 0.67498144007199112*abs((p_affine_0_0_WHITE_DOWN - p_affine_1_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_2_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_3_2_WHITE_DOWN) - (p_affine_0_0_WHITE_DOWN - p_affine_1_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_3_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_2_2_WHITE_DOWN) - (p_affine_0_0_WHITE_DOWN - p_affine_2_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_1_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_3_2_WHITE_DOWN) + (p_affine_0_0_WHITE_DOWN - p_affine_2_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_3_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_1_2_WHITE_DOWN) + (p_affine_0_0_WHITE_DOWN - p_affine_3_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_1_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_2_2_WHITE_DOWN) - (p_affine_0_0_WHITE_DOWN - p_affine_3_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_2_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_1_2_WHITE_DOWN)), 0.10160124737918669*abs((p_affine_0_0_WHITE_DOWN - p_affine_1_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_2_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_3_2_WHITE_DOWN) - (p_affine_0_0_WHITE_DOWN - p_affine_1_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_3_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_2_2_WHITE_DOWN) - (p_affine_0_0_WHITE_DOWN - p_affine_2_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_1_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_3_2_WHITE_DOWN) + (p_affine_0_0_WHITE_DOWN - p_affine_2_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_3_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_1_2_WHITE_DOWN) + (p_affine_0_0_WHITE_DOWN - p_affine_3_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_1_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_2_2_WHITE_DOWN) - (p_affine_0_0_WHITE_DOWN - p_affine_3_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_2_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_1_2_WHITE_DOWN)), 0.032807896240979378*abs((p_affine_0_0_WHITE_DOWN - p_affine_1_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_2_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_3_2_WHITE_DOWN) - (p_affine_0_0_WHITE_DOWN - p_affine_1_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_3_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_2_2_WHITE_DOWN) - (p_affine_0_0_WHITE_DOWN - p_affine_2_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_1_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_3_2_WHITE_DOWN) + (p_affine_0_0_WHITE_DOWN - p_affine_2_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_3_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_1_2_WHITE_DOWN) + (p_affine_0_0_WHITE_DOWN - p_affine_3_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_1_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_2_2_WHITE_DOWN) - (p_affine_0_0_WHITE_DOWN - p_affine_3_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_2_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_1_2_WHITE_DOWN)), 0.015293477503478755*abs((p_affine_0_0_WHITE_DOWN - p_affine_1_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_2_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_3_2_WHITE_DOWN) - (p_affine_0_0_WHITE_DOWN - p_affine_1_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_3_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_2_2_WHITE_DOWN) - (p_affine_0_0_WHITE_DOWN - p_affine_2_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_1_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_3_2_WHITE_DOWN) + (p_affine_0_0_WHITE_DOWN - p_affine_2_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_3_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_1_2_WHITE_DOWN) + (p_affine_0_0_WHITE_DOWN - p_affine_3_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_1_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_2_2_WHITE_DOWN) - (p_affine_0_0_WHITE_DOWN - p_affine_3_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_2_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_1_2_WHITE_DOWN)), 0.0049383923528547903*abs((p_affine_0_0_WHITE_DOWN - p_affine_1_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_2_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_3_2_WHITE_DOWN) - (p_affine_0_0_WHITE_DOWN - p_affine_1_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_3_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_2_2_WHITE_DOWN) - (p_affine_0_0_WHITE_DOWN - p_affine_2_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_1_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_3_2_WHITE_DOWN) + (p_affine_0_0_WHITE_DOWN - p_affine_2_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_3_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_1_2_WHITE_DOWN) + (p_affine_0_0_WHITE_DOWN - p_affine_3_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_1_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_2_2_WHITE_DOWN) - (p_affine_0_0_WHITE_DOWN - p_affine_3_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_2_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_1_2_WHITE_DOWN)), 0.0015946483738042757*abs((p_affine_0_0_WHITE_DOWN - p_affine_1_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_2_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_3_2_WHITE_DOWN) - (p_affine_0_0_WHITE_DOWN - p_affine_1_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_3_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_2_2_WHITE_DOWN) - (p_affine_0_0_WHITE_DOWN - p_affine_2_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_1_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_3_2_WHITE_DOWN) + (p_affine_0_0_WHITE_DOWN - p_affine_2_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_3_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_1_2_WHITE_DOWN) + (p_affine_0_0_WHITE_DOWN - p_affine_3_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_1_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_2_2_WHITE_DOWN) - (p_affine_0_0_WHITE_DOWN - p_affine_3_0_WHITE_DOWN)*(p_affine_0_1_WHITE_DOWN - p_affine_2_1_WHITE_DOWN)*(p_affine_0_2_WHITE_DOWN - p_affine_1_2_WHITE_DOWN))};
      
          for (int64_t ctr_2 = 0; ctr_2 < micro_edges_per_macro_edge; ctr_2 += 1)
          for (int64_t ctr_1 = 0; ctr_1 < -ctr_2 + micro_edges_per_macro_edge; ctr_1 += 1)
          {
             for (int64_t ctr_0 = 0; ctr_0 < (int64_t)((-ctr_1 - ctr_2 + micro_edges_per_macro_edge - 2) / (4)) * (4); ctr_0 += 4)
             {
                __m256d q_acc_0_0 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_1 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_2 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_3 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                for (int64_t q = 0; q < 4; q += 1)
                {
                   const real_t q_tmp_0_0 = _data_phi_psi_det_jac_aff_0_WHITE_DOWN[10*q]*_data_q_w[q];
                   const real_t q_tmp_1_1 = _data_phi_psi_det_jac_aff_0_WHITE_DOWN[10*q + 4]*_data_q_w[q];
                   const real_t q_tmp_2_2 = _data_phi_psi_det_jac_aff_0_WHITE_DOWN[10*q + 7]*_data_q_w[q];
                   const real_t q_tmp_3_3 = _data_phi_psi_det_jac_aff_0_WHITE_DOWN[10*q + 9]*_data_q_w[q];
                   q_acc_0_0 = _mm256_add_pd(_mm256_set_pd(q_tmp_0_0,q_tmp_0_0,q_tmp_0_0,q_tmp_0_0),q_acc_0_0);
                   q_acc_1_1 = _mm256_add_pd(_mm256_set_pd(q_tmp_1_1,q_tmp_1_1,q_tmp_1_1,q_tmp_1_1),q_acc_1_1);
                   q_acc_2_2 = _mm256_add_pd(_mm256_set_pd(q_tmp_2_2,q_tmp_2_2,q_tmp_2_2,q_tmp_2_2),q_acc_2_2);
                   q_acc_3_3 = _mm256_add_pd(_mm256_set_pd(q_tmp_3_3,q_tmp_3_3,q_tmp_3_3,q_tmp_3_3),q_acc_3_3);
                }
                const __m256d elMatDiag_0 = q_acc_0_0;
                const __m256d elMatDiag_1 = q_acc_1_1;
                const __m256d elMatDiag_2 = q_acc_2_2;
                const __m256d elMatDiag_3 = q_acc_3_3;
                _mm256_storeu_pd(&_data_invDiag_[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatDiag_0,_mm256_loadu_pd(& _data_invDiag_[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatDiag_1,_mm256_loadu_pd(& _data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_invDiag_[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatDiag_2,_mm256_loadu_pd(& _data_invDiag_[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag_[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatDiag_3,_mm256_loadu_pd(& _data_invDiag_[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1])));
             }
             for (int64_t ctr_0 = (int64_t)((-ctr_1 - ctr_2 + micro_edges_per_macro_edge - 2) / (4)) * (4); ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge - 2; ctr_0 += 1)
             {
                real_t q_acc_0_0 = 0.0;
                real_t q_acc_1_1 = 0.0;
                real_t q_acc_2_2 = 0.0;
                real_t q_acc_3_3 = 0.0;
                for (int64_t q = 0; q < 4; q += 1)
                {
                   const real_t q_tmp_0_0 = _data_phi_psi_det_jac_aff_0_WHITE_DOWN[10*q]*_data_q_w[q];
                   const real_t q_tmp_1_1 = _data_phi_psi_det_jac_aff_0_WHITE_DOWN[10*q + 4]*_data_q_w[q];
                   const real_t q_tmp_2_2 = _data_phi_psi_det_jac_aff_0_WHITE_DOWN[10*q + 7]*_data_q_w[q];
                   const real_t q_tmp_3_3 = _data_phi_psi_det_jac_aff_0_WHITE_DOWN[10*q + 9]*_data_q_w[q];
                   q_acc_0_0 = q_acc_0_0 + q_tmp_0_0;
                   q_acc_1_1 = q_acc_1_1 + q_tmp_1_1;
                   q_acc_2_2 = q_acc_2_2 + q_tmp_2_2;
                   q_acc_3_3 = q_acc_3_3 + q_tmp_3_3;
                }
                const real_t elMatDiag_0 = q_acc_0_0;
                const real_t elMatDiag_1 = q_acc_1_1;
                const real_t elMatDiag_2 = q_acc_2_2;
                const real_t elMatDiag_3 = q_acc_3_3;
                _data_invDiag_[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatDiag_0 + _data_invDiag_[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatDiag_1 + _data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_invDiag_[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatDiag_2 + _data_invDiag_[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                _data_invDiag_[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatDiag_3 + _data_invDiag_[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             }
          }
       }
       const real_t tmp_0_BLUE_UP = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t tmp_1_BLUE_UP = macro_vertex_coord_id_0comp0 + tmp_0_BLUE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const real_t tmp_2_BLUE_UP = macro_vertex_coord_id_0comp1 + tmp_0_BLUE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const real_t tmp_3_BLUE_UP = macro_vertex_coord_id_0comp2 + tmp_0_BLUE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2);
       const real_t tmp_4_BLUE_UP = tmp_0_BLUE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t tmp_5_BLUE_UP = tmp_0_BLUE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t tmp_6_BLUE_UP = tmp_0_BLUE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const real_t p_affine_0_0_BLUE_UP = tmp_1_BLUE_UP;
       const real_t p_affine_0_1_BLUE_UP = tmp_2_BLUE_UP;
       const real_t p_affine_0_2_BLUE_UP = tmp_3_BLUE_UP;
       const real_t p_affine_1_0_BLUE_UP = macro_vertex_coord_id_0comp0 + tmp_4_BLUE_UP;
       const real_t p_affine_1_1_BLUE_UP = macro_vertex_coord_id_0comp1 + tmp_5_BLUE_UP;
       const real_t p_affine_1_2_BLUE_UP = macro_vertex_coord_id_0comp2 + tmp_6_BLUE_UP;
       const real_t p_affine_2_0_BLUE_UP = tmp_1_BLUE_UP + tmp_4_BLUE_UP;
       const real_t p_affine_2_1_BLUE_UP = tmp_2_BLUE_UP + tmp_5_BLUE_UP;
       const real_t p_affine_2_2_BLUE_UP = tmp_3_BLUE_UP + tmp_6_BLUE_UP;
       const real_t p_affine_3_0_BLUE_UP = tmp_0_BLUE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0) + tmp_1_BLUE_UP;
       const real_t p_affine_3_1_BLUE_UP = tmp_0_BLUE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1) + tmp_2_BLUE_UP;
       const real_t p_affine_3_2_BLUE_UP = tmp_0_BLUE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2) + tmp_3_BLUE_UP;
       {
          /* CellType.BLUE_UP */
          const real_t _data_phi_psi_det_jac_aff_0_BLUE_UP [] = {0.20046443821120821*abs((p_affine_0_0_BLUE_UP - p_affine_1_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_2_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_3_2_BLUE_UP) - (p_affine_0_0_BLUE_UP - p_affine_1_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_3_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_2_2_BLUE_UP) - (p_affine_0_0_BLUE_UP - p_affine_2_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_1_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_3_2_BLUE_UP) + (p_affine_0_0_BLUE_UP - p_affine_2_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_3_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_1_2_BLUE_UP) + (p_affine_0_0_BLUE_UP - p_affine_3_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_1_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_2_2_BLUE_UP) - (p_affine_0_0_BLUE_UP - p_affine_3_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_2_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_1_2_BLUE_UP)), 0.080605154129423817*abs((p_affine_0_0_BLUE_UP - p_affine_1_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_2_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_3_2_BLUE_UP) - (p_affine_0_0_BLUE_UP - p_affine_1_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_3_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_2_2_BLUE_UP) - (p_affine_0_0_BLUE_UP - p_affine_2_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_1_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_3_2_BLUE_UP) + (p_affine_0_0_BLUE_UP - p_affine_2_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_3_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_1_2_BLUE_UP) + (p_affine_0_0_BLUE_UP - p_affine_3_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_1_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_2_2_BLUE_UP) - (p_affine_0_0_BLUE_UP - p_affine_3_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_2_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_1_2_BLUE_UP)), 0.16356320182856121*abs((p_affine_0_0_BLUE_UP - p_affine_1_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_2_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_3_2_BLUE_UP) - (p_affine_0_0_BLUE_UP - p_affine_1_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_3_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_2_2_BLUE_UP) - (p_affine_0_0_BLUE_UP - p_affine_2_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_1_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_3_2_BLUE_UP) + (p_affine_0_0_BLUE_UP - p_affine_2_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_3_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_1_2_BLUE_UP) + (p_affine_0_0_BLUE_UP - p_affine_3_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_1_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_2_2_BLUE_UP) - (p_affine_0_0_BLUE_UP - p_affine_3_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_2_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_1_2_BLUE_UP)), 0.0030997579321792282*abs((p_affine_0_0_BLUE_UP - p_affine_1_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_2_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_3_2_BLUE_UP) - (p_affine_0_0_BLUE_UP - p_affine_1_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_3_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_2_2_BLUE_UP) - (p_affine_0_0_BLUE_UP - p_affine_2_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_1_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_3_2_BLUE_UP) + (p_affine_0_0_BLUE_UP - p_affine_2_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_3_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_1_2_BLUE_UP) + (p_affine_0_0_BLUE_UP - p_affine_3_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_1_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_2_2_BLUE_UP) - (p_affine_0_0_BLUE_UP - p_affine_3_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_2_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_1_2_BLUE_UP)), 0.032410690545436126*abs((p_affine_0_0_BLUE_UP - p_affine_1_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_2_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_3_2_BLUE_UP) - (p_affine_0_0_BLUE_UP - p_affine_1_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_3_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_2_2_BLUE_UP) - (p_affine_0_0_BLUE_UP - p_affine_2_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_1_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_3_2_BLUE_UP) + (p_affine_0_0_BLUE_UP - p_affine_2_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_3_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_1_2_BLUE_UP) + (p_affine_0_0_BLUE_UP - p_affine_3_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_1_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_2_2_BLUE_UP) - (p_affine_0_0_BLUE_UP - p_affine_3_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_2_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_1_2_BLUE_UP)), 0.065767460857085305*abs((p_affine_0_0_BLUE_UP - p_affine_1_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_2_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_3_2_BLUE_UP) - (p_affine_0_0_BLUE_UP - p_affine_1_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_3_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_2_2_BLUE_UP) - (p_affine_0_0_BLUE_UP - p_affine_2_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_1_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_3_2_BLUE_UP) + (p_affine_0_0_BLUE_UP - p_affine_2_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_3_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_1_2_BLUE_UP) + (p_affine_0_0_BLUE_UP - p_affine_3_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_1_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_2_2_BLUE_UP) - (p_affine_0_0_BLUE_UP - p_affine_3_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_2_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_1_2_BLUE_UP)), 0.0012463879784202093*abs((p_affine_0_0_BLUE_UP - p_affine_1_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_2_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_3_2_BLUE_UP) - (p_affine_0_0_BLUE_UP - p_affine_1_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_3_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_2_2_BLUE_UP) - (p_affine_0_0_BLUE_UP - p_affine_2_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_1_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_3_2_BLUE_UP) + (p_affine_0_0_BLUE_UP - p_affine_2_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_3_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_1_2_BLUE_UP) + (p_affine_0_0_BLUE_UP - p_affine_3_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_1_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_2_2_BLUE_UP) - (p_affine_0_0_BLUE_UP - p_affine_3_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_2_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_1_2_BLUE_UP)), 0.13345469765676804*abs((p_affine_0_0_BLUE_UP - p_affine_1_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_2_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_3_2_BLUE_UP) - (p_affine_0_0_BLUE_UP - p_affine_1_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_3_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_2_2_BLUE_UP) - (p_affine_0_0_BLUE_UP - p_affine_2_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_1_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_3_2_BLUE_UP) + (p_affine_0_0_BLUE_UP - p_affine_2_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_3_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_1_2_BLUE_UP) + (p_affine_0_0_BLUE_UP - p_affine_3_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_1_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_2_2_BLUE_UP) - (p_affine_0_0_BLUE_UP - p_affine_3_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_2_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_1_2_BLUE_UP)), 0.002529158472220073*abs((p_affine_0_0_BLUE_UP - p_affine_1_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_2_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_3_2_BLUE_UP) - (p_affine_0_0_BLUE_UP - p_affine_1_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_3_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_2_2_BLUE_UP) - (p_affine_0_0_BLUE_UP - p_affine_2_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_1_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_3_2_BLUE_UP) + (p_affine_0_0_BLUE_UP - p_affine_2_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_3_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_1_2_BLUE_UP) + (p_affine_0_0_BLUE_UP - p_affine_3_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_1_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_2_2_BLUE_UP) - (p_affine_0_0_BLUE_UP - p_affine_3_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_2_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_1_2_BLUE_UP)), 4.793119080794062e-5*abs((p_affine_0_0_BLUE_UP - p_affine_1_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_2_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_3_2_BLUE_UP) - (p_affine_0_0_BLUE_UP - p_affine_1_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_3_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_2_2_BLUE_UP) - (p_affine_0_0_BLUE_UP - p_affine_2_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_1_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_3_2_BLUE_UP) + (p_affine_0_0_BLUE_UP - p_affine_2_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_3_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_1_2_BLUE_UP) + (p_affine_0_0_BLUE_UP - p_affine_3_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_1_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_2_2_BLUE_UP) - (p_affine_0_0_BLUE_UP - p_affine_3_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_2_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_1_2_BLUE_UP)), 2.3424983832091605e-5*abs((p_affine_0_0_BLUE_UP - p_affine_1_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_2_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_3_2_BLUE_UP) - (p_affine_0_0_BLUE_UP - p_affine_1_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_3_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_2_2_BLUE_UP) - (p_affine_0_0_BLUE_UP - p_affine_2_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_1_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_3_2_BLUE_UP) + (p_affine_0_0_BLUE_UP - p_affine_2_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_3_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_1_2_BLUE_UP) + (p_affine_0_0_BLUE_UP - p_affine_3_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_1_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_2_2_BLUE_UP) - (p_affine_0_0_BLUE_UP - p_affine_3_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_2_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_1_2_BLUE_UP)), 0.00075470637742922845*abs((p_affine_0_0_BLUE_UP - p_affine_1_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_2_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_3_2_BLUE_UP) - (p_affine_0_0_BLUE_UP - p_affine_1_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_3_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_2_2_BLUE_UP) - (p_affine_0_0_BLUE_UP - p_affine_2_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_1_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_3_2_BLUE_UP) + (p_affine_0_0_BLUE_UP - p_affine_2_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_3_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_1_2_BLUE_UP) + (p_affine_0_0_BLUE_UP - p_affine_3_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_1_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_2_2_BLUE_UP) - (p_affine_0_0_BLUE_UP - p_affine_3_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_2_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_1_2_BLUE_UP)), 0.0022140849621758063*abs((p_affine_0_0_BLUE_UP - p_affine_1_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_2_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_3_2_BLUE_UP) - (p_affine_0_0_BLUE_UP - p_affine_1_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_3_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_2_2_BLUE_UP) - (p_affine_0_0_BLUE_UP - p_affine_2_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_1_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_3_2_BLUE_UP) + (p_affine_0_0_BLUE_UP - p_affine_2_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_3_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_1_2_BLUE_UP) + (p_affine_0_0_BLUE_UP - p_affine_3_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_1_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_2_2_BLUE_UP) - (p_affine_0_0_BLUE_UP - p_affine_3_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_2_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_1_2_BLUE_UP)), 0.0018477200224347493*abs((p_affine_0_0_BLUE_UP - p_affine_1_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_2_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_3_2_BLUE_UP) - (p_affine_0_0_BLUE_UP - p_affine_1_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_3_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_2_2_BLUE_UP) - (p_affine_0_0_BLUE_UP - p_affine_2_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_1_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_3_2_BLUE_UP) + (p_affine_0_0_BLUE_UP - p_affine_2_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_3_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_1_2_BLUE_UP) + (p_affine_0_0_BLUE_UP - p_affine_3_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_1_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_2_2_BLUE_UP) - (p_affine_0_0_BLUE_UP - p_affine_3_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_2_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_1_2_BLUE_UP)), 0.024315138068613611*abs((p_affine_0_0_BLUE_UP - p_affine_1_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_2_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_3_2_BLUE_UP) - (p_affine_0_0_BLUE_UP - p_affine_1_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_3_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_2_2_BLUE_UP) - (p_affine_0_0_BLUE_UP - p_affine_2_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_1_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_3_2_BLUE_UP) + (p_affine_0_0_BLUE_UP - p_affine_2_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_3_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_1_2_BLUE_UP) + (p_affine_0_0_BLUE_UP - p_affine_3_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_1_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_2_2_BLUE_UP) - (p_affine_0_0_BLUE_UP - p_affine_3_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_2_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_1_2_BLUE_UP)), 0.071333412782766975*abs((p_affine_0_0_BLUE_UP - p_affine_1_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_2_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_3_2_BLUE_UP) - (p_affine_0_0_BLUE_UP - p_affine_1_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_3_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_2_2_BLUE_UP) - (p_affine_0_0_BLUE_UP - p_affine_2_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_1_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_3_2_BLUE_UP) + (p_affine_0_0_BLUE_UP - p_affine_2_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_3_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_1_2_BLUE_UP) + (p_affine_0_0_BLUE_UP - p_affine_3_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_1_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_2_2_BLUE_UP) - (p_affine_0_0_BLUE_UP - p_affine_3_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_2_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_1_2_BLUE_UP)), 0.059529863270376029*abs((p_affine_0_0_BLUE_UP - p_affine_1_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_2_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_3_2_BLUE_UP) - (p_affine_0_0_BLUE_UP - p_affine_1_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_3_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_2_2_BLUE_UP) - (p_affine_0_0_BLUE_UP - p_affine_2_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_1_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_3_2_BLUE_UP) + (p_affine_0_0_BLUE_UP - p_affine_2_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_3_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_1_2_BLUE_UP) + (p_affine_0_0_BLUE_UP - p_affine_3_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_1_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_2_2_BLUE_UP) - (p_affine_0_0_BLUE_UP - p_affine_3_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_2_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_1_2_BLUE_UP)), 0.20927110365887197*abs((p_affine_0_0_BLUE_UP - p_affine_1_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_2_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_3_2_BLUE_UP) - (p_affine_0_0_BLUE_UP - p_affine_1_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_3_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_2_2_BLUE_UP) - (p_affine_0_0_BLUE_UP - p_affine_2_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_1_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_3_2_BLUE_UP) + (p_affine_0_0_BLUE_UP - p_affine_2_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_3_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_1_2_BLUE_UP) + (p_affine_0_0_BLUE_UP - p_affine_3_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_1_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_2_2_BLUE_UP) - (p_affine_0_0_BLUE_UP - p_affine_3_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_2_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_1_2_BLUE_UP)), 0.17464298568178085*abs((p_affine_0_0_BLUE_UP - p_affine_1_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_2_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_3_2_BLUE_UP) - (p_affine_0_0_BLUE_UP - p_affine_1_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_3_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_2_2_BLUE_UP) - (p_affine_0_0_BLUE_UP - p_affine_2_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_1_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_3_2_BLUE_UP) + (p_affine_0_0_BLUE_UP - p_affine_2_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_3_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_1_2_BLUE_UP) + (p_affine_0_0_BLUE_UP - p_affine_3_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_1_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_2_2_BLUE_UP) - (p_affine_0_0_BLUE_UP - p_affine_3_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_2_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_1_2_BLUE_UP)), 0.14574478709475508*abs((p_affine_0_0_BLUE_UP - p_affine_1_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_2_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_3_2_BLUE_UP) - (p_affine_0_0_BLUE_UP - p_affine_1_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_3_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_2_2_BLUE_UP) - (p_affine_0_0_BLUE_UP - p_affine_2_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_1_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_3_2_BLUE_UP) + (p_affine_0_0_BLUE_UP - p_affine_2_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_3_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_1_2_BLUE_UP) + (p_affine_0_0_BLUE_UP - p_affine_3_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_1_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_2_2_BLUE_UP) - (p_affine_0_0_BLUE_UP - p_affine_3_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_2_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_1_2_BLUE_UP)), 0.12450054579698165*abs((p_affine_0_0_BLUE_UP - p_affine_1_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_2_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_3_2_BLUE_UP) - (p_affine_0_0_BLUE_UP - p_affine_1_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_3_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_2_2_BLUE_UP) - (p_affine_0_0_BLUE_UP - p_affine_2_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_1_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_3_2_BLUE_UP) + (p_affine_0_0_BLUE_UP - p_affine_2_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_3_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_1_2_BLUE_UP) + (p_affine_0_0_BLUE_UP - p_affine_3_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_1_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_2_2_BLUE_UP) - (p_affine_0_0_BLUE_UP - p_affine_3_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_2_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_1_2_BLUE_UP)), 0.076241779079863126*abs((p_affine_0_0_BLUE_UP - p_affine_1_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_2_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_3_2_BLUE_UP) - (p_affine_0_0_BLUE_UP - p_affine_1_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_3_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_2_2_BLUE_UP) - (p_affine_0_0_BLUE_UP - p_affine_2_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_1_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_3_2_BLUE_UP) + (p_affine_0_0_BLUE_UP - p_affine_2_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_3_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_1_2_BLUE_UP) + (p_affine_0_0_BLUE_UP - p_affine_3_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_1_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_2_2_BLUE_UP) - (p_affine_0_0_BLUE_UP - p_affine_3_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_2_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_1_2_BLUE_UP)), 0.00013249910677232994*abs((p_affine_0_0_BLUE_UP - p_affine_1_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_2_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_3_2_BLUE_UP) - (p_affine_0_0_BLUE_UP - p_affine_1_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_3_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_2_2_BLUE_UP) - (p_affine_0_0_BLUE_UP - p_affine_2_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_1_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_3_2_BLUE_UP) + (p_affine_0_0_BLUE_UP - p_affine_2_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_3_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_1_2_BLUE_UP) + (p_affine_0_0_BLUE_UP - p_affine_3_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_1_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_2_2_BLUE_UP) - (p_affine_0_0_BLUE_UP - p_affine_3_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_2_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_1_2_BLUE_UP)), 0.15197152472496969*abs((p_affine_0_0_BLUE_UP - p_affine_1_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_2_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_3_2_BLUE_UP) - (p_affine_0_0_BLUE_UP - p_affine_1_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_3_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_2_2_BLUE_UP) - (p_affine_0_0_BLUE_UP - p_affine_2_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_1_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_3_2_BLUE_UP) + (p_affine_0_0_BLUE_UP - p_affine_2_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_3_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_1_2_BLUE_UP) + (p_affine_0_0_BLUE_UP - p_affine_3_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_1_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_2_2_BLUE_UP) - (p_affine_0_0_BLUE_UP - p_affine_3_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_2_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_1_2_BLUE_UP)), 0.046689023249274604*abs((p_affine_0_0_BLUE_UP - p_affine_1_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_2_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_3_2_BLUE_UP) - (p_affine_0_0_BLUE_UP - p_affine_1_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_3_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_2_2_BLUE_UP) - (p_affine_0_0_BLUE_UP - p_affine_2_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_1_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_3_2_BLUE_UP) + (p_affine_0_0_BLUE_UP - p_affine_2_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_3_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_1_2_BLUE_UP) + (p_affine_0_0_BLUE_UP - p_affine_3_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_1_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_2_2_BLUE_UP) - (p_affine_0_0_BLUE_UP - p_affine_3_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_2_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_1_2_BLUE_UP)), 8.1139946513070487e-5*abs((p_affine_0_0_BLUE_UP - p_affine_1_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_2_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_3_2_BLUE_UP) - (p_affine_0_0_BLUE_UP - p_affine_1_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_3_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_2_2_BLUE_UP) - (p_affine_0_0_BLUE_UP - p_affine_2_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_1_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_3_2_BLUE_UP) + (p_affine_0_0_BLUE_UP - p_affine_2_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_3_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_1_2_BLUE_UP) + (p_affine_0_0_BLUE_UP - p_affine_3_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_1_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_2_2_BLUE_UP) - (p_affine_0_0_BLUE_UP - p_affine_3_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_2_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_1_2_BLUE_UP)), 0.093064486909197122*abs((p_affine_0_0_BLUE_UP - p_affine_1_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_2_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_3_2_BLUE_UP) - (p_affine_0_0_BLUE_UP - p_affine_1_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_3_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_2_2_BLUE_UP) - (p_affine_0_0_BLUE_UP - p_affine_2_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_1_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_3_2_BLUE_UP) + (p_affine_0_0_BLUE_UP - p_affine_2_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_3_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_1_2_BLUE_UP) + (p_affine_0_0_BLUE_UP - p_affine_3_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_1_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_2_2_BLUE_UP) - (p_affine_0_0_BLUE_UP - p_affine_3_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_2_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_1_2_BLUE_UP)), 1.4101153680155925e-7*abs((p_affine_0_0_BLUE_UP - p_affine_1_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_2_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_3_2_BLUE_UP) - (p_affine_0_0_BLUE_UP - p_affine_1_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_3_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_2_2_BLUE_UP) - (p_affine_0_0_BLUE_UP - p_affine_2_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_1_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_3_2_BLUE_UP) + (p_affine_0_0_BLUE_UP - p_affine_2_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_3_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_1_2_BLUE_UP) + (p_affine_0_0_BLUE_UP - p_affine_3_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_1_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_2_2_BLUE_UP) - (p_affine_0_0_BLUE_UP - p_affine_3_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_2_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_1_2_BLUE_UP)), 0.00016173496390708763*abs((p_affine_0_0_BLUE_UP - p_affine_1_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_2_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_3_2_BLUE_UP) - (p_affine_0_0_BLUE_UP - p_affine_1_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_3_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_2_2_BLUE_UP) - (p_affine_0_0_BLUE_UP - p_affine_2_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_1_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_3_2_BLUE_UP) + (p_affine_0_0_BLUE_UP - p_affine_2_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_3_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_1_2_BLUE_UP) + (p_affine_0_0_BLUE_UP - p_affine_3_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_1_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_2_2_BLUE_UP) - (p_affine_0_0_BLUE_UP - p_affine_3_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_2_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_1_2_BLUE_UP)), 0.18550396047976195*abs((p_affine_0_0_BLUE_UP - p_affine_1_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_2_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_3_2_BLUE_UP) - (p_affine_0_0_BLUE_UP - p_affine_1_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_3_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_2_2_BLUE_UP) - (p_affine_0_0_BLUE_UP - p_affine_2_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_1_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_3_2_BLUE_UP) + (p_affine_0_0_BLUE_UP - p_affine_2_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_3_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_1_2_BLUE_UP) + (p_affine_0_0_BLUE_UP - p_affine_3_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_1_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_2_2_BLUE_UP) - (p_affine_0_0_BLUE_UP - p_affine_3_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_2_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_1_2_BLUE_UP)), 0.00021985802016328927*abs((p_affine_0_0_BLUE_UP - p_affine_1_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_2_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_3_2_BLUE_UP) - (p_affine_0_0_BLUE_UP - p_affine_1_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_3_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_2_2_BLUE_UP) - (p_affine_0_0_BLUE_UP - p_affine_2_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_1_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_3_2_BLUE_UP) + (p_affine_0_0_BLUE_UP - p_affine_2_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_3_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_1_2_BLUE_UP) + (p_affine_0_0_BLUE_UP - p_affine_3_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_1_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_2_2_BLUE_UP) - (p_affine_0_0_BLUE_UP - p_affine_3_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_2_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_1_2_BLUE_UP)), 0.012181957275462504*abs((p_affine_0_0_BLUE_UP - p_affine_1_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_2_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_3_2_BLUE_UP) - (p_affine_0_0_BLUE_UP - p_affine_1_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_3_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_2_2_BLUE_UP) - (p_affine_0_0_BLUE_UP - p_affine_2_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_1_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_3_2_BLUE_UP) + (p_affine_0_0_BLUE_UP - p_affine_2_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_3_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_1_2_BLUE_UP) + (p_affine_0_0_BLUE_UP - p_affine_3_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_1_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_2_2_BLUE_UP) - (p_affine_0_0_BLUE_UP - p_affine_3_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_2_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_1_2_BLUE_UP)), 0.0018336830929379926*abs((p_affine_0_0_BLUE_UP - p_affine_1_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_2_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_3_2_BLUE_UP) - (p_affine_0_0_BLUE_UP - p_affine_1_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_3_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_2_2_BLUE_UP) - (p_affine_0_0_BLUE_UP - p_affine_2_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_1_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_3_2_BLUE_UP) + (p_affine_0_0_BLUE_UP - p_affine_2_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_3_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_1_2_BLUE_UP) + (p_affine_0_0_BLUE_UP - p_affine_3_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_1_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_2_2_BLUE_UP) - (p_affine_0_0_BLUE_UP - p_affine_3_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_2_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_1_2_BLUE_UP)), 0.00059211167385993745*abs((p_affine_0_0_BLUE_UP - p_affine_1_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_2_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_3_2_BLUE_UP) - (p_affine_0_0_BLUE_UP - p_affine_1_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_3_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_2_2_BLUE_UP) - (p_affine_0_0_BLUE_UP - p_affine_2_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_1_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_3_2_BLUE_UP) + (p_affine_0_0_BLUE_UP - p_affine_2_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_3_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_1_2_BLUE_UP) + (p_affine_0_0_BLUE_UP - p_affine_3_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_1_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_2_2_BLUE_UP) - (p_affine_0_0_BLUE_UP - p_affine_3_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_2_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_1_2_BLUE_UP)), 0.67498144007199112*abs((p_affine_0_0_BLUE_UP - p_affine_1_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_2_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_3_2_BLUE_UP) - (p_affine_0_0_BLUE_UP - p_affine_1_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_3_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_2_2_BLUE_UP) - (p_affine_0_0_BLUE_UP - p_affine_2_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_1_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_3_2_BLUE_UP) + (p_affine_0_0_BLUE_UP - p_affine_2_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_3_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_1_2_BLUE_UP) + (p_affine_0_0_BLUE_UP - p_affine_3_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_1_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_2_2_BLUE_UP) - (p_affine_0_0_BLUE_UP - p_affine_3_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_2_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_1_2_BLUE_UP)), 0.10160124737918669*abs((p_affine_0_0_BLUE_UP - p_affine_1_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_2_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_3_2_BLUE_UP) - (p_affine_0_0_BLUE_UP - p_affine_1_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_3_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_2_2_BLUE_UP) - (p_affine_0_0_BLUE_UP - p_affine_2_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_1_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_3_2_BLUE_UP) + (p_affine_0_0_BLUE_UP - p_affine_2_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_3_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_1_2_BLUE_UP) + (p_affine_0_0_BLUE_UP - p_affine_3_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_1_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_2_2_BLUE_UP) - (p_affine_0_0_BLUE_UP - p_affine_3_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_2_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_1_2_BLUE_UP)), 0.032807896240979378*abs((p_affine_0_0_BLUE_UP - p_affine_1_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_2_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_3_2_BLUE_UP) - (p_affine_0_0_BLUE_UP - p_affine_1_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_3_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_2_2_BLUE_UP) - (p_affine_0_0_BLUE_UP - p_affine_2_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_1_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_3_2_BLUE_UP) + (p_affine_0_0_BLUE_UP - p_affine_2_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_3_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_1_2_BLUE_UP) + (p_affine_0_0_BLUE_UP - p_affine_3_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_1_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_2_2_BLUE_UP) - (p_affine_0_0_BLUE_UP - p_affine_3_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_2_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_1_2_BLUE_UP)), 0.015293477503478755*abs((p_affine_0_0_BLUE_UP - p_affine_1_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_2_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_3_2_BLUE_UP) - (p_affine_0_0_BLUE_UP - p_affine_1_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_3_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_2_2_BLUE_UP) - (p_affine_0_0_BLUE_UP - p_affine_2_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_1_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_3_2_BLUE_UP) + (p_affine_0_0_BLUE_UP - p_affine_2_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_3_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_1_2_BLUE_UP) + (p_affine_0_0_BLUE_UP - p_affine_3_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_1_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_2_2_BLUE_UP) - (p_affine_0_0_BLUE_UP - p_affine_3_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_2_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_1_2_BLUE_UP)), 0.0049383923528547903*abs((p_affine_0_0_BLUE_UP - p_affine_1_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_2_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_3_2_BLUE_UP) - (p_affine_0_0_BLUE_UP - p_affine_1_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_3_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_2_2_BLUE_UP) - (p_affine_0_0_BLUE_UP - p_affine_2_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_1_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_3_2_BLUE_UP) + (p_affine_0_0_BLUE_UP - p_affine_2_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_3_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_1_2_BLUE_UP) + (p_affine_0_0_BLUE_UP - p_affine_3_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_1_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_2_2_BLUE_UP) - (p_affine_0_0_BLUE_UP - p_affine_3_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_2_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_1_2_BLUE_UP)), 0.0015946483738042757*abs((p_affine_0_0_BLUE_UP - p_affine_1_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_2_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_3_2_BLUE_UP) - (p_affine_0_0_BLUE_UP - p_affine_1_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_3_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_2_2_BLUE_UP) - (p_affine_0_0_BLUE_UP - p_affine_2_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_1_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_3_2_BLUE_UP) + (p_affine_0_0_BLUE_UP - p_affine_2_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_3_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_1_2_BLUE_UP) + (p_affine_0_0_BLUE_UP - p_affine_3_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_1_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_2_2_BLUE_UP) - (p_affine_0_0_BLUE_UP - p_affine_3_0_BLUE_UP)*(p_affine_0_1_BLUE_UP - p_affine_2_1_BLUE_UP)*(p_affine_0_2_BLUE_UP - p_affine_1_2_BLUE_UP))};
      
          for (int64_t ctr_2 = 0; ctr_2 < micro_edges_per_macro_edge; ctr_2 += 1)
          for (int64_t ctr_1 = 0; ctr_1 < -ctr_2 + micro_edges_per_macro_edge; ctr_1 += 1)
          {
             for (int64_t ctr_0 = 0; ctr_0 < (int64_t)((-ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1) / (4)) * (4); ctr_0 += 4)
             {
                __m256d q_acc_0_0 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_1 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_2 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_3 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                for (int64_t q = 0; q < 4; q += 1)
                {
                   const real_t q_tmp_0_0 = _data_phi_psi_det_jac_aff_0_BLUE_UP[10*q]*_data_q_w[q];
                   const real_t q_tmp_1_1 = _data_phi_psi_det_jac_aff_0_BLUE_UP[10*q + 4]*_data_q_w[q];
                   const real_t q_tmp_2_2 = _data_phi_psi_det_jac_aff_0_BLUE_UP[10*q + 7]*_data_q_w[q];
                   const real_t q_tmp_3_3 = _data_phi_psi_det_jac_aff_0_BLUE_UP[10*q + 9]*_data_q_w[q];
                   q_acc_0_0 = _mm256_add_pd(_mm256_set_pd(q_tmp_0_0,q_tmp_0_0,q_tmp_0_0,q_tmp_0_0),q_acc_0_0);
                   q_acc_1_1 = _mm256_add_pd(_mm256_set_pd(q_tmp_1_1,q_tmp_1_1,q_tmp_1_1,q_tmp_1_1),q_acc_1_1);
                   q_acc_2_2 = _mm256_add_pd(_mm256_set_pd(q_tmp_2_2,q_tmp_2_2,q_tmp_2_2,q_tmp_2_2),q_acc_2_2);
                   q_acc_3_3 = _mm256_add_pd(_mm256_set_pd(q_tmp_3_3,q_tmp_3_3,q_tmp_3_3,q_tmp_3_3),q_acc_3_3);
                }
                const __m256d elMatDiag_0 = q_acc_0_0;
                const __m256d elMatDiag_1 = q_acc_1_1;
                const __m256d elMatDiag_2 = q_acc_2_2;
                const __m256d elMatDiag_3 = q_acc_3_3;
                _mm256_storeu_pd(&_data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatDiag_0,_mm256_loadu_pd(& _data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_invDiag_[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatDiag_1,_mm256_loadu_pd(& _data_invDiag_[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag_[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatDiag_2,_mm256_loadu_pd(& _data_invDiag_[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatDiag_3,_mm256_loadu_pd(& _data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1])));
             }
             for (int64_t ctr_0 = (int64_t)((-ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1) / (4)) * (4); ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1; ctr_0 += 1)
             {
                real_t q_acc_0_0 = 0.0;
                real_t q_acc_1_1 = 0.0;
                real_t q_acc_2_2 = 0.0;
                real_t q_acc_3_3 = 0.0;
                for (int64_t q = 0; q < 4; q += 1)
                {
                   const real_t q_tmp_0_0 = _data_phi_psi_det_jac_aff_0_BLUE_UP[10*q]*_data_q_w[q];
                   const real_t q_tmp_1_1 = _data_phi_psi_det_jac_aff_0_BLUE_UP[10*q + 4]*_data_q_w[q];
                   const real_t q_tmp_2_2 = _data_phi_psi_det_jac_aff_0_BLUE_UP[10*q + 7]*_data_q_w[q];
                   const real_t q_tmp_3_3 = _data_phi_psi_det_jac_aff_0_BLUE_UP[10*q + 9]*_data_q_w[q];
                   q_acc_0_0 = q_acc_0_0 + q_tmp_0_0;
                   q_acc_1_1 = q_acc_1_1 + q_tmp_1_1;
                   q_acc_2_2 = q_acc_2_2 + q_tmp_2_2;
                   q_acc_3_3 = q_acc_3_3 + q_tmp_3_3;
                }
                const real_t elMatDiag_0 = q_acc_0_0;
                const real_t elMatDiag_1 = q_acc_1_1;
                const real_t elMatDiag_2 = q_acc_2_2;
                const real_t elMatDiag_3 = q_acc_3_3;
                _data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatDiag_0 + _data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_invDiag_[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatDiag_1 + _data_invDiag_[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                _data_invDiag_[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatDiag_2 + _data_invDiag_[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatDiag_3 + _data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             }
          }
       }
       const real_t tmp_0_BLUE_DOWN = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t tmp_1_BLUE_DOWN = macro_vertex_coord_id_0comp0 + tmp_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t tmp_2_BLUE_DOWN = macro_vertex_coord_id_0comp1 + tmp_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t tmp_3_BLUE_DOWN = macro_vertex_coord_id_0comp2 + tmp_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const real_t tmp_4_BLUE_DOWN = tmp_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0);
       const real_t tmp_5_BLUE_DOWN = macro_vertex_coord_id_0comp0 + tmp_4_BLUE_DOWN;
       const real_t tmp_6_BLUE_DOWN = tmp_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1);
       const real_t tmp_7_BLUE_DOWN = macro_vertex_coord_id_0comp1 + tmp_6_BLUE_DOWN;
       const real_t tmp_8_BLUE_DOWN = tmp_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2);
       const real_t tmp_9_BLUE_DOWN = macro_vertex_coord_id_0comp2 + tmp_8_BLUE_DOWN;
       const real_t p_affine_0_0_BLUE_DOWN = tmp_1_BLUE_DOWN;
       const real_t p_affine_0_1_BLUE_DOWN = tmp_2_BLUE_DOWN;
       const real_t p_affine_0_2_BLUE_DOWN = tmp_3_BLUE_DOWN;
       const real_t p_affine_1_0_BLUE_DOWN = tmp_5_BLUE_DOWN;
       const real_t p_affine_1_1_BLUE_DOWN = tmp_7_BLUE_DOWN;
       const real_t p_affine_1_2_BLUE_DOWN = tmp_9_BLUE_DOWN;
       const real_t p_affine_2_0_BLUE_DOWN = tmp_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0) + tmp_5_BLUE_DOWN;
       const real_t p_affine_2_1_BLUE_DOWN = tmp_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1) + tmp_7_BLUE_DOWN;
       const real_t p_affine_2_2_BLUE_DOWN = tmp_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2) + tmp_9_BLUE_DOWN;
       const real_t p_affine_3_0_BLUE_DOWN = tmp_1_BLUE_DOWN + tmp_4_BLUE_DOWN;
       const real_t p_affine_3_1_BLUE_DOWN = tmp_2_BLUE_DOWN + tmp_6_BLUE_DOWN;
       const real_t p_affine_3_2_BLUE_DOWN = tmp_3_BLUE_DOWN + tmp_8_BLUE_DOWN;
       {
          /* CellType.BLUE_DOWN */
          const real_t _data_phi_psi_det_jac_aff_0_BLUE_DOWN [] = {0.20046443821120821*abs((p_affine_0_0_BLUE_DOWN - p_affine_1_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_2_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_3_2_BLUE_DOWN) - (p_affine_0_0_BLUE_DOWN - p_affine_1_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_3_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_2_2_BLUE_DOWN) - (p_affine_0_0_BLUE_DOWN - p_affine_2_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_1_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_3_2_BLUE_DOWN) + (p_affine_0_0_BLUE_DOWN - p_affine_2_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_3_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_1_2_BLUE_DOWN) + (p_affine_0_0_BLUE_DOWN - p_affine_3_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_1_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_2_2_BLUE_DOWN) - (p_affine_0_0_BLUE_DOWN - p_affine_3_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_2_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_1_2_BLUE_DOWN)), 0.080605154129423817*abs((p_affine_0_0_BLUE_DOWN - p_affine_1_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_2_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_3_2_BLUE_DOWN) - (p_affine_0_0_BLUE_DOWN - p_affine_1_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_3_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_2_2_BLUE_DOWN) - (p_affine_0_0_BLUE_DOWN - p_affine_2_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_1_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_3_2_BLUE_DOWN) + (p_affine_0_0_BLUE_DOWN - p_affine_2_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_3_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_1_2_BLUE_DOWN) + (p_affine_0_0_BLUE_DOWN - p_affine_3_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_1_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_2_2_BLUE_DOWN) - (p_affine_0_0_BLUE_DOWN - p_affine_3_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_2_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_1_2_BLUE_DOWN)), 0.16356320182856121*abs((p_affine_0_0_BLUE_DOWN - p_affine_1_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_2_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_3_2_BLUE_DOWN) - (p_affine_0_0_BLUE_DOWN - p_affine_1_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_3_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_2_2_BLUE_DOWN) - (p_affine_0_0_BLUE_DOWN - p_affine_2_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_1_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_3_2_BLUE_DOWN) + (p_affine_0_0_BLUE_DOWN - p_affine_2_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_3_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_1_2_BLUE_DOWN) + (p_affine_0_0_BLUE_DOWN - p_affine_3_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_1_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_2_2_BLUE_DOWN) - (p_affine_0_0_BLUE_DOWN - p_affine_3_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_2_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_1_2_BLUE_DOWN)), 0.0030997579321792282*abs((p_affine_0_0_BLUE_DOWN - p_affine_1_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_2_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_3_2_BLUE_DOWN) - (p_affine_0_0_BLUE_DOWN - p_affine_1_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_3_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_2_2_BLUE_DOWN) - (p_affine_0_0_BLUE_DOWN - p_affine_2_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_1_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_3_2_BLUE_DOWN) + (p_affine_0_0_BLUE_DOWN - p_affine_2_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_3_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_1_2_BLUE_DOWN) + (p_affine_0_0_BLUE_DOWN - p_affine_3_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_1_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_2_2_BLUE_DOWN) - (p_affine_0_0_BLUE_DOWN - p_affine_3_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_2_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_1_2_BLUE_DOWN)), 0.032410690545436126*abs((p_affine_0_0_BLUE_DOWN - p_affine_1_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_2_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_3_2_BLUE_DOWN) - (p_affine_0_0_BLUE_DOWN - p_affine_1_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_3_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_2_2_BLUE_DOWN) - (p_affine_0_0_BLUE_DOWN - p_affine_2_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_1_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_3_2_BLUE_DOWN) + (p_affine_0_0_BLUE_DOWN - p_affine_2_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_3_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_1_2_BLUE_DOWN) + (p_affine_0_0_BLUE_DOWN - p_affine_3_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_1_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_2_2_BLUE_DOWN) - (p_affine_0_0_BLUE_DOWN - p_affine_3_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_2_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_1_2_BLUE_DOWN)), 0.065767460857085305*abs((p_affine_0_0_BLUE_DOWN - p_affine_1_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_2_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_3_2_BLUE_DOWN) - (p_affine_0_0_BLUE_DOWN - p_affine_1_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_3_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_2_2_BLUE_DOWN) - (p_affine_0_0_BLUE_DOWN - p_affine_2_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_1_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_3_2_BLUE_DOWN) + (p_affine_0_0_BLUE_DOWN - p_affine_2_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_3_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_1_2_BLUE_DOWN) + (p_affine_0_0_BLUE_DOWN - p_affine_3_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_1_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_2_2_BLUE_DOWN) - (p_affine_0_0_BLUE_DOWN - p_affine_3_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_2_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_1_2_BLUE_DOWN)), 0.0012463879784202093*abs((p_affine_0_0_BLUE_DOWN - p_affine_1_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_2_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_3_2_BLUE_DOWN) - (p_affine_0_0_BLUE_DOWN - p_affine_1_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_3_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_2_2_BLUE_DOWN) - (p_affine_0_0_BLUE_DOWN - p_affine_2_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_1_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_3_2_BLUE_DOWN) + (p_affine_0_0_BLUE_DOWN - p_affine_2_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_3_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_1_2_BLUE_DOWN) + (p_affine_0_0_BLUE_DOWN - p_affine_3_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_1_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_2_2_BLUE_DOWN) - (p_affine_0_0_BLUE_DOWN - p_affine_3_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_2_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_1_2_BLUE_DOWN)), 0.13345469765676804*abs((p_affine_0_0_BLUE_DOWN - p_affine_1_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_2_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_3_2_BLUE_DOWN) - (p_affine_0_0_BLUE_DOWN - p_affine_1_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_3_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_2_2_BLUE_DOWN) - (p_affine_0_0_BLUE_DOWN - p_affine_2_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_1_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_3_2_BLUE_DOWN) + (p_affine_0_0_BLUE_DOWN - p_affine_2_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_3_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_1_2_BLUE_DOWN) + (p_affine_0_0_BLUE_DOWN - p_affine_3_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_1_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_2_2_BLUE_DOWN) - (p_affine_0_0_BLUE_DOWN - p_affine_3_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_2_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_1_2_BLUE_DOWN)), 0.002529158472220073*abs((p_affine_0_0_BLUE_DOWN - p_affine_1_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_2_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_3_2_BLUE_DOWN) - (p_affine_0_0_BLUE_DOWN - p_affine_1_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_3_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_2_2_BLUE_DOWN) - (p_affine_0_0_BLUE_DOWN - p_affine_2_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_1_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_3_2_BLUE_DOWN) + (p_affine_0_0_BLUE_DOWN - p_affine_2_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_3_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_1_2_BLUE_DOWN) + (p_affine_0_0_BLUE_DOWN - p_affine_3_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_1_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_2_2_BLUE_DOWN) - (p_affine_0_0_BLUE_DOWN - p_affine_3_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_2_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_1_2_BLUE_DOWN)), 4.793119080794062e-5*abs((p_affine_0_0_BLUE_DOWN - p_affine_1_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_2_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_3_2_BLUE_DOWN) - (p_affine_0_0_BLUE_DOWN - p_affine_1_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_3_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_2_2_BLUE_DOWN) - (p_affine_0_0_BLUE_DOWN - p_affine_2_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_1_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_3_2_BLUE_DOWN) + (p_affine_0_0_BLUE_DOWN - p_affine_2_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_3_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_1_2_BLUE_DOWN) + (p_affine_0_0_BLUE_DOWN - p_affine_3_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_1_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_2_2_BLUE_DOWN) - (p_affine_0_0_BLUE_DOWN - p_affine_3_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_2_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_1_2_BLUE_DOWN)), 2.3424983832091605e-5*abs((p_affine_0_0_BLUE_DOWN - p_affine_1_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_2_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_3_2_BLUE_DOWN) - (p_affine_0_0_BLUE_DOWN - p_affine_1_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_3_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_2_2_BLUE_DOWN) - (p_affine_0_0_BLUE_DOWN - p_affine_2_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_1_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_3_2_BLUE_DOWN) + (p_affine_0_0_BLUE_DOWN - p_affine_2_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_3_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_1_2_BLUE_DOWN) + (p_affine_0_0_BLUE_DOWN - p_affine_3_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_1_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_2_2_BLUE_DOWN) - (p_affine_0_0_BLUE_DOWN - p_affine_3_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_2_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_1_2_BLUE_DOWN)), 0.00075470637742922845*abs((p_affine_0_0_BLUE_DOWN - p_affine_1_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_2_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_3_2_BLUE_DOWN) - (p_affine_0_0_BLUE_DOWN - p_affine_1_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_3_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_2_2_BLUE_DOWN) - (p_affine_0_0_BLUE_DOWN - p_affine_2_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_1_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_3_2_BLUE_DOWN) + (p_affine_0_0_BLUE_DOWN - p_affine_2_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_3_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_1_2_BLUE_DOWN) + (p_affine_0_0_BLUE_DOWN - p_affine_3_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_1_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_2_2_BLUE_DOWN) - (p_affine_0_0_BLUE_DOWN - p_affine_3_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_2_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_1_2_BLUE_DOWN)), 0.0022140849621758063*abs((p_affine_0_0_BLUE_DOWN - p_affine_1_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_2_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_3_2_BLUE_DOWN) - (p_affine_0_0_BLUE_DOWN - p_affine_1_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_3_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_2_2_BLUE_DOWN) - (p_affine_0_0_BLUE_DOWN - p_affine_2_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_1_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_3_2_BLUE_DOWN) + (p_affine_0_0_BLUE_DOWN - p_affine_2_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_3_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_1_2_BLUE_DOWN) + (p_affine_0_0_BLUE_DOWN - p_affine_3_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_1_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_2_2_BLUE_DOWN) - (p_affine_0_0_BLUE_DOWN - p_affine_3_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_2_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_1_2_BLUE_DOWN)), 0.0018477200224347493*abs((p_affine_0_0_BLUE_DOWN - p_affine_1_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_2_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_3_2_BLUE_DOWN) - (p_affine_0_0_BLUE_DOWN - p_affine_1_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_3_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_2_2_BLUE_DOWN) - (p_affine_0_0_BLUE_DOWN - p_affine_2_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_1_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_3_2_BLUE_DOWN) + (p_affine_0_0_BLUE_DOWN - p_affine_2_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_3_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_1_2_BLUE_DOWN) + (p_affine_0_0_BLUE_DOWN - p_affine_3_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_1_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_2_2_BLUE_DOWN) - (p_affine_0_0_BLUE_DOWN - p_affine_3_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_2_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_1_2_BLUE_DOWN)), 0.024315138068613611*abs((p_affine_0_0_BLUE_DOWN - p_affine_1_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_2_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_3_2_BLUE_DOWN) - (p_affine_0_0_BLUE_DOWN - p_affine_1_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_3_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_2_2_BLUE_DOWN) - (p_affine_0_0_BLUE_DOWN - p_affine_2_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_1_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_3_2_BLUE_DOWN) + (p_affine_0_0_BLUE_DOWN - p_affine_2_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_3_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_1_2_BLUE_DOWN) + (p_affine_0_0_BLUE_DOWN - p_affine_3_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_1_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_2_2_BLUE_DOWN) - (p_affine_0_0_BLUE_DOWN - p_affine_3_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_2_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_1_2_BLUE_DOWN)), 0.071333412782766975*abs((p_affine_0_0_BLUE_DOWN - p_affine_1_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_2_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_3_2_BLUE_DOWN) - (p_affine_0_0_BLUE_DOWN - p_affine_1_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_3_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_2_2_BLUE_DOWN) - (p_affine_0_0_BLUE_DOWN - p_affine_2_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_1_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_3_2_BLUE_DOWN) + (p_affine_0_0_BLUE_DOWN - p_affine_2_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_3_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_1_2_BLUE_DOWN) + (p_affine_0_0_BLUE_DOWN - p_affine_3_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_1_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_2_2_BLUE_DOWN) - (p_affine_0_0_BLUE_DOWN - p_affine_3_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_2_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_1_2_BLUE_DOWN)), 0.059529863270376029*abs((p_affine_0_0_BLUE_DOWN - p_affine_1_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_2_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_3_2_BLUE_DOWN) - (p_affine_0_0_BLUE_DOWN - p_affine_1_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_3_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_2_2_BLUE_DOWN) - (p_affine_0_0_BLUE_DOWN - p_affine_2_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_1_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_3_2_BLUE_DOWN) + (p_affine_0_0_BLUE_DOWN - p_affine_2_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_3_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_1_2_BLUE_DOWN) + (p_affine_0_0_BLUE_DOWN - p_affine_3_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_1_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_2_2_BLUE_DOWN) - (p_affine_0_0_BLUE_DOWN - p_affine_3_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_2_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_1_2_BLUE_DOWN)), 0.20927110365887197*abs((p_affine_0_0_BLUE_DOWN - p_affine_1_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_2_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_3_2_BLUE_DOWN) - (p_affine_0_0_BLUE_DOWN - p_affine_1_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_3_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_2_2_BLUE_DOWN) - (p_affine_0_0_BLUE_DOWN - p_affine_2_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_1_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_3_2_BLUE_DOWN) + (p_affine_0_0_BLUE_DOWN - p_affine_2_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_3_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_1_2_BLUE_DOWN) + (p_affine_0_0_BLUE_DOWN - p_affine_3_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_1_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_2_2_BLUE_DOWN) - (p_affine_0_0_BLUE_DOWN - p_affine_3_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_2_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_1_2_BLUE_DOWN)), 0.17464298568178085*abs((p_affine_0_0_BLUE_DOWN - p_affine_1_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_2_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_3_2_BLUE_DOWN) - (p_affine_0_0_BLUE_DOWN - p_affine_1_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_3_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_2_2_BLUE_DOWN) - (p_affine_0_0_BLUE_DOWN - p_affine_2_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_1_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_3_2_BLUE_DOWN) + (p_affine_0_0_BLUE_DOWN - p_affine_2_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_3_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_1_2_BLUE_DOWN) + (p_affine_0_0_BLUE_DOWN - p_affine_3_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_1_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_2_2_BLUE_DOWN) - (p_affine_0_0_BLUE_DOWN - p_affine_3_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_2_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_1_2_BLUE_DOWN)), 0.14574478709475508*abs((p_affine_0_0_BLUE_DOWN - p_affine_1_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_2_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_3_2_BLUE_DOWN) - (p_affine_0_0_BLUE_DOWN - p_affine_1_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_3_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_2_2_BLUE_DOWN) - (p_affine_0_0_BLUE_DOWN - p_affine_2_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_1_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_3_2_BLUE_DOWN) + (p_affine_0_0_BLUE_DOWN - p_affine_2_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_3_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_1_2_BLUE_DOWN) + (p_affine_0_0_BLUE_DOWN - p_affine_3_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_1_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_2_2_BLUE_DOWN) - (p_affine_0_0_BLUE_DOWN - p_affine_3_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_2_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_1_2_BLUE_DOWN)), 0.12450054579698165*abs((p_affine_0_0_BLUE_DOWN - p_affine_1_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_2_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_3_2_BLUE_DOWN) - (p_affine_0_0_BLUE_DOWN - p_affine_1_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_3_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_2_2_BLUE_DOWN) - (p_affine_0_0_BLUE_DOWN - p_affine_2_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_1_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_3_2_BLUE_DOWN) + (p_affine_0_0_BLUE_DOWN - p_affine_2_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_3_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_1_2_BLUE_DOWN) + (p_affine_0_0_BLUE_DOWN - p_affine_3_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_1_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_2_2_BLUE_DOWN) - (p_affine_0_0_BLUE_DOWN - p_affine_3_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_2_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_1_2_BLUE_DOWN)), 0.076241779079863126*abs((p_affine_0_0_BLUE_DOWN - p_affine_1_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_2_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_3_2_BLUE_DOWN) - (p_affine_0_0_BLUE_DOWN - p_affine_1_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_3_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_2_2_BLUE_DOWN) - (p_affine_0_0_BLUE_DOWN - p_affine_2_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_1_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_3_2_BLUE_DOWN) + (p_affine_0_0_BLUE_DOWN - p_affine_2_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_3_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_1_2_BLUE_DOWN) + (p_affine_0_0_BLUE_DOWN - p_affine_3_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_1_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_2_2_BLUE_DOWN) - (p_affine_0_0_BLUE_DOWN - p_affine_3_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_2_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_1_2_BLUE_DOWN)), 0.00013249910677232994*abs((p_affine_0_0_BLUE_DOWN - p_affine_1_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_2_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_3_2_BLUE_DOWN) - (p_affine_0_0_BLUE_DOWN - p_affine_1_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_3_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_2_2_BLUE_DOWN) - (p_affine_0_0_BLUE_DOWN - p_affine_2_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_1_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_3_2_BLUE_DOWN) + (p_affine_0_0_BLUE_DOWN - p_affine_2_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_3_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_1_2_BLUE_DOWN) + (p_affine_0_0_BLUE_DOWN - p_affine_3_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_1_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_2_2_BLUE_DOWN) - (p_affine_0_0_BLUE_DOWN - p_affine_3_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_2_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_1_2_BLUE_DOWN)), 0.15197152472496969*abs((p_affine_0_0_BLUE_DOWN - p_affine_1_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_2_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_3_2_BLUE_DOWN) - (p_affine_0_0_BLUE_DOWN - p_affine_1_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_3_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_2_2_BLUE_DOWN) - (p_affine_0_0_BLUE_DOWN - p_affine_2_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_1_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_3_2_BLUE_DOWN) + (p_affine_0_0_BLUE_DOWN - p_affine_2_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_3_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_1_2_BLUE_DOWN) + (p_affine_0_0_BLUE_DOWN - p_affine_3_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_1_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_2_2_BLUE_DOWN) - (p_affine_0_0_BLUE_DOWN - p_affine_3_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_2_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_1_2_BLUE_DOWN)), 0.046689023249274604*abs((p_affine_0_0_BLUE_DOWN - p_affine_1_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_2_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_3_2_BLUE_DOWN) - (p_affine_0_0_BLUE_DOWN - p_affine_1_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_3_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_2_2_BLUE_DOWN) - (p_affine_0_0_BLUE_DOWN - p_affine_2_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_1_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_3_2_BLUE_DOWN) + (p_affine_0_0_BLUE_DOWN - p_affine_2_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_3_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_1_2_BLUE_DOWN) + (p_affine_0_0_BLUE_DOWN - p_affine_3_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_1_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_2_2_BLUE_DOWN) - (p_affine_0_0_BLUE_DOWN - p_affine_3_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_2_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_1_2_BLUE_DOWN)), 8.1139946513070487e-5*abs((p_affine_0_0_BLUE_DOWN - p_affine_1_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_2_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_3_2_BLUE_DOWN) - (p_affine_0_0_BLUE_DOWN - p_affine_1_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_3_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_2_2_BLUE_DOWN) - (p_affine_0_0_BLUE_DOWN - p_affine_2_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_1_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_3_2_BLUE_DOWN) + (p_affine_0_0_BLUE_DOWN - p_affine_2_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_3_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_1_2_BLUE_DOWN) + (p_affine_0_0_BLUE_DOWN - p_affine_3_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_1_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_2_2_BLUE_DOWN) - (p_affine_0_0_BLUE_DOWN - p_affine_3_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_2_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_1_2_BLUE_DOWN)), 0.093064486909197122*abs((p_affine_0_0_BLUE_DOWN - p_affine_1_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_2_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_3_2_BLUE_DOWN) - (p_affine_0_0_BLUE_DOWN - p_affine_1_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_3_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_2_2_BLUE_DOWN) - (p_affine_0_0_BLUE_DOWN - p_affine_2_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_1_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_3_2_BLUE_DOWN) + (p_affine_0_0_BLUE_DOWN - p_affine_2_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_3_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_1_2_BLUE_DOWN) + (p_affine_0_0_BLUE_DOWN - p_affine_3_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_1_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_2_2_BLUE_DOWN) - (p_affine_0_0_BLUE_DOWN - p_affine_3_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_2_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_1_2_BLUE_DOWN)), 1.4101153680155925e-7*abs((p_affine_0_0_BLUE_DOWN - p_affine_1_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_2_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_3_2_BLUE_DOWN) - (p_affine_0_0_BLUE_DOWN - p_affine_1_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_3_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_2_2_BLUE_DOWN) - (p_affine_0_0_BLUE_DOWN - p_affine_2_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_1_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_3_2_BLUE_DOWN) + (p_affine_0_0_BLUE_DOWN - p_affine_2_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_3_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_1_2_BLUE_DOWN) + (p_affine_0_0_BLUE_DOWN - p_affine_3_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_1_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_2_2_BLUE_DOWN) - (p_affine_0_0_BLUE_DOWN - p_affine_3_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_2_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_1_2_BLUE_DOWN)), 0.00016173496390708763*abs((p_affine_0_0_BLUE_DOWN - p_affine_1_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_2_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_3_2_BLUE_DOWN) - (p_affine_0_0_BLUE_DOWN - p_affine_1_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_3_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_2_2_BLUE_DOWN) - (p_affine_0_0_BLUE_DOWN - p_affine_2_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_1_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_3_2_BLUE_DOWN) + (p_affine_0_0_BLUE_DOWN - p_affine_2_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_3_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_1_2_BLUE_DOWN) + (p_affine_0_0_BLUE_DOWN - p_affine_3_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_1_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_2_2_BLUE_DOWN) - (p_affine_0_0_BLUE_DOWN - p_affine_3_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_2_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_1_2_BLUE_DOWN)), 0.18550396047976195*abs((p_affine_0_0_BLUE_DOWN - p_affine_1_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_2_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_3_2_BLUE_DOWN) - (p_affine_0_0_BLUE_DOWN - p_affine_1_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_3_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_2_2_BLUE_DOWN) - (p_affine_0_0_BLUE_DOWN - p_affine_2_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_1_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_3_2_BLUE_DOWN) + (p_affine_0_0_BLUE_DOWN - p_affine_2_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_3_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_1_2_BLUE_DOWN) + (p_affine_0_0_BLUE_DOWN - p_affine_3_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_1_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_2_2_BLUE_DOWN) - (p_affine_0_0_BLUE_DOWN - p_affine_3_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_2_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_1_2_BLUE_DOWN)), 0.00021985802016328927*abs((p_affine_0_0_BLUE_DOWN - p_affine_1_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_2_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_3_2_BLUE_DOWN) - (p_affine_0_0_BLUE_DOWN - p_affine_1_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_3_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_2_2_BLUE_DOWN) - (p_affine_0_0_BLUE_DOWN - p_affine_2_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_1_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_3_2_BLUE_DOWN) + (p_affine_0_0_BLUE_DOWN - p_affine_2_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_3_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_1_2_BLUE_DOWN) + (p_affine_0_0_BLUE_DOWN - p_affine_3_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_1_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_2_2_BLUE_DOWN) - (p_affine_0_0_BLUE_DOWN - p_affine_3_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_2_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_1_2_BLUE_DOWN)), 0.012181957275462504*abs((p_affine_0_0_BLUE_DOWN - p_affine_1_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_2_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_3_2_BLUE_DOWN) - (p_affine_0_0_BLUE_DOWN - p_affine_1_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_3_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_2_2_BLUE_DOWN) - (p_affine_0_0_BLUE_DOWN - p_affine_2_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_1_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_3_2_BLUE_DOWN) + (p_affine_0_0_BLUE_DOWN - p_affine_2_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_3_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_1_2_BLUE_DOWN) + (p_affine_0_0_BLUE_DOWN - p_affine_3_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_1_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_2_2_BLUE_DOWN) - (p_affine_0_0_BLUE_DOWN - p_affine_3_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_2_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_1_2_BLUE_DOWN)), 0.0018336830929379926*abs((p_affine_0_0_BLUE_DOWN - p_affine_1_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_2_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_3_2_BLUE_DOWN) - (p_affine_0_0_BLUE_DOWN - p_affine_1_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_3_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_2_2_BLUE_DOWN) - (p_affine_0_0_BLUE_DOWN - p_affine_2_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_1_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_3_2_BLUE_DOWN) + (p_affine_0_0_BLUE_DOWN - p_affine_2_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_3_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_1_2_BLUE_DOWN) + (p_affine_0_0_BLUE_DOWN - p_affine_3_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_1_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_2_2_BLUE_DOWN) - (p_affine_0_0_BLUE_DOWN - p_affine_3_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_2_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_1_2_BLUE_DOWN)), 0.00059211167385993745*abs((p_affine_0_0_BLUE_DOWN - p_affine_1_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_2_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_3_2_BLUE_DOWN) - (p_affine_0_0_BLUE_DOWN - p_affine_1_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_3_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_2_2_BLUE_DOWN) - (p_affine_0_0_BLUE_DOWN - p_affine_2_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_1_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_3_2_BLUE_DOWN) + (p_affine_0_0_BLUE_DOWN - p_affine_2_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_3_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_1_2_BLUE_DOWN) + (p_affine_0_0_BLUE_DOWN - p_affine_3_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_1_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_2_2_BLUE_DOWN) - (p_affine_0_0_BLUE_DOWN - p_affine_3_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_2_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_1_2_BLUE_DOWN)), 0.67498144007199112*abs((p_affine_0_0_BLUE_DOWN - p_affine_1_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_2_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_3_2_BLUE_DOWN) - (p_affine_0_0_BLUE_DOWN - p_affine_1_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_3_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_2_2_BLUE_DOWN) - (p_affine_0_0_BLUE_DOWN - p_affine_2_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_1_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_3_2_BLUE_DOWN) + (p_affine_0_0_BLUE_DOWN - p_affine_2_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_3_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_1_2_BLUE_DOWN) + (p_affine_0_0_BLUE_DOWN - p_affine_3_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_1_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_2_2_BLUE_DOWN) - (p_affine_0_0_BLUE_DOWN - p_affine_3_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_2_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_1_2_BLUE_DOWN)), 0.10160124737918669*abs((p_affine_0_0_BLUE_DOWN - p_affine_1_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_2_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_3_2_BLUE_DOWN) - (p_affine_0_0_BLUE_DOWN - p_affine_1_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_3_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_2_2_BLUE_DOWN) - (p_affine_0_0_BLUE_DOWN - p_affine_2_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_1_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_3_2_BLUE_DOWN) + (p_affine_0_0_BLUE_DOWN - p_affine_2_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_3_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_1_2_BLUE_DOWN) + (p_affine_0_0_BLUE_DOWN - p_affine_3_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_1_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_2_2_BLUE_DOWN) - (p_affine_0_0_BLUE_DOWN - p_affine_3_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_2_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_1_2_BLUE_DOWN)), 0.032807896240979378*abs((p_affine_0_0_BLUE_DOWN - p_affine_1_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_2_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_3_2_BLUE_DOWN) - (p_affine_0_0_BLUE_DOWN - p_affine_1_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_3_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_2_2_BLUE_DOWN) - (p_affine_0_0_BLUE_DOWN - p_affine_2_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_1_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_3_2_BLUE_DOWN) + (p_affine_0_0_BLUE_DOWN - p_affine_2_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_3_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_1_2_BLUE_DOWN) + (p_affine_0_0_BLUE_DOWN - p_affine_3_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_1_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_2_2_BLUE_DOWN) - (p_affine_0_0_BLUE_DOWN - p_affine_3_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_2_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_1_2_BLUE_DOWN)), 0.015293477503478755*abs((p_affine_0_0_BLUE_DOWN - p_affine_1_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_2_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_3_2_BLUE_DOWN) - (p_affine_0_0_BLUE_DOWN - p_affine_1_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_3_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_2_2_BLUE_DOWN) - (p_affine_0_0_BLUE_DOWN - p_affine_2_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_1_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_3_2_BLUE_DOWN) + (p_affine_0_0_BLUE_DOWN - p_affine_2_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_3_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_1_2_BLUE_DOWN) + (p_affine_0_0_BLUE_DOWN - p_affine_3_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_1_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_2_2_BLUE_DOWN) - (p_affine_0_0_BLUE_DOWN - p_affine_3_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_2_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_1_2_BLUE_DOWN)), 0.0049383923528547903*abs((p_affine_0_0_BLUE_DOWN - p_affine_1_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_2_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_3_2_BLUE_DOWN) - (p_affine_0_0_BLUE_DOWN - p_affine_1_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_3_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_2_2_BLUE_DOWN) - (p_affine_0_0_BLUE_DOWN - p_affine_2_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_1_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_3_2_BLUE_DOWN) + (p_affine_0_0_BLUE_DOWN - p_affine_2_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_3_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_1_2_BLUE_DOWN) + (p_affine_0_0_BLUE_DOWN - p_affine_3_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_1_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_2_2_BLUE_DOWN) - (p_affine_0_0_BLUE_DOWN - p_affine_3_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_2_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_1_2_BLUE_DOWN)), 0.0015946483738042757*abs((p_affine_0_0_BLUE_DOWN - p_affine_1_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_2_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_3_2_BLUE_DOWN) - (p_affine_0_0_BLUE_DOWN - p_affine_1_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_3_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_2_2_BLUE_DOWN) - (p_affine_0_0_BLUE_DOWN - p_affine_2_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_1_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_3_2_BLUE_DOWN) + (p_affine_0_0_BLUE_DOWN - p_affine_2_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_3_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_1_2_BLUE_DOWN) + (p_affine_0_0_BLUE_DOWN - p_affine_3_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_1_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_2_2_BLUE_DOWN) - (p_affine_0_0_BLUE_DOWN - p_affine_3_0_BLUE_DOWN)*(p_affine_0_1_BLUE_DOWN - p_affine_2_1_BLUE_DOWN)*(p_affine_0_2_BLUE_DOWN - p_affine_1_2_BLUE_DOWN))};
      
          for (int64_t ctr_2 = 0; ctr_2 < micro_edges_per_macro_edge; ctr_2 += 1)
          for (int64_t ctr_1 = 0; ctr_1 < -ctr_2 + micro_edges_per_macro_edge; ctr_1 += 1)
          {
             for (int64_t ctr_0 = 0; ctr_0 < (int64_t)((-ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1) / (4)) * (4); ctr_0 += 4)
             {
                __m256d q_acc_0_0 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_1 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_2 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_3 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                for (int64_t q = 0; q < 4; q += 1)
                {
                   const real_t q_tmp_0_0 = _data_phi_psi_det_jac_aff_0_BLUE_DOWN[10*q]*_data_q_w[q];
                   const real_t q_tmp_1_1 = _data_phi_psi_det_jac_aff_0_BLUE_DOWN[10*q + 4]*_data_q_w[q];
                   const real_t q_tmp_2_2 = _data_phi_psi_det_jac_aff_0_BLUE_DOWN[10*q + 7]*_data_q_w[q];
                   const real_t q_tmp_3_3 = _data_phi_psi_det_jac_aff_0_BLUE_DOWN[10*q + 9]*_data_q_w[q];
                   q_acc_0_0 = _mm256_add_pd(_mm256_set_pd(q_tmp_0_0,q_tmp_0_0,q_tmp_0_0,q_tmp_0_0),q_acc_0_0);
                   q_acc_1_1 = _mm256_add_pd(_mm256_set_pd(q_tmp_1_1,q_tmp_1_1,q_tmp_1_1,q_tmp_1_1),q_acc_1_1);
                   q_acc_2_2 = _mm256_add_pd(_mm256_set_pd(q_tmp_2_2,q_tmp_2_2,q_tmp_2_2,q_tmp_2_2),q_acc_2_2);
                   q_acc_3_3 = _mm256_add_pd(_mm256_set_pd(q_tmp_3_3,q_tmp_3_3,q_tmp_3_3,q_tmp_3_3),q_acc_3_3);
                }
                const __m256d elMatDiag_0 = q_acc_0_0;
                const __m256d elMatDiag_1 = q_acc_1_1;
                const __m256d elMatDiag_2 = q_acc_2_2;
                const __m256d elMatDiag_3 = q_acc_3_3;
                _mm256_storeu_pd(&_data_invDiag_[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatDiag_0,_mm256_loadu_pd(& _data_invDiag_[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatDiag_1,_mm256_loadu_pd(& _data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatDiag_2,_mm256_loadu_pd(& _data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_invDiag_[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatDiag_3,_mm256_loadu_pd(& _data_invDiag_[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))])));
             }
             for (int64_t ctr_0 = (int64_t)((-ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1) / (4)) * (4); ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1; ctr_0 += 1)
             {
                real_t q_acc_0_0 = 0.0;
                real_t q_acc_1_1 = 0.0;
                real_t q_acc_2_2 = 0.0;
                real_t q_acc_3_3 = 0.0;
                for (int64_t q = 0; q < 4; q += 1)
                {
                   const real_t q_tmp_0_0 = _data_phi_psi_det_jac_aff_0_BLUE_DOWN[10*q]*_data_q_w[q];
                   const real_t q_tmp_1_1 = _data_phi_psi_det_jac_aff_0_BLUE_DOWN[10*q + 4]*_data_q_w[q];
                   const real_t q_tmp_2_2 = _data_phi_psi_det_jac_aff_0_BLUE_DOWN[10*q + 7]*_data_q_w[q];
                   const real_t q_tmp_3_3 = _data_phi_psi_det_jac_aff_0_BLUE_DOWN[10*q + 9]*_data_q_w[q];
                   q_acc_0_0 = q_acc_0_0 + q_tmp_0_0;
                   q_acc_1_1 = q_acc_1_1 + q_tmp_1_1;
                   q_acc_2_2 = q_acc_2_2 + q_tmp_2_2;
                   q_acc_3_3 = q_acc_3_3 + q_tmp_3_3;
                }
                const real_t elMatDiag_0 = q_acc_0_0;
                const real_t elMatDiag_1 = q_acc_1_1;
                const real_t elMatDiag_2 = q_acc_2_2;
                const real_t elMatDiag_3 = q_acc_3_3;
                _data_invDiag_[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatDiag_0 + _data_invDiag_[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                _data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatDiag_1 + _data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                _data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatDiag_2 + _data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_invDiag_[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatDiag_3 + _data_invDiag_[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             }
          }
       }
       const real_t tmp_0_GREEN_UP = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t tmp_1_GREEN_UP = macro_vertex_coord_id_0comp0 + tmp_0_GREEN_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const real_t tmp_2_GREEN_UP = macro_vertex_coord_id_0comp1 + tmp_0_GREEN_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const real_t tmp_3_GREEN_UP = macro_vertex_coord_id_0comp2 + tmp_0_GREEN_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2);
       const real_t tmp_4_GREEN_UP = tmp_0_GREEN_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0);
       const real_t tmp_5_GREEN_UP = tmp_0_GREEN_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1);
       const real_t tmp_6_GREEN_UP = tmp_0_GREEN_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2);
       const real_t p_affine_0_0_GREEN_UP = tmp_1_GREEN_UP;
       const real_t p_affine_0_1_GREEN_UP = tmp_2_GREEN_UP;
       const real_t p_affine_0_2_GREEN_UP = tmp_3_GREEN_UP;
       const real_t p_affine_1_0_GREEN_UP = macro_vertex_coord_id_0comp0 + tmp_0_GREEN_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t p_affine_1_1_GREEN_UP = macro_vertex_coord_id_0comp1 + tmp_0_GREEN_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t p_affine_1_2_GREEN_UP = macro_vertex_coord_id_0comp2 + tmp_0_GREEN_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const real_t p_affine_2_0_GREEN_UP = macro_vertex_coord_id_0comp0 + tmp_4_GREEN_UP;
       const real_t p_affine_2_1_GREEN_UP = macro_vertex_coord_id_0comp1 + tmp_5_GREEN_UP;
       const real_t p_affine_2_2_GREEN_UP = macro_vertex_coord_id_0comp2 + tmp_6_GREEN_UP;
       const real_t p_affine_3_0_GREEN_UP = tmp_1_GREEN_UP + tmp_4_GREEN_UP;
       const real_t p_affine_3_1_GREEN_UP = tmp_2_GREEN_UP + tmp_5_GREEN_UP;
       const real_t p_affine_3_2_GREEN_UP = tmp_3_GREEN_UP + tmp_6_GREEN_UP;
       {
          /* CellType.GREEN_UP */
          const real_t _data_phi_psi_det_jac_aff_0_GREEN_UP [] = {0.20046443821120821*abs((p_affine_0_0_GREEN_UP - p_affine_1_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_2_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_3_2_GREEN_UP) - (p_affine_0_0_GREEN_UP - p_affine_1_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_3_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_2_2_GREEN_UP) - (p_affine_0_0_GREEN_UP - p_affine_2_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_1_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_3_2_GREEN_UP) + (p_affine_0_0_GREEN_UP - p_affine_2_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_3_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_1_2_GREEN_UP) + (p_affine_0_0_GREEN_UP - p_affine_3_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_1_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_2_2_GREEN_UP) - (p_affine_0_0_GREEN_UP - p_affine_3_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_2_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_1_2_GREEN_UP)), 0.080605154129423817*abs((p_affine_0_0_GREEN_UP - p_affine_1_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_2_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_3_2_GREEN_UP) - (p_affine_0_0_GREEN_UP - p_affine_1_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_3_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_2_2_GREEN_UP) - (p_affine_0_0_GREEN_UP - p_affine_2_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_1_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_3_2_GREEN_UP) + (p_affine_0_0_GREEN_UP - p_affine_2_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_3_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_1_2_GREEN_UP) + (p_affine_0_0_GREEN_UP - p_affine_3_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_1_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_2_2_GREEN_UP) - (p_affine_0_0_GREEN_UP - p_affine_3_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_2_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_1_2_GREEN_UP)), 0.16356320182856121*abs((p_affine_0_0_GREEN_UP - p_affine_1_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_2_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_3_2_GREEN_UP) - (p_affine_0_0_GREEN_UP - p_affine_1_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_3_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_2_2_GREEN_UP) - (p_affine_0_0_GREEN_UP - p_affine_2_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_1_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_3_2_GREEN_UP) + (p_affine_0_0_GREEN_UP - p_affine_2_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_3_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_1_2_GREEN_UP) + (p_affine_0_0_GREEN_UP - p_affine_3_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_1_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_2_2_GREEN_UP) - (p_affine_0_0_GREEN_UP - p_affine_3_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_2_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_1_2_GREEN_UP)), 0.0030997579321792282*abs((p_affine_0_0_GREEN_UP - p_affine_1_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_2_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_3_2_GREEN_UP) - (p_affine_0_0_GREEN_UP - p_affine_1_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_3_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_2_2_GREEN_UP) - (p_affine_0_0_GREEN_UP - p_affine_2_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_1_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_3_2_GREEN_UP) + (p_affine_0_0_GREEN_UP - p_affine_2_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_3_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_1_2_GREEN_UP) + (p_affine_0_0_GREEN_UP - p_affine_3_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_1_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_2_2_GREEN_UP) - (p_affine_0_0_GREEN_UP - p_affine_3_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_2_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_1_2_GREEN_UP)), 0.032410690545436126*abs((p_affine_0_0_GREEN_UP - p_affine_1_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_2_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_3_2_GREEN_UP) - (p_affine_0_0_GREEN_UP - p_affine_1_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_3_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_2_2_GREEN_UP) - (p_affine_0_0_GREEN_UP - p_affine_2_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_1_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_3_2_GREEN_UP) + (p_affine_0_0_GREEN_UP - p_affine_2_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_3_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_1_2_GREEN_UP) + (p_affine_0_0_GREEN_UP - p_affine_3_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_1_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_2_2_GREEN_UP) - (p_affine_0_0_GREEN_UP - p_affine_3_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_2_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_1_2_GREEN_UP)), 0.065767460857085305*abs((p_affine_0_0_GREEN_UP - p_affine_1_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_2_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_3_2_GREEN_UP) - (p_affine_0_0_GREEN_UP - p_affine_1_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_3_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_2_2_GREEN_UP) - (p_affine_0_0_GREEN_UP - p_affine_2_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_1_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_3_2_GREEN_UP) + (p_affine_0_0_GREEN_UP - p_affine_2_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_3_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_1_2_GREEN_UP) + (p_affine_0_0_GREEN_UP - p_affine_3_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_1_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_2_2_GREEN_UP) - (p_affine_0_0_GREEN_UP - p_affine_3_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_2_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_1_2_GREEN_UP)), 0.0012463879784202093*abs((p_affine_0_0_GREEN_UP - p_affine_1_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_2_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_3_2_GREEN_UP) - (p_affine_0_0_GREEN_UP - p_affine_1_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_3_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_2_2_GREEN_UP) - (p_affine_0_0_GREEN_UP - p_affine_2_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_1_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_3_2_GREEN_UP) + (p_affine_0_0_GREEN_UP - p_affine_2_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_3_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_1_2_GREEN_UP) + (p_affine_0_0_GREEN_UP - p_affine_3_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_1_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_2_2_GREEN_UP) - (p_affine_0_0_GREEN_UP - p_affine_3_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_2_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_1_2_GREEN_UP)), 0.13345469765676804*abs((p_affine_0_0_GREEN_UP - p_affine_1_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_2_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_3_2_GREEN_UP) - (p_affine_0_0_GREEN_UP - p_affine_1_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_3_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_2_2_GREEN_UP) - (p_affine_0_0_GREEN_UP - p_affine_2_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_1_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_3_2_GREEN_UP) + (p_affine_0_0_GREEN_UP - p_affine_2_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_3_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_1_2_GREEN_UP) + (p_affine_0_0_GREEN_UP - p_affine_3_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_1_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_2_2_GREEN_UP) - (p_affine_0_0_GREEN_UP - p_affine_3_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_2_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_1_2_GREEN_UP)), 0.002529158472220073*abs((p_affine_0_0_GREEN_UP - p_affine_1_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_2_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_3_2_GREEN_UP) - (p_affine_0_0_GREEN_UP - p_affine_1_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_3_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_2_2_GREEN_UP) - (p_affine_0_0_GREEN_UP - p_affine_2_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_1_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_3_2_GREEN_UP) + (p_affine_0_0_GREEN_UP - p_affine_2_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_3_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_1_2_GREEN_UP) + (p_affine_0_0_GREEN_UP - p_affine_3_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_1_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_2_2_GREEN_UP) - (p_affine_0_0_GREEN_UP - p_affine_3_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_2_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_1_2_GREEN_UP)), 4.793119080794062e-5*abs((p_affine_0_0_GREEN_UP - p_affine_1_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_2_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_3_2_GREEN_UP) - (p_affine_0_0_GREEN_UP - p_affine_1_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_3_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_2_2_GREEN_UP) - (p_affine_0_0_GREEN_UP - p_affine_2_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_1_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_3_2_GREEN_UP) + (p_affine_0_0_GREEN_UP - p_affine_2_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_3_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_1_2_GREEN_UP) + (p_affine_0_0_GREEN_UP - p_affine_3_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_1_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_2_2_GREEN_UP) - (p_affine_0_0_GREEN_UP - p_affine_3_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_2_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_1_2_GREEN_UP)), 2.3424983832091605e-5*abs((p_affine_0_0_GREEN_UP - p_affine_1_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_2_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_3_2_GREEN_UP) - (p_affine_0_0_GREEN_UP - p_affine_1_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_3_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_2_2_GREEN_UP) - (p_affine_0_0_GREEN_UP - p_affine_2_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_1_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_3_2_GREEN_UP) + (p_affine_0_0_GREEN_UP - p_affine_2_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_3_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_1_2_GREEN_UP) + (p_affine_0_0_GREEN_UP - p_affine_3_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_1_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_2_2_GREEN_UP) - (p_affine_0_0_GREEN_UP - p_affine_3_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_2_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_1_2_GREEN_UP)), 0.00075470637742922845*abs((p_affine_0_0_GREEN_UP - p_affine_1_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_2_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_3_2_GREEN_UP) - (p_affine_0_0_GREEN_UP - p_affine_1_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_3_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_2_2_GREEN_UP) - (p_affine_0_0_GREEN_UP - p_affine_2_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_1_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_3_2_GREEN_UP) + (p_affine_0_0_GREEN_UP - p_affine_2_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_3_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_1_2_GREEN_UP) + (p_affine_0_0_GREEN_UP - p_affine_3_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_1_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_2_2_GREEN_UP) - (p_affine_0_0_GREEN_UP - p_affine_3_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_2_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_1_2_GREEN_UP)), 0.0022140849621758063*abs((p_affine_0_0_GREEN_UP - p_affine_1_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_2_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_3_2_GREEN_UP) - (p_affine_0_0_GREEN_UP - p_affine_1_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_3_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_2_2_GREEN_UP) - (p_affine_0_0_GREEN_UP - p_affine_2_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_1_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_3_2_GREEN_UP) + (p_affine_0_0_GREEN_UP - p_affine_2_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_3_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_1_2_GREEN_UP) + (p_affine_0_0_GREEN_UP - p_affine_3_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_1_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_2_2_GREEN_UP) - (p_affine_0_0_GREEN_UP - p_affine_3_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_2_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_1_2_GREEN_UP)), 0.0018477200224347493*abs((p_affine_0_0_GREEN_UP - p_affine_1_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_2_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_3_2_GREEN_UP) - (p_affine_0_0_GREEN_UP - p_affine_1_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_3_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_2_2_GREEN_UP) - (p_affine_0_0_GREEN_UP - p_affine_2_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_1_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_3_2_GREEN_UP) + (p_affine_0_0_GREEN_UP - p_affine_2_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_3_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_1_2_GREEN_UP) + (p_affine_0_0_GREEN_UP - p_affine_3_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_1_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_2_2_GREEN_UP) - (p_affine_0_0_GREEN_UP - p_affine_3_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_2_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_1_2_GREEN_UP)), 0.024315138068613611*abs((p_affine_0_0_GREEN_UP - p_affine_1_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_2_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_3_2_GREEN_UP) - (p_affine_0_0_GREEN_UP - p_affine_1_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_3_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_2_2_GREEN_UP) - (p_affine_0_0_GREEN_UP - p_affine_2_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_1_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_3_2_GREEN_UP) + (p_affine_0_0_GREEN_UP - p_affine_2_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_3_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_1_2_GREEN_UP) + (p_affine_0_0_GREEN_UP - p_affine_3_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_1_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_2_2_GREEN_UP) - (p_affine_0_0_GREEN_UP - p_affine_3_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_2_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_1_2_GREEN_UP)), 0.071333412782766975*abs((p_affine_0_0_GREEN_UP - p_affine_1_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_2_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_3_2_GREEN_UP) - (p_affine_0_0_GREEN_UP - p_affine_1_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_3_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_2_2_GREEN_UP) - (p_affine_0_0_GREEN_UP - p_affine_2_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_1_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_3_2_GREEN_UP) + (p_affine_0_0_GREEN_UP - p_affine_2_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_3_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_1_2_GREEN_UP) + (p_affine_0_0_GREEN_UP - p_affine_3_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_1_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_2_2_GREEN_UP) - (p_affine_0_0_GREEN_UP - p_affine_3_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_2_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_1_2_GREEN_UP)), 0.059529863270376029*abs((p_affine_0_0_GREEN_UP - p_affine_1_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_2_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_3_2_GREEN_UP) - (p_affine_0_0_GREEN_UP - p_affine_1_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_3_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_2_2_GREEN_UP) - (p_affine_0_0_GREEN_UP - p_affine_2_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_1_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_3_2_GREEN_UP) + (p_affine_0_0_GREEN_UP - p_affine_2_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_3_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_1_2_GREEN_UP) + (p_affine_0_0_GREEN_UP - p_affine_3_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_1_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_2_2_GREEN_UP) - (p_affine_0_0_GREEN_UP - p_affine_3_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_2_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_1_2_GREEN_UP)), 0.20927110365887197*abs((p_affine_0_0_GREEN_UP - p_affine_1_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_2_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_3_2_GREEN_UP) - (p_affine_0_0_GREEN_UP - p_affine_1_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_3_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_2_2_GREEN_UP) - (p_affine_0_0_GREEN_UP - p_affine_2_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_1_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_3_2_GREEN_UP) + (p_affine_0_0_GREEN_UP - p_affine_2_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_3_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_1_2_GREEN_UP) + (p_affine_0_0_GREEN_UP - p_affine_3_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_1_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_2_2_GREEN_UP) - (p_affine_0_0_GREEN_UP - p_affine_3_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_2_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_1_2_GREEN_UP)), 0.17464298568178085*abs((p_affine_0_0_GREEN_UP - p_affine_1_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_2_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_3_2_GREEN_UP) - (p_affine_0_0_GREEN_UP - p_affine_1_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_3_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_2_2_GREEN_UP) - (p_affine_0_0_GREEN_UP - p_affine_2_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_1_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_3_2_GREEN_UP) + (p_affine_0_0_GREEN_UP - p_affine_2_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_3_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_1_2_GREEN_UP) + (p_affine_0_0_GREEN_UP - p_affine_3_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_1_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_2_2_GREEN_UP) - (p_affine_0_0_GREEN_UP - p_affine_3_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_2_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_1_2_GREEN_UP)), 0.14574478709475508*abs((p_affine_0_0_GREEN_UP - p_affine_1_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_2_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_3_2_GREEN_UP) - (p_affine_0_0_GREEN_UP - p_affine_1_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_3_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_2_2_GREEN_UP) - (p_affine_0_0_GREEN_UP - p_affine_2_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_1_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_3_2_GREEN_UP) + (p_affine_0_0_GREEN_UP - p_affine_2_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_3_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_1_2_GREEN_UP) + (p_affine_0_0_GREEN_UP - p_affine_3_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_1_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_2_2_GREEN_UP) - (p_affine_0_0_GREEN_UP - p_affine_3_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_2_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_1_2_GREEN_UP)), 0.12450054579698165*abs((p_affine_0_0_GREEN_UP - p_affine_1_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_2_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_3_2_GREEN_UP) - (p_affine_0_0_GREEN_UP - p_affine_1_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_3_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_2_2_GREEN_UP) - (p_affine_0_0_GREEN_UP - p_affine_2_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_1_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_3_2_GREEN_UP) + (p_affine_0_0_GREEN_UP - p_affine_2_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_3_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_1_2_GREEN_UP) + (p_affine_0_0_GREEN_UP - p_affine_3_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_1_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_2_2_GREEN_UP) - (p_affine_0_0_GREEN_UP - p_affine_3_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_2_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_1_2_GREEN_UP)), 0.076241779079863126*abs((p_affine_0_0_GREEN_UP - p_affine_1_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_2_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_3_2_GREEN_UP) - (p_affine_0_0_GREEN_UP - p_affine_1_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_3_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_2_2_GREEN_UP) - (p_affine_0_0_GREEN_UP - p_affine_2_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_1_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_3_2_GREEN_UP) + (p_affine_0_0_GREEN_UP - p_affine_2_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_3_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_1_2_GREEN_UP) + (p_affine_0_0_GREEN_UP - p_affine_3_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_1_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_2_2_GREEN_UP) - (p_affine_0_0_GREEN_UP - p_affine_3_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_2_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_1_2_GREEN_UP)), 0.00013249910677232994*abs((p_affine_0_0_GREEN_UP - p_affine_1_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_2_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_3_2_GREEN_UP) - (p_affine_0_0_GREEN_UP - p_affine_1_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_3_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_2_2_GREEN_UP) - (p_affine_0_0_GREEN_UP - p_affine_2_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_1_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_3_2_GREEN_UP) + (p_affine_0_0_GREEN_UP - p_affine_2_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_3_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_1_2_GREEN_UP) + (p_affine_0_0_GREEN_UP - p_affine_3_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_1_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_2_2_GREEN_UP) - (p_affine_0_0_GREEN_UP - p_affine_3_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_2_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_1_2_GREEN_UP)), 0.15197152472496969*abs((p_affine_0_0_GREEN_UP - p_affine_1_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_2_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_3_2_GREEN_UP) - (p_affine_0_0_GREEN_UP - p_affine_1_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_3_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_2_2_GREEN_UP) - (p_affine_0_0_GREEN_UP - p_affine_2_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_1_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_3_2_GREEN_UP) + (p_affine_0_0_GREEN_UP - p_affine_2_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_3_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_1_2_GREEN_UP) + (p_affine_0_0_GREEN_UP - p_affine_3_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_1_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_2_2_GREEN_UP) - (p_affine_0_0_GREEN_UP - p_affine_3_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_2_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_1_2_GREEN_UP)), 0.046689023249274604*abs((p_affine_0_0_GREEN_UP - p_affine_1_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_2_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_3_2_GREEN_UP) - (p_affine_0_0_GREEN_UP - p_affine_1_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_3_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_2_2_GREEN_UP) - (p_affine_0_0_GREEN_UP - p_affine_2_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_1_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_3_2_GREEN_UP) + (p_affine_0_0_GREEN_UP - p_affine_2_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_3_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_1_2_GREEN_UP) + (p_affine_0_0_GREEN_UP - p_affine_3_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_1_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_2_2_GREEN_UP) - (p_affine_0_0_GREEN_UP - p_affine_3_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_2_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_1_2_GREEN_UP)), 8.1139946513070487e-5*abs((p_affine_0_0_GREEN_UP - p_affine_1_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_2_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_3_2_GREEN_UP) - (p_affine_0_0_GREEN_UP - p_affine_1_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_3_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_2_2_GREEN_UP) - (p_affine_0_0_GREEN_UP - p_affine_2_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_1_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_3_2_GREEN_UP) + (p_affine_0_0_GREEN_UP - p_affine_2_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_3_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_1_2_GREEN_UP) + (p_affine_0_0_GREEN_UP - p_affine_3_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_1_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_2_2_GREEN_UP) - (p_affine_0_0_GREEN_UP - p_affine_3_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_2_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_1_2_GREEN_UP)), 0.093064486909197122*abs((p_affine_0_0_GREEN_UP - p_affine_1_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_2_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_3_2_GREEN_UP) - (p_affine_0_0_GREEN_UP - p_affine_1_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_3_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_2_2_GREEN_UP) - (p_affine_0_0_GREEN_UP - p_affine_2_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_1_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_3_2_GREEN_UP) + (p_affine_0_0_GREEN_UP - p_affine_2_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_3_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_1_2_GREEN_UP) + (p_affine_0_0_GREEN_UP - p_affine_3_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_1_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_2_2_GREEN_UP) - (p_affine_0_0_GREEN_UP - p_affine_3_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_2_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_1_2_GREEN_UP)), 1.4101153680155925e-7*abs((p_affine_0_0_GREEN_UP - p_affine_1_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_2_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_3_2_GREEN_UP) - (p_affine_0_0_GREEN_UP - p_affine_1_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_3_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_2_2_GREEN_UP) - (p_affine_0_0_GREEN_UP - p_affine_2_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_1_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_3_2_GREEN_UP) + (p_affine_0_0_GREEN_UP - p_affine_2_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_3_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_1_2_GREEN_UP) + (p_affine_0_0_GREEN_UP - p_affine_3_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_1_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_2_2_GREEN_UP) - (p_affine_0_0_GREEN_UP - p_affine_3_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_2_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_1_2_GREEN_UP)), 0.00016173496390708763*abs((p_affine_0_0_GREEN_UP - p_affine_1_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_2_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_3_2_GREEN_UP) - (p_affine_0_0_GREEN_UP - p_affine_1_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_3_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_2_2_GREEN_UP) - (p_affine_0_0_GREEN_UP - p_affine_2_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_1_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_3_2_GREEN_UP) + (p_affine_0_0_GREEN_UP - p_affine_2_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_3_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_1_2_GREEN_UP) + (p_affine_0_0_GREEN_UP - p_affine_3_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_1_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_2_2_GREEN_UP) - (p_affine_0_0_GREEN_UP - p_affine_3_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_2_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_1_2_GREEN_UP)), 0.18550396047976195*abs((p_affine_0_0_GREEN_UP - p_affine_1_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_2_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_3_2_GREEN_UP) - (p_affine_0_0_GREEN_UP - p_affine_1_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_3_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_2_2_GREEN_UP) - (p_affine_0_0_GREEN_UP - p_affine_2_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_1_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_3_2_GREEN_UP) + (p_affine_0_0_GREEN_UP - p_affine_2_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_3_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_1_2_GREEN_UP) + (p_affine_0_0_GREEN_UP - p_affine_3_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_1_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_2_2_GREEN_UP) - (p_affine_0_0_GREEN_UP - p_affine_3_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_2_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_1_2_GREEN_UP)), 0.00021985802016328927*abs((p_affine_0_0_GREEN_UP - p_affine_1_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_2_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_3_2_GREEN_UP) - (p_affine_0_0_GREEN_UP - p_affine_1_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_3_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_2_2_GREEN_UP) - (p_affine_0_0_GREEN_UP - p_affine_2_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_1_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_3_2_GREEN_UP) + (p_affine_0_0_GREEN_UP - p_affine_2_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_3_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_1_2_GREEN_UP) + (p_affine_0_0_GREEN_UP - p_affine_3_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_1_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_2_2_GREEN_UP) - (p_affine_0_0_GREEN_UP - p_affine_3_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_2_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_1_2_GREEN_UP)), 0.012181957275462504*abs((p_affine_0_0_GREEN_UP - p_affine_1_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_2_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_3_2_GREEN_UP) - (p_affine_0_0_GREEN_UP - p_affine_1_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_3_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_2_2_GREEN_UP) - (p_affine_0_0_GREEN_UP - p_affine_2_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_1_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_3_2_GREEN_UP) + (p_affine_0_0_GREEN_UP - p_affine_2_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_3_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_1_2_GREEN_UP) + (p_affine_0_0_GREEN_UP - p_affine_3_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_1_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_2_2_GREEN_UP) - (p_affine_0_0_GREEN_UP - p_affine_3_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_2_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_1_2_GREEN_UP)), 0.0018336830929379926*abs((p_affine_0_0_GREEN_UP - p_affine_1_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_2_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_3_2_GREEN_UP) - (p_affine_0_0_GREEN_UP - p_affine_1_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_3_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_2_2_GREEN_UP) - (p_affine_0_0_GREEN_UP - p_affine_2_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_1_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_3_2_GREEN_UP) + (p_affine_0_0_GREEN_UP - p_affine_2_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_3_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_1_2_GREEN_UP) + (p_affine_0_0_GREEN_UP - p_affine_3_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_1_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_2_2_GREEN_UP) - (p_affine_0_0_GREEN_UP - p_affine_3_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_2_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_1_2_GREEN_UP)), 0.00059211167385993745*abs((p_affine_0_0_GREEN_UP - p_affine_1_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_2_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_3_2_GREEN_UP) - (p_affine_0_0_GREEN_UP - p_affine_1_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_3_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_2_2_GREEN_UP) - (p_affine_0_0_GREEN_UP - p_affine_2_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_1_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_3_2_GREEN_UP) + (p_affine_0_0_GREEN_UP - p_affine_2_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_3_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_1_2_GREEN_UP) + (p_affine_0_0_GREEN_UP - p_affine_3_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_1_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_2_2_GREEN_UP) - (p_affine_0_0_GREEN_UP - p_affine_3_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_2_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_1_2_GREEN_UP)), 0.67498144007199112*abs((p_affine_0_0_GREEN_UP - p_affine_1_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_2_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_3_2_GREEN_UP) - (p_affine_0_0_GREEN_UP - p_affine_1_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_3_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_2_2_GREEN_UP) - (p_affine_0_0_GREEN_UP - p_affine_2_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_1_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_3_2_GREEN_UP) + (p_affine_0_0_GREEN_UP - p_affine_2_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_3_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_1_2_GREEN_UP) + (p_affine_0_0_GREEN_UP - p_affine_3_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_1_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_2_2_GREEN_UP) - (p_affine_0_0_GREEN_UP - p_affine_3_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_2_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_1_2_GREEN_UP)), 0.10160124737918669*abs((p_affine_0_0_GREEN_UP - p_affine_1_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_2_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_3_2_GREEN_UP) - (p_affine_0_0_GREEN_UP - p_affine_1_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_3_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_2_2_GREEN_UP) - (p_affine_0_0_GREEN_UP - p_affine_2_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_1_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_3_2_GREEN_UP) + (p_affine_0_0_GREEN_UP - p_affine_2_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_3_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_1_2_GREEN_UP) + (p_affine_0_0_GREEN_UP - p_affine_3_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_1_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_2_2_GREEN_UP) - (p_affine_0_0_GREEN_UP - p_affine_3_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_2_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_1_2_GREEN_UP)), 0.032807896240979378*abs((p_affine_0_0_GREEN_UP - p_affine_1_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_2_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_3_2_GREEN_UP) - (p_affine_0_0_GREEN_UP - p_affine_1_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_3_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_2_2_GREEN_UP) - (p_affine_0_0_GREEN_UP - p_affine_2_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_1_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_3_2_GREEN_UP) + (p_affine_0_0_GREEN_UP - p_affine_2_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_3_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_1_2_GREEN_UP) + (p_affine_0_0_GREEN_UP - p_affine_3_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_1_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_2_2_GREEN_UP) - (p_affine_0_0_GREEN_UP - p_affine_3_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_2_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_1_2_GREEN_UP)), 0.015293477503478755*abs((p_affine_0_0_GREEN_UP - p_affine_1_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_2_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_3_2_GREEN_UP) - (p_affine_0_0_GREEN_UP - p_affine_1_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_3_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_2_2_GREEN_UP) - (p_affine_0_0_GREEN_UP - p_affine_2_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_1_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_3_2_GREEN_UP) + (p_affine_0_0_GREEN_UP - p_affine_2_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_3_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_1_2_GREEN_UP) + (p_affine_0_0_GREEN_UP - p_affine_3_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_1_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_2_2_GREEN_UP) - (p_affine_0_0_GREEN_UP - p_affine_3_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_2_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_1_2_GREEN_UP)), 0.0049383923528547903*abs((p_affine_0_0_GREEN_UP - p_affine_1_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_2_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_3_2_GREEN_UP) - (p_affine_0_0_GREEN_UP - p_affine_1_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_3_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_2_2_GREEN_UP) - (p_affine_0_0_GREEN_UP - p_affine_2_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_1_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_3_2_GREEN_UP) + (p_affine_0_0_GREEN_UP - p_affine_2_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_3_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_1_2_GREEN_UP) + (p_affine_0_0_GREEN_UP - p_affine_3_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_1_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_2_2_GREEN_UP) - (p_affine_0_0_GREEN_UP - p_affine_3_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_2_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_1_2_GREEN_UP)), 0.0015946483738042757*abs((p_affine_0_0_GREEN_UP - p_affine_1_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_2_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_3_2_GREEN_UP) - (p_affine_0_0_GREEN_UP - p_affine_1_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_3_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_2_2_GREEN_UP) - (p_affine_0_0_GREEN_UP - p_affine_2_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_1_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_3_2_GREEN_UP) + (p_affine_0_0_GREEN_UP - p_affine_2_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_3_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_1_2_GREEN_UP) + (p_affine_0_0_GREEN_UP - p_affine_3_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_1_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_2_2_GREEN_UP) - (p_affine_0_0_GREEN_UP - p_affine_3_0_GREEN_UP)*(p_affine_0_1_GREEN_UP - p_affine_2_1_GREEN_UP)*(p_affine_0_2_GREEN_UP - p_affine_1_2_GREEN_UP))};
      
          for (int64_t ctr_2 = 0; ctr_2 < micro_edges_per_macro_edge; ctr_2 += 1)
          for (int64_t ctr_1 = 0; ctr_1 < -ctr_2 + micro_edges_per_macro_edge; ctr_1 += 1)
          {
             for (int64_t ctr_0 = 0; ctr_0 < (int64_t)((-ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1) / (4)) * (4); ctr_0 += 4)
             {
                __m256d q_acc_0_0 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_1 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_2 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_3 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                for (int64_t q = 0; q < 4; q += 1)
                {
                   const real_t q_tmp_0_0 = _data_phi_psi_det_jac_aff_0_GREEN_UP[10*q]*_data_q_w[q];
                   const real_t q_tmp_1_1 = _data_phi_psi_det_jac_aff_0_GREEN_UP[10*q + 4]*_data_q_w[q];
                   const real_t q_tmp_2_2 = _data_phi_psi_det_jac_aff_0_GREEN_UP[10*q + 7]*_data_q_w[q];
                   const real_t q_tmp_3_3 = _data_phi_psi_det_jac_aff_0_GREEN_UP[10*q + 9]*_data_q_w[q];
                   q_acc_0_0 = _mm256_add_pd(_mm256_set_pd(q_tmp_0_0,q_tmp_0_0,q_tmp_0_0,q_tmp_0_0),q_acc_0_0);
                   q_acc_1_1 = _mm256_add_pd(_mm256_set_pd(q_tmp_1_1,q_tmp_1_1,q_tmp_1_1,q_tmp_1_1),q_acc_1_1);
                   q_acc_2_2 = _mm256_add_pd(_mm256_set_pd(q_tmp_2_2,q_tmp_2_2,q_tmp_2_2,q_tmp_2_2),q_acc_2_2);
                   q_acc_3_3 = _mm256_add_pd(_mm256_set_pd(q_tmp_3_3,q_tmp_3_3,q_tmp_3_3,q_tmp_3_3),q_acc_3_3);
                }
                const __m256d elMatDiag_0 = q_acc_0_0;
                const __m256d elMatDiag_1 = q_acc_1_1;
                const __m256d elMatDiag_2 = q_acc_2_2;
                const __m256d elMatDiag_3 = q_acc_3_3;
                _mm256_storeu_pd(&_data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatDiag_0,_mm256_loadu_pd(& _data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_invDiag_[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatDiag_1,_mm256_loadu_pd(& _data_invDiag_[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatDiag_2,_mm256_loadu_pd(& _data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatDiag_3,_mm256_loadu_pd(& _data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1])));
             }
             for (int64_t ctr_0 = (int64_t)((-ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1) / (4)) * (4); ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1; ctr_0 += 1)
             {
                real_t q_acc_0_0 = 0.0;
                real_t q_acc_1_1 = 0.0;
                real_t q_acc_2_2 = 0.0;
                real_t q_acc_3_3 = 0.0;
                for (int64_t q = 0; q < 4; q += 1)
                {
                   const real_t q_tmp_0_0 = _data_phi_psi_det_jac_aff_0_GREEN_UP[10*q]*_data_q_w[q];
                   const real_t q_tmp_1_1 = _data_phi_psi_det_jac_aff_0_GREEN_UP[10*q + 4]*_data_q_w[q];
                   const real_t q_tmp_2_2 = _data_phi_psi_det_jac_aff_0_GREEN_UP[10*q + 7]*_data_q_w[q];
                   const real_t q_tmp_3_3 = _data_phi_psi_det_jac_aff_0_GREEN_UP[10*q + 9]*_data_q_w[q];
                   q_acc_0_0 = q_acc_0_0 + q_tmp_0_0;
                   q_acc_1_1 = q_acc_1_1 + q_tmp_1_1;
                   q_acc_2_2 = q_acc_2_2 + q_tmp_2_2;
                   q_acc_3_3 = q_acc_3_3 + q_tmp_3_3;
                }
                const real_t elMatDiag_0 = q_acc_0_0;
                const real_t elMatDiag_1 = q_acc_1_1;
                const real_t elMatDiag_2 = q_acc_2_2;
                const real_t elMatDiag_3 = q_acc_3_3;
                _data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatDiag_0 + _data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_invDiag_[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatDiag_1 + _data_invDiag_[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                _data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatDiag_2 + _data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                _data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatDiag_3 + _data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             }
          }
       }
       const real_t tmp_0_GREEN_DOWN = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t tmp_1_GREEN_DOWN = macro_vertex_coord_id_0comp0 + tmp_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t tmp_2_GREEN_DOWN = macro_vertex_coord_id_0comp1 + tmp_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t tmp_3_GREEN_DOWN = macro_vertex_coord_id_0comp2 + tmp_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const real_t tmp_4_GREEN_DOWN = tmp_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const real_t tmp_5_GREEN_DOWN = tmp_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const real_t tmp_6_GREEN_DOWN = tmp_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2);
       const real_t tmp_7_GREEN_DOWN = tmp_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0);
       const real_t tmp_8_GREEN_DOWN = tmp_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1);
       const real_t tmp_9_GREEN_DOWN = tmp_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2);
       const real_t p_affine_0_0_GREEN_DOWN = tmp_1_GREEN_DOWN;
       const real_t p_affine_0_1_GREEN_DOWN = tmp_2_GREEN_DOWN;
       const real_t p_affine_0_2_GREEN_DOWN = tmp_3_GREEN_DOWN;
       const real_t p_affine_1_0_GREEN_DOWN = tmp_1_GREEN_DOWN + tmp_4_GREEN_DOWN;
       const real_t p_affine_1_1_GREEN_DOWN = tmp_2_GREEN_DOWN + tmp_5_GREEN_DOWN;
       const real_t p_affine_1_2_GREEN_DOWN = tmp_3_GREEN_DOWN + tmp_6_GREEN_DOWN;
       const real_t p_affine_2_0_GREEN_DOWN = macro_vertex_coord_id_0comp0 + tmp_4_GREEN_DOWN + tmp_7_GREEN_DOWN;
       const real_t p_affine_2_1_GREEN_DOWN = macro_vertex_coord_id_0comp1 + tmp_5_GREEN_DOWN + tmp_8_GREEN_DOWN;
       const real_t p_affine_2_2_GREEN_DOWN = macro_vertex_coord_id_0comp2 + tmp_6_GREEN_DOWN + tmp_9_GREEN_DOWN;
       const real_t p_affine_3_0_GREEN_DOWN = tmp_1_GREEN_DOWN + tmp_7_GREEN_DOWN;
       const real_t p_affine_3_1_GREEN_DOWN = tmp_2_GREEN_DOWN + tmp_8_GREEN_DOWN;
       const real_t p_affine_3_2_GREEN_DOWN = tmp_3_GREEN_DOWN + tmp_9_GREEN_DOWN;
       {
          /* CellType.GREEN_DOWN */
          const real_t _data_phi_psi_det_jac_aff_0_GREEN_DOWN [] = {0.20046443821120821*abs((p_affine_0_0_GREEN_DOWN - p_affine_1_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_2_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_3_2_GREEN_DOWN) - (p_affine_0_0_GREEN_DOWN - p_affine_1_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_3_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_2_2_GREEN_DOWN) - (p_affine_0_0_GREEN_DOWN - p_affine_2_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_1_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_3_2_GREEN_DOWN) + (p_affine_0_0_GREEN_DOWN - p_affine_2_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_3_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_1_2_GREEN_DOWN) + (p_affine_0_0_GREEN_DOWN - p_affine_3_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_1_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_2_2_GREEN_DOWN) - (p_affine_0_0_GREEN_DOWN - p_affine_3_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_2_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_1_2_GREEN_DOWN)), 0.080605154129423817*abs((p_affine_0_0_GREEN_DOWN - p_affine_1_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_2_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_3_2_GREEN_DOWN) - (p_affine_0_0_GREEN_DOWN - p_affine_1_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_3_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_2_2_GREEN_DOWN) - (p_affine_0_0_GREEN_DOWN - p_affine_2_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_1_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_3_2_GREEN_DOWN) + (p_affine_0_0_GREEN_DOWN - p_affine_2_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_3_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_1_2_GREEN_DOWN) + (p_affine_0_0_GREEN_DOWN - p_affine_3_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_1_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_2_2_GREEN_DOWN) - (p_affine_0_0_GREEN_DOWN - p_affine_3_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_2_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_1_2_GREEN_DOWN)), 0.16356320182856121*abs((p_affine_0_0_GREEN_DOWN - p_affine_1_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_2_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_3_2_GREEN_DOWN) - (p_affine_0_0_GREEN_DOWN - p_affine_1_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_3_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_2_2_GREEN_DOWN) - (p_affine_0_0_GREEN_DOWN - p_affine_2_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_1_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_3_2_GREEN_DOWN) + (p_affine_0_0_GREEN_DOWN - p_affine_2_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_3_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_1_2_GREEN_DOWN) + (p_affine_0_0_GREEN_DOWN - p_affine_3_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_1_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_2_2_GREEN_DOWN) - (p_affine_0_0_GREEN_DOWN - p_affine_3_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_2_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_1_2_GREEN_DOWN)), 0.0030997579321792282*abs((p_affine_0_0_GREEN_DOWN - p_affine_1_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_2_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_3_2_GREEN_DOWN) - (p_affine_0_0_GREEN_DOWN - p_affine_1_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_3_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_2_2_GREEN_DOWN) - (p_affine_0_0_GREEN_DOWN - p_affine_2_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_1_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_3_2_GREEN_DOWN) + (p_affine_0_0_GREEN_DOWN - p_affine_2_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_3_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_1_2_GREEN_DOWN) + (p_affine_0_0_GREEN_DOWN - p_affine_3_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_1_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_2_2_GREEN_DOWN) - (p_affine_0_0_GREEN_DOWN - p_affine_3_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_2_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_1_2_GREEN_DOWN)), 0.032410690545436126*abs((p_affine_0_0_GREEN_DOWN - p_affine_1_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_2_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_3_2_GREEN_DOWN) - (p_affine_0_0_GREEN_DOWN - p_affine_1_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_3_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_2_2_GREEN_DOWN) - (p_affine_0_0_GREEN_DOWN - p_affine_2_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_1_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_3_2_GREEN_DOWN) + (p_affine_0_0_GREEN_DOWN - p_affine_2_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_3_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_1_2_GREEN_DOWN) + (p_affine_0_0_GREEN_DOWN - p_affine_3_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_1_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_2_2_GREEN_DOWN) - (p_affine_0_0_GREEN_DOWN - p_affine_3_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_2_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_1_2_GREEN_DOWN)), 0.065767460857085305*abs((p_affine_0_0_GREEN_DOWN - p_affine_1_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_2_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_3_2_GREEN_DOWN) - (p_affine_0_0_GREEN_DOWN - p_affine_1_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_3_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_2_2_GREEN_DOWN) - (p_affine_0_0_GREEN_DOWN - p_affine_2_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_1_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_3_2_GREEN_DOWN) + (p_affine_0_0_GREEN_DOWN - p_affine_2_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_3_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_1_2_GREEN_DOWN) + (p_affine_0_0_GREEN_DOWN - p_affine_3_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_1_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_2_2_GREEN_DOWN) - (p_affine_0_0_GREEN_DOWN - p_affine_3_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_2_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_1_2_GREEN_DOWN)), 0.0012463879784202093*abs((p_affine_0_0_GREEN_DOWN - p_affine_1_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_2_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_3_2_GREEN_DOWN) - (p_affine_0_0_GREEN_DOWN - p_affine_1_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_3_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_2_2_GREEN_DOWN) - (p_affine_0_0_GREEN_DOWN - p_affine_2_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_1_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_3_2_GREEN_DOWN) + (p_affine_0_0_GREEN_DOWN - p_affine_2_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_3_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_1_2_GREEN_DOWN) + (p_affine_0_0_GREEN_DOWN - p_affine_3_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_1_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_2_2_GREEN_DOWN) - (p_affine_0_0_GREEN_DOWN - p_affine_3_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_2_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_1_2_GREEN_DOWN)), 0.13345469765676804*abs((p_affine_0_0_GREEN_DOWN - p_affine_1_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_2_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_3_2_GREEN_DOWN) - (p_affine_0_0_GREEN_DOWN - p_affine_1_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_3_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_2_2_GREEN_DOWN) - (p_affine_0_0_GREEN_DOWN - p_affine_2_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_1_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_3_2_GREEN_DOWN) + (p_affine_0_0_GREEN_DOWN - p_affine_2_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_3_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_1_2_GREEN_DOWN) + (p_affine_0_0_GREEN_DOWN - p_affine_3_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_1_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_2_2_GREEN_DOWN) - (p_affine_0_0_GREEN_DOWN - p_affine_3_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_2_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_1_2_GREEN_DOWN)), 0.002529158472220073*abs((p_affine_0_0_GREEN_DOWN - p_affine_1_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_2_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_3_2_GREEN_DOWN) - (p_affine_0_0_GREEN_DOWN - p_affine_1_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_3_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_2_2_GREEN_DOWN) - (p_affine_0_0_GREEN_DOWN - p_affine_2_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_1_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_3_2_GREEN_DOWN) + (p_affine_0_0_GREEN_DOWN - p_affine_2_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_3_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_1_2_GREEN_DOWN) + (p_affine_0_0_GREEN_DOWN - p_affine_3_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_1_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_2_2_GREEN_DOWN) - (p_affine_0_0_GREEN_DOWN - p_affine_3_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_2_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_1_2_GREEN_DOWN)), 4.793119080794062e-5*abs((p_affine_0_0_GREEN_DOWN - p_affine_1_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_2_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_3_2_GREEN_DOWN) - (p_affine_0_0_GREEN_DOWN - p_affine_1_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_3_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_2_2_GREEN_DOWN) - (p_affine_0_0_GREEN_DOWN - p_affine_2_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_1_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_3_2_GREEN_DOWN) + (p_affine_0_0_GREEN_DOWN - p_affine_2_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_3_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_1_2_GREEN_DOWN) + (p_affine_0_0_GREEN_DOWN - p_affine_3_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_1_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_2_2_GREEN_DOWN) - (p_affine_0_0_GREEN_DOWN - p_affine_3_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_2_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_1_2_GREEN_DOWN)), 2.3424983832091605e-5*abs((p_affine_0_0_GREEN_DOWN - p_affine_1_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_2_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_3_2_GREEN_DOWN) - (p_affine_0_0_GREEN_DOWN - p_affine_1_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_3_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_2_2_GREEN_DOWN) - (p_affine_0_0_GREEN_DOWN - p_affine_2_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_1_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_3_2_GREEN_DOWN) + (p_affine_0_0_GREEN_DOWN - p_affine_2_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_3_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_1_2_GREEN_DOWN) + (p_affine_0_0_GREEN_DOWN - p_affine_3_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_1_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_2_2_GREEN_DOWN) - (p_affine_0_0_GREEN_DOWN - p_affine_3_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_2_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_1_2_GREEN_DOWN)), 0.00075470637742922845*abs((p_affine_0_0_GREEN_DOWN - p_affine_1_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_2_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_3_2_GREEN_DOWN) - (p_affine_0_0_GREEN_DOWN - p_affine_1_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_3_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_2_2_GREEN_DOWN) - (p_affine_0_0_GREEN_DOWN - p_affine_2_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_1_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_3_2_GREEN_DOWN) + (p_affine_0_0_GREEN_DOWN - p_affine_2_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_3_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_1_2_GREEN_DOWN) + (p_affine_0_0_GREEN_DOWN - p_affine_3_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_1_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_2_2_GREEN_DOWN) - (p_affine_0_0_GREEN_DOWN - p_affine_3_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_2_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_1_2_GREEN_DOWN)), 0.0022140849621758063*abs((p_affine_0_0_GREEN_DOWN - p_affine_1_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_2_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_3_2_GREEN_DOWN) - (p_affine_0_0_GREEN_DOWN - p_affine_1_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_3_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_2_2_GREEN_DOWN) - (p_affine_0_0_GREEN_DOWN - p_affine_2_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_1_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_3_2_GREEN_DOWN) + (p_affine_0_0_GREEN_DOWN - p_affine_2_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_3_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_1_2_GREEN_DOWN) + (p_affine_0_0_GREEN_DOWN - p_affine_3_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_1_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_2_2_GREEN_DOWN) - (p_affine_0_0_GREEN_DOWN - p_affine_3_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_2_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_1_2_GREEN_DOWN)), 0.0018477200224347493*abs((p_affine_0_0_GREEN_DOWN - p_affine_1_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_2_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_3_2_GREEN_DOWN) - (p_affine_0_0_GREEN_DOWN - p_affine_1_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_3_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_2_2_GREEN_DOWN) - (p_affine_0_0_GREEN_DOWN - p_affine_2_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_1_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_3_2_GREEN_DOWN) + (p_affine_0_0_GREEN_DOWN - p_affine_2_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_3_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_1_2_GREEN_DOWN) + (p_affine_0_0_GREEN_DOWN - p_affine_3_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_1_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_2_2_GREEN_DOWN) - (p_affine_0_0_GREEN_DOWN - p_affine_3_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_2_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_1_2_GREEN_DOWN)), 0.024315138068613611*abs((p_affine_0_0_GREEN_DOWN - p_affine_1_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_2_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_3_2_GREEN_DOWN) - (p_affine_0_0_GREEN_DOWN - p_affine_1_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_3_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_2_2_GREEN_DOWN) - (p_affine_0_0_GREEN_DOWN - p_affine_2_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_1_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_3_2_GREEN_DOWN) + (p_affine_0_0_GREEN_DOWN - p_affine_2_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_3_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_1_2_GREEN_DOWN) + (p_affine_0_0_GREEN_DOWN - p_affine_3_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_1_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_2_2_GREEN_DOWN) - (p_affine_0_0_GREEN_DOWN - p_affine_3_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_2_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_1_2_GREEN_DOWN)), 0.071333412782766975*abs((p_affine_0_0_GREEN_DOWN - p_affine_1_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_2_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_3_2_GREEN_DOWN) - (p_affine_0_0_GREEN_DOWN - p_affine_1_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_3_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_2_2_GREEN_DOWN) - (p_affine_0_0_GREEN_DOWN - p_affine_2_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_1_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_3_2_GREEN_DOWN) + (p_affine_0_0_GREEN_DOWN - p_affine_2_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_3_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_1_2_GREEN_DOWN) + (p_affine_0_0_GREEN_DOWN - p_affine_3_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_1_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_2_2_GREEN_DOWN) - (p_affine_0_0_GREEN_DOWN - p_affine_3_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_2_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_1_2_GREEN_DOWN)), 0.059529863270376029*abs((p_affine_0_0_GREEN_DOWN - p_affine_1_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_2_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_3_2_GREEN_DOWN) - (p_affine_0_0_GREEN_DOWN - p_affine_1_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_3_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_2_2_GREEN_DOWN) - (p_affine_0_0_GREEN_DOWN - p_affine_2_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_1_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_3_2_GREEN_DOWN) + (p_affine_0_0_GREEN_DOWN - p_affine_2_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_3_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_1_2_GREEN_DOWN) + (p_affine_0_0_GREEN_DOWN - p_affine_3_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_1_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_2_2_GREEN_DOWN) - (p_affine_0_0_GREEN_DOWN - p_affine_3_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_2_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_1_2_GREEN_DOWN)), 0.20927110365887197*abs((p_affine_0_0_GREEN_DOWN - p_affine_1_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_2_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_3_2_GREEN_DOWN) - (p_affine_0_0_GREEN_DOWN - p_affine_1_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_3_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_2_2_GREEN_DOWN) - (p_affine_0_0_GREEN_DOWN - p_affine_2_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_1_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_3_2_GREEN_DOWN) + (p_affine_0_0_GREEN_DOWN - p_affine_2_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_3_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_1_2_GREEN_DOWN) + (p_affine_0_0_GREEN_DOWN - p_affine_3_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_1_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_2_2_GREEN_DOWN) - (p_affine_0_0_GREEN_DOWN - p_affine_3_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_2_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_1_2_GREEN_DOWN)), 0.17464298568178085*abs((p_affine_0_0_GREEN_DOWN - p_affine_1_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_2_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_3_2_GREEN_DOWN) - (p_affine_0_0_GREEN_DOWN - p_affine_1_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_3_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_2_2_GREEN_DOWN) - (p_affine_0_0_GREEN_DOWN - p_affine_2_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_1_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_3_2_GREEN_DOWN) + (p_affine_0_0_GREEN_DOWN - p_affine_2_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_3_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_1_2_GREEN_DOWN) + (p_affine_0_0_GREEN_DOWN - p_affine_3_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_1_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_2_2_GREEN_DOWN) - (p_affine_0_0_GREEN_DOWN - p_affine_3_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_2_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_1_2_GREEN_DOWN)), 0.14574478709475508*abs((p_affine_0_0_GREEN_DOWN - p_affine_1_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_2_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_3_2_GREEN_DOWN) - (p_affine_0_0_GREEN_DOWN - p_affine_1_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_3_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_2_2_GREEN_DOWN) - (p_affine_0_0_GREEN_DOWN - p_affine_2_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_1_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_3_2_GREEN_DOWN) + (p_affine_0_0_GREEN_DOWN - p_affine_2_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_3_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_1_2_GREEN_DOWN) + (p_affine_0_0_GREEN_DOWN - p_affine_3_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_1_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_2_2_GREEN_DOWN) - (p_affine_0_0_GREEN_DOWN - p_affine_3_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_2_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_1_2_GREEN_DOWN)), 0.12450054579698165*abs((p_affine_0_0_GREEN_DOWN - p_affine_1_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_2_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_3_2_GREEN_DOWN) - (p_affine_0_0_GREEN_DOWN - p_affine_1_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_3_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_2_2_GREEN_DOWN) - (p_affine_0_0_GREEN_DOWN - p_affine_2_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_1_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_3_2_GREEN_DOWN) + (p_affine_0_0_GREEN_DOWN - p_affine_2_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_3_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_1_2_GREEN_DOWN) + (p_affine_0_0_GREEN_DOWN - p_affine_3_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_1_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_2_2_GREEN_DOWN) - (p_affine_0_0_GREEN_DOWN - p_affine_3_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_2_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_1_2_GREEN_DOWN)), 0.076241779079863126*abs((p_affine_0_0_GREEN_DOWN - p_affine_1_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_2_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_3_2_GREEN_DOWN) - (p_affine_0_0_GREEN_DOWN - p_affine_1_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_3_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_2_2_GREEN_DOWN) - (p_affine_0_0_GREEN_DOWN - p_affine_2_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_1_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_3_2_GREEN_DOWN) + (p_affine_0_0_GREEN_DOWN - p_affine_2_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_3_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_1_2_GREEN_DOWN) + (p_affine_0_0_GREEN_DOWN - p_affine_3_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_1_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_2_2_GREEN_DOWN) - (p_affine_0_0_GREEN_DOWN - p_affine_3_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_2_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_1_2_GREEN_DOWN)), 0.00013249910677232994*abs((p_affine_0_0_GREEN_DOWN - p_affine_1_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_2_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_3_2_GREEN_DOWN) - (p_affine_0_0_GREEN_DOWN - p_affine_1_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_3_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_2_2_GREEN_DOWN) - (p_affine_0_0_GREEN_DOWN - p_affine_2_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_1_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_3_2_GREEN_DOWN) + (p_affine_0_0_GREEN_DOWN - p_affine_2_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_3_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_1_2_GREEN_DOWN) + (p_affine_0_0_GREEN_DOWN - p_affine_3_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_1_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_2_2_GREEN_DOWN) - (p_affine_0_0_GREEN_DOWN - p_affine_3_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_2_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_1_2_GREEN_DOWN)), 0.15197152472496969*abs((p_affine_0_0_GREEN_DOWN - p_affine_1_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_2_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_3_2_GREEN_DOWN) - (p_affine_0_0_GREEN_DOWN - p_affine_1_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_3_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_2_2_GREEN_DOWN) - (p_affine_0_0_GREEN_DOWN - p_affine_2_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_1_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_3_2_GREEN_DOWN) + (p_affine_0_0_GREEN_DOWN - p_affine_2_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_3_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_1_2_GREEN_DOWN) + (p_affine_0_0_GREEN_DOWN - p_affine_3_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_1_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_2_2_GREEN_DOWN) - (p_affine_0_0_GREEN_DOWN - p_affine_3_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_2_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_1_2_GREEN_DOWN)), 0.046689023249274604*abs((p_affine_0_0_GREEN_DOWN - p_affine_1_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_2_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_3_2_GREEN_DOWN) - (p_affine_0_0_GREEN_DOWN - p_affine_1_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_3_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_2_2_GREEN_DOWN) - (p_affine_0_0_GREEN_DOWN - p_affine_2_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_1_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_3_2_GREEN_DOWN) + (p_affine_0_0_GREEN_DOWN - p_affine_2_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_3_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_1_2_GREEN_DOWN) + (p_affine_0_0_GREEN_DOWN - p_affine_3_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_1_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_2_2_GREEN_DOWN) - (p_affine_0_0_GREEN_DOWN - p_affine_3_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_2_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_1_2_GREEN_DOWN)), 8.1139946513070487e-5*abs((p_affine_0_0_GREEN_DOWN - p_affine_1_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_2_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_3_2_GREEN_DOWN) - (p_affine_0_0_GREEN_DOWN - p_affine_1_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_3_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_2_2_GREEN_DOWN) - (p_affine_0_0_GREEN_DOWN - p_affine_2_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_1_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_3_2_GREEN_DOWN) + (p_affine_0_0_GREEN_DOWN - p_affine_2_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_3_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_1_2_GREEN_DOWN) + (p_affine_0_0_GREEN_DOWN - p_affine_3_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_1_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_2_2_GREEN_DOWN) - (p_affine_0_0_GREEN_DOWN - p_affine_3_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_2_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_1_2_GREEN_DOWN)), 0.093064486909197122*abs((p_affine_0_0_GREEN_DOWN - p_affine_1_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_2_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_3_2_GREEN_DOWN) - (p_affine_0_0_GREEN_DOWN - p_affine_1_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_3_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_2_2_GREEN_DOWN) - (p_affine_0_0_GREEN_DOWN - p_affine_2_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_1_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_3_2_GREEN_DOWN) + (p_affine_0_0_GREEN_DOWN - p_affine_2_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_3_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_1_2_GREEN_DOWN) + (p_affine_0_0_GREEN_DOWN - p_affine_3_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_1_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_2_2_GREEN_DOWN) - (p_affine_0_0_GREEN_DOWN - p_affine_3_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_2_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_1_2_GREEN_DOWN)), 1.4101153680155925e-7*abs((p_affine_0_0_GREEN_DOWN - p_affine_1_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_2_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_3_2_GREEN_DOWN) - (p_affine_0_0_GREEN_DOWN - p_affine_1_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_3_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_2_2_GREEN_DOWN) - (p_affine_0_0_GREEN_DOWN - p_affine_2_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_1_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_3_2_GREEN_DOWN) + (p_affine_0_0_GREEN_DOWN - p_affine_2_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_3_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_1_2_GREEN_DOWN) + (p_affine_0_0_GREEN_DOWN - p_affine_3_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_1_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_2_2_GREEN_DOWN) - (p_affine_0_0_GREEN_DOWN - p_affine_3_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_2_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_1_2_GREEN_DOWN)), 0.00016173496390708763*abs((p_affine_0_0_GREEN_DOWN - p_affine_1_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_2_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_3_2_GREEN_DOWN) - (p_affine_0_0_GREEN_DOWN - p_affine_1_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_3_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_2_2_GREEN_DOWN) - (p_affine_0_0_GREEN_DOWN - p_affine_2_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_1_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_3_2_GREEN_DOWN) + (p_affine_0_0_GREEN_DOWN - p_affine_2_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_3_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_1_2_GREEN_DOWN) + (p_affine_0_0_GREEN_DOWN - p_affine_3_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_1_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_2_2_GREEN_DOWN) - (p_affine_0_0_GREEN_DOWN - p_affine_3_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_2_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_1_2_GREEN_DOWN)), 0.18550396047976195*abs((p_affine_0_0_GREEN_DOWN - p_affine_1_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_2_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_3_2_GREEN_DOWN) - (p_affine_0_0_GREEN_DOWN - p_affine_1_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_3_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_2_2_GREEN_DOWN) - (p_affine_0_0_GREEN_DOWN - p_affine_2_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_1_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_3_2_GREEN_DOWN) + (p_affine_0_0_GREEN_DOWN - p_affine_2_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_3_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_1_2_GREEN_DOWN) + (p_affine_0_0_GREEN_DOWN - p_affine_3_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_1_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_2_2_GREEN_DOWN) - (p_affine_0_0_GREEN_DOWN - p_affine_3_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_2_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_1_2_GREEN_DOWN)), 0.00021985802016328927*abs((p_affine_0_0_GREEN_DOWN - p_affine_1_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_2_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_3_2_GREEN_DOWN) - (p_affine_0_0_GREEN_DOWN - p_affine_1_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_3_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_2_2_GREEN_DOWN) - (p_affine_0_0_GREEN_DOWN - p_affine_2_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_1_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_3_2_GREEN_DOWN) + (p_affine_0_0_GREEN_DOWN - p_affine_2_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_3_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_1_2_GREEN_DOWN) + (p_affine_0_0_GREEN_DOWN - p_affine_3_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_1_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_2_2_GREEN_DOWN) - (p_affine_0_0_GREEN_DOWN - p_affine_3_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_2_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_1_2_GREEN_DOWN)), 0.012181957275462504*abs((p_affine_0_0_GREEN_DOWN - p_affine_1_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_2_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_3_2_GREEN_DOWN) - (p_affine_0_0_GREEN_DOWN - p_affine_1_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_3_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_2_2_GREEN_DOWN) - (p_affine_0_0_GREEN_DOWN - p_affine_2_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_1_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_3_2_GREEN_DOWN) + (p_affine_0_0_GREEN_DOWN - p_affine_2_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_3_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_1_2_GREEN_DOWN) + (p_affine_0_0_GREEN_DOWN - p_affine_3_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_1_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_2_2_GREEN_DOWN) - (p_affine_0_0_GREEN_DOWN - p_affine_3_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_2_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_1_2_GREEN_DOWN)), 0.0018336830929379926*abs((p_affine_0_0_GREEN_DOWN - p_affine_1_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_2_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_3_2_GREEN_DOWN) - (p_affine_0_0_GREEN_DOWN - p_affine_1_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_3_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_2_2_GREEN_DOWN) - (p_affine_0_0_GREEN_DOWN - p_affine_2_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_1_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_3_2_GREEN_DOWN) + (p_affine_0_0_GREEN_DOWN - p_affine_2_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_3_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_1_2_GREEN_DOWN) + (p_affine_0_0_GREEN_DOWN - p_affine_3_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_1_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_2_2_GREEN_DOWN) - (p_affine_0_0_GREEN_DOWN - p_affine_3_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_2_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_1_2_GREEN_DOWN)), 0.00059211167385993745*abs((p_affine_0_0_GREEN_DOWN - p_affine_1_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_2_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_3_2_GREEN_DOWN) - (p_affine_0_0_GREEN_DOWN - p_affine_1_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_3_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_2_2_GREEN_DOWN) - (p_affine_0_0_GREEN_DOWN - p_affine_2_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_1_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_3_2_GREEN_DOWN) + (p_affine_0_0_GREEN_DOWN - p_affine_2_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_3_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_1_2_GREEN_DOWN) + (p_affine_0_0_GREEN_DOWN - p_affine_3_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_1_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_2_2_GREEN_DOWN) - (p_affine_0_0_GREEN_DOWN - p_affine_3_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_2_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_1_2_GREEN_DOWN)), 0.67498144007199112*abs((p_affine_0_0_GREEN_DOWN - p_affine_1_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_2_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_3_2_GREEN_DOWN) - (p_affine_0_0_GREEN_DOWN - p_affine_1_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_3_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_2_2_GREEN_DOWN) - (p_affine_0_0_GREEN_DOWN - p_affine_2_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_1_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_3_2_GREEN_DOWN) + (p_affine_0_0_GREEN_DOWN - p_affine_2_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_3_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_1_2_GREEN_DOWN) + (p_affine_0_0_GREEN_DOWN - p_affine_3_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_1_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_2_2_GREEN_DOWN) - (p_affine_0_0_GREEN_DOWN - p_affine_3_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_2_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_1_2_GREEN_DOWN)), 0.10160124737918669*abs((p_affine_0_0_GREEN_DOWN - p_affine_1_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_2_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_3_2_GREEN_DOWN) - (p_affine_0_0_GREEN_DOWN - p_affine_1_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_3_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_2_2_GREEN_DOWN) - (p_affine_0_0_GREEN_DOWN - p_affine_2_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_1_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_3_2_GREEN_DOWN) + (p_affine_0_0_GREEN_DOWN - p_affine_2_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_3_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_1_2_GREEN_DOWN) + (p_affine_0_0_GREEN_DOWN - p_affine_3_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_1_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_2_2_GREEN_DOWN) - (p_affine_0_0_GREEN_DOWN - p_affine_3_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_2_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_1_2_GREEN_DOWN)), 0.032807896240979378*abs((p_affine_0_0_GREEN_DOWN - p_affine_1_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_2_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_3_2_GREEN_DOWN) - (p_affine_0_0_GREEN_DOWN - p_affine_1_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_3_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_2_2_GREEN_DOWN) - (p_affine_0_0_GREEN_DOWN - p_affine_2_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_1_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_3_2_GREEN_DOWN) + (p_affine_0_0_GREEN_DOWN - p_affine_2_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_3_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_1_2_GREEN_DOWN) + (p_affine_0_0_GREEN_DOWN - p_affine_3_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_1_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_2_2_GREEN_DOWN) - (p_affine_0_0_GREEN_DOWN - p_affine_3_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_2_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_1_2_GREEN_DOWN)), 0.015293477503478755*abs((p_affine_0_0_GREEN_DOWN - p_affine_1_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_2_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_3_2_GREEN_DOWN) - (p_affine_0_0_GREEN_DOWN - p_affine_1_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_3_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_2_2_GREEN_DOWN) - (p_affine_0_0_GREEN_DOWN - p_affine_2_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_1_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_3_2_GREEN_DOWN) + (p_affine_0_0_GREEN_DOWN - p_affine_2_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_3_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_1_2_GREEN_DOWN) + (p_affine_0_0_GREEN_DOWN - p_affine_3_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_1_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_2_2_GREEN_DOWN) - (p_affine_0_0_GREEN_DOWN - p_affine_3_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_2_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_1_2_GREEN_DOWN)), 0.0049383923528547903*abs((p_affine_0_0_GREEN_DOWN - p_affine_1_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_2_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_3_2_GREEN_DOWN) - (p_affine_0_0_GREEN_DOWN - p_affine_1_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_3_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_2_2_GREEN_DOWN) - (p_affine_0_0_GREEN_DOWN - p_affine_2_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_1_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_3_2_GREEN_DOWN) + (p_affine_0_0_GREEN_DOWN - p_affine_2_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_3_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_1_2_GREEN_DOWN) + (p_affine_0_0_GREEN_DOWN - p_affine_3_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_1_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_2_2_GREEN_DOWN) - (p_affine_0_0_GREEN_DOWN - p_affine_3_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_2_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_1_2_GREEN_DOWN)), 0.0015946483738042757*abs((p_affine_0_0_GREEN_DOWN - p_affine_1_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_2_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_3_2_GREEN_DOWN) - (p_affine_0_0_GREEN_DOWN - p_affine_1_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_3_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_2_2_GREEN_DOWN) - (p_affine_0_0_GREEN_DOWN - p_affine_2_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_1_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_3_2_GREEN_DOWN) + (p_affine_0_0_GREEN_DOWN - p_affine_2_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_3_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_1_2_GREEN_DOWN) + (p_affine_0_0_GREEN_DOWN - p_affine_3_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_1_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_2_2_GREEN_DOWN) - (p_affine_0_0_GREEN_DOWN - p_affine_3_0_GREEN_DOWN)*(p_affine_0_1_GREEN_DOWN - p_affine_2_1_GREEN_DOWN)*(p_affine_0_2_GREEN_DOWN - p_affine_1_2_GREEN_DOWN))};
      
          for (int64_t ctr_2 = 0; ctr_2 < micro_edges_per_macro_edge; ctr_2 += 1)
          for (int64_t ctr_1 = 0; ctr_1 < -ctr_2 + micro_edges_per_macro_edge; ctr_1 += 1)
          {
             for (int64_t ctr_0 = 0; ctr_0 < (int64_t)((-ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1) / (4)) * (4); ctr_0 += 4)
             {
                __m256d q_acc_0_0 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_1 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_2 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_3 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                for (int64_t q = 0; q < 4; q += 1)
                {
                   const real_t q_tmp_0_0 = _data_phi_psi_det_jac_aff_0_GREEN_DOWN[10*q]*_data_q_w[q];
                   const real_t q_tmp_1_1 = _data_phi_psi_det_jac_aff_0_GREEN_DOWN[10*q + 4]*_data_q_w[q];
                   const real_t q_tmp_2_2 = _data_phi_psi_det_jac_aff_0_GREEN_DOWN[10*q + 7]*_data_q_w[q];
                   const real_t q_tmp_3_3 = _data_phi_psi_det_jac_aff_0_GREEN_DOWN[10*q + 9]*_data_q_w[q];
                   q_acc_0_0 = _mm256_add_pd(_mm256_set_pd(q_tmp_0_0,q_tmp_0_0,q_tmp_0_0,q_tmp_0_0),q_acc_0_0);
                   q_acc_1_1 = _mm256_add_pd(_mm256_set_pd(q_tmp_1_1,q_tmp_1_1,q_tmp_1_1,q_tmp_1_1),q_acc_1_1);
                   q_acc_2_2 = _mm256_add_pd(_mm256_set_pd(q_tmp_2_2,q_tmp_2_2,q_tmp_2_2,q_tmp_2_2),q_acc_2_2);
                   q_acc_3_3 = _mm256_add_pd(_mm256_set_pd(q_tmp_3_3,q_tmp_3_3,q_tmp_3_3,q_tmp_3_3),q_acc_3_3);
                }
                const __m256d elMatDiag_0 = q_acc_0_0;
                const __m256d elMatDiag_1 = q_acc_1_1;
                const __m256d elMatDiag_2 = q_acc_2_2;
                const __m256d elMatDiag_3 = q_acc_3_3;
                _mm256_storeu_pd(&_data_invDiag_[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatDiag_0,_mm256_loadu_pd(& _data_invDiag_[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag_[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatDiag_1,_mm256_loadu_pd(& _data_invDiag_[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatDiag_2,_mm256_loadu_pd(& _data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_invDiag_[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatDiag_3,_mm256_loadu_pd(& _data_invDiag_[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))])));
             }
             for (int64_t ctr_0 = (int64_t)((-ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1) / (4)) * (4); ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1; ctr_0 += 1)
             {
                real_t q_acc_0_0 = 0.0;
                real_t q_acc_1_1 = 0.0;
                real_t q_acc_2_2 = 0.0;
                real_t q_acc_3_3 = 0.0;
                for (int64_t q = 0; q < 4; q += 1)
                {
                   const real_t q_tmp_0_0 = _data_phi_psi_det_jac_aff_0_GREEN_DOWN[10*q]*_data_q_w[q];
                   const real_t q_tmp_1_1 = _data_phi_psi_det_jac_aff_0_GREEN_DOWN[10*q + 4]*_data_q_w[q];
                   const real_t q_tmp_2_2 = _data_phi_psi_det_jac_aff_0_GREEN_DOWN[10*q + 7]*_data_q_w[q];
                   const real_t q_tmp_3_3 = _data_phi_psi_det_jac_aff_0_GREEN_DOWN[10*q + 9]*_data_q_w[q];
                   q_acc_0_0 = q_acc_0_0 + q_tmp_0_0;
                   q_acc_1_1 = q_acc_1_1 + q_tmp_1_1;
                   q_acc_2_2 = q_acc_2_2 + q_tmp_2_2;
                   q_acc_3_3 = q_acc_3_3 + q_tmp_3_3;
                }
                const real_t elMatDiag_0 = q_acc_0_0;
                const real_t elMatDiag_1 = q_acc_1_1;
                const real_t elMatDiag_2 = q_acc_2_2;
                const real_t elMatDiag_3 = q_acc_3_3;
                _data_invDiag_[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatDiag_0 + _data_invDiag_[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                _data_invDiag_[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatDiag_1 + _data_invDiag_[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatDiag_2 + _data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_invDiag_[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatDiag_3 + _data_invDiag_[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             }
          }
       }
    }
}
} // namespace operatorgeneration

} // namespace hyteg
